<?xml version="1.0" encoding="UTF-8"?>
<!--

This file is distributed as part of EHF Post-Award G3.

Release: 2022-06-15
Timestamp: 2024-04-25 10:02z

Repository for releases and issues:
  https://github.com/anskaffelser/ehf-postaward-g3
-->
<schema xmlns="http://purl.oclc.org/dsdl/schematron" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xi="http://www.w3.org/2001/XInclude" xmlns:u="utils" schemaVersion="iso" queryBinding="xslt2">

	<title>EHF Punch Out 3.0</title>

	<ns prefix="cbc" uri="urn:oasis:names:specification:ubl:schema:xsd:CommonBasicComponents-2"/>
	<ns prefix="cac" uri="urn:oasis:names:specification:ubl:schema:xsd:CommonAggregateComponents-2"/>
	<ns prefix="ubl" uri="urn:oasis:names:specification:ubl:schema:xsd:Catalogue-2"/>
	<ns prefix="xs" uri="http://www.w3.org/2001/XMLSchema"/>
	<ns prefix="u" uri="utils"/>

	

	<function xmlns="http://www.w3.org/1999/XSL/Transform" name="u:abn" as="xs:boolean">
    <param name="val"/>
    <sequence select="( ((string-to-codepoints(substring($val,1,1)) - 49) * 10) + ((string-to-codepoints(substring($val,2,1)) - 48) * 1) + ((string-to-codepoints(substring($val,3,1)) - 48) * 3) + ((string-to-codepoints(substring($val,4,1)) - 48) * 5) + ((string-to-codepoints(substring($val,5,1)) - 48) * 7) + ((string-to-codepoints(substring($val,6,1)) - 48) * 9) + ((string-to-codepoints(substring($val,7,1)) - 48) * 11) + ((string-to-codepoints(substring($val,8,1)) - 48) * 13) + ((string-to-codepoints(substring($val,9,1)) - 48) * 15) + ((string-to-codepoints(substring($val,10,1)) - 48) * 17) + ((string-to-codepoints(substring($val,11,1)) - 48) * 19)) mod 89 = 0 "/>
</function>
	<function xmlns="http://www.w3.org/1999/XSL/Transform" name="u:addPIVA" as="xs:integer">
    <param name="arg" as="xs:string"/>
    <param name="pari" as="xs:integer"/>
    <variable name="tappo" select="if (not($arg castable as xs:integer)) then 0 else 1"/>
    <variable name="mapper" select="if ($tappo = 0) then 0 else                    ( if ($pari = 1)                     then ( xs:integer(substring('0246813579', ( xs:integer(substring($arg,1,1)) +1 ) ,1)) )                     else ( xs:integer(substring($arg,1,1) ) )                   )"/>
    <sequence select="if ($tappo = 0) then $mapper else ( xs:integer($mapper) + u:addPIVA(substring(xs:string($arg),2), (if($pari=0) then 1 else 0) ) )"/>
  </function>
	<function xmlns="http://www.w3.org/1999/XSL/Transform" name="u:cat2str">
    <param name="cat"/>
    <sequence select="concat(normalize-space($cat/cbc:ID), '-', round(xs:decimal($cat/cbc:Percent) * 1000000))"/>
</function>
	<function xmlns="http://www.w3.org/1999/XSL/Transform" name="u:checkCF" as="xs:boolean">
    <param name="arg" as="xs:string?"/>
    <sequence select="   if ( (string-length($arg) = 16) or (string-length($arg) = 11) )      then    (    if ((string-length($arg) = 16))     then    (     if (u:checkCF16($arg))      then     (      true()     )     else     (      false()     )    )    else    (     if(($arg castable as xs:integer)) then true() else false()       )   )   else   (    false()   )   "/>
  </function>
	<function xmlns="http://www.w3.org/1999/XSL/Transform" name="u:checkCF16" as="xs:boolean">
    <param name="arg" as="xs:string?"/>
    <variable name="allowed-characters">ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz</variable>
    <sequence select="     if (  (string-length(translate(substring($arg,1,6), $allowed-characters, '')) = 0) and         (substring($arg,7,2) castable as xs:integer) and        (string-length(translate(substring($arg,9,1), $allowed-characters, '')) = 0) and        (substring($arg,10,2) castable as xs:integer) and         (substring($arg,12,3) castable as xs:string) and        (substring($arg,15,1) castable as xs:integer) and         (string-length(translate(substring($arg,16,1), $allowed-characters, '')) = 0)      )      then true()     else false()     "/>
  </function>
	<function xmlns="http://www.w3.org/1999/XSL/Transform" name="u:checkCodiceIPA" as="xs:boolean">
    <param name="arg" as="xs:string?"/>
    <variable name="allowed-characters">ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789</variable>
    <sequence select="if ( (string-length(translate($arg, $allowed-characters, '')) = 0) and (string-length($arg) = 6) ) then true() else false()"/>
  </function>
	<function xmlns="http://www.w3.org/1999/XSL/Transform" name="u:checkPIVA" as="xs:integer">
    <param name="arg" as="xs:string?"/>
    <sequence select="     if (not($arg castable as xs:integer))       then 1      else ( u:addPIVA($arg,xs:integer(0)) mod 10 )"/>
  </function>
	<function xmlns="http://www.w3.org/1999/XSL/Transform" name="u:checkPIVAseIT" as="xs:boolean">
    <param name="arg" as="xs:string"/>
    <variable name="paese" select="substring($arg,1,2)"/>
    <variable name="codice" select="substring($arg,3)"/>
    <sequence select="       if ( $paese = 'IT' or $paese = 'it' )    then    (     if ( ( string-length($codice) = 11 ) and ( if (u:checkPIVA($codice)!=0) then false() else true() ))     then      (      true()     )     else     (      false()     )    )    else    (     true()    )      "/>
  </function>
	<function xmlns="http://www.w3.org/1999/XSL/Transform" name="u:gln" as="xs:boolean">
  <param name="val"/>
  <variable name="length" select="string-length($val) - 1"/>
  <variable name="digits" select="reverse(for $i in string-to-codepoints(substring($val, 1, $length)) return $i -48)"/>
  <variable name="weightedSum" select="sum(for $i in (0 to $length - 1) return $digits[$i + 1] * (1 + ((($i + 1) mod 2) * 2)))"/>
  <sequence select="(10 - ($weightedSum mod 10)) mod 10 = number(substring($val, $length + 1, 1))"/>
</function>
	<function xmlns="http://www.w3.org/1999/XSL/Transform" name="u:mod11" as="xs:boolean">
  <param name="val"/>
  <variable name="length" select="string-length($val) - 1"/>
  <variable name="digits" select="reverse(for $i in string-to-codepoints(substring($val, 0, $length + 1)) return $i - 48)"/>
  <variable name="weightedSum" select="sum(for $i in (0 to $length - 1) return $digits[$i + 1] * (($i mod 6) + 2))"/>
  <sequence select="number($val) &gt; 0 and (11 - ($weightedSum mod 11)) mod 11 = number(substring($val, $length + 1, 1))"/>
</function>
	<function xmlns="http://www.w3.org/1999/XSL/Transform" name="u:mod97-0208" as="xs:boolean">
    <param name="val"/>
    <variable name="checkdigits" select="substring($val,9,2)"/>
    <variable name="calculated_digits" select="xs:string(97 - (xs:integer(substring($val,1,8)) mod 97))"/>
    <sequence select="number($checkdigits) = number($calculated_digits)"/>
  </function>
	<function xmlns="http://www.w3.org/1999/XSL/Transform" name="u:slack" as="xs:boolean">
    <param name="exp" as="xs:decimal"/>
    <param name="val" as="xs:decimal"/>
    <param name="slack" as="xs:decimal"/>
    <sequence select="xs:decimal($exp + $slack) &gt;= $val and xs:decimal($exp - $slack) &lt;= $val"/>
</function>

	

	<pattern>
    <rule context="cbc:*">
        <assert id="EHF-COMMON-R001" test=". != ''" flag="fatal">Document MUST not contain empty elements.</assert>
    </rule>

    <rule context="cac:*">
        <assert id="EHF-COMMON-R002" test="count(*) != 0" flag="fatal">Document MUST not contain empty elements.</assert>
    </rule>
</pattern>
	<pattern xmlns:ns2="http://www.schematron-quickfix.com/validator/process"><let name="clICD" value="tokenize('0002 0003 0004 0005 0006 0007 0008 0009 0010 0011 0012 0013 0014 0015 0016 0017 0018 0019 0020 0021 0022 0023 0024 0025 0026 0027 0028 0029 0030 0031 0032 0033 0034 0035 0036 0037 0038 0039 0040 0041 0042 0043 0044 0045 0046 0047 0048 0049 0050 0051 0052 0053 0054 0055 0056 0057 0058 0059 0060 0061 0062 0063 0064 0065 0066 0067 0068 0069 0070 0071 0072 0073 0074 0075 0076 0077 0078 0079 0080 0081 0082 0083 0084 0085 0086 0087 0088 0089 0090 0091 0093 0094 0095 0096 0097 0098 0099 0100 0101 0102 0104 0105 0106 0107 0108 0109 0110 0111 0112 0113 0114 0115 0116 0117 0118 0119 0120 0121 0122 0123 0124 0125 0126 0127 0128 0129 0130 0131 0132 0133 0134 0135 0136 0137 0138 0139 0140 0141 0142 0143 0144 0145 0146 0147 0148 0149 0150 0151 0152 0153 0154 0155 0156 0157 0158 0159 0160 0161 0162 0163 0164 0165 0166 0167 0168 0169 0170 0171 0172 0173 0174 0175 0176 0177 0178 0179 0180 0183 0184 0185 0186 0187 0188 0189 0190 0191 0192 0193 0194 0195 0196 0197 0198 0199 0200 0201 0202 0203 0204 0205 0206 0207 0208 0209 0210 0211 0212 0213 0214 0215 0216', '\s')"/><let name="clUNECERec20" value="tokenize('10 11 13 14 15 20 21 22 23 24 25 27 28 33 34 35 37 38 40 41 56 57 58 59 60 61 74 77 80 81 85 87 89 91 1I 2A 2B 2C 2G 2H 2I 2J 2K 2L 2M 2N 2P 2Q 2R 2U 2X 2Y 2Z 3B 3C 4C 4G 4H 4K 4L 4M 4N 4O 4P 4Q 4R 4T 4U 4W 4X 5A 5B 5E 5J A10 A11 A12 A13 A14 A15 A16 A17 A18 A19 A2 A20 A21 A22 A23 A24 A26 A27 A28 A29 A3 A30 A31 A32 A33 A34 A35 A36 A37 A38 A39 A4 A40 A41 A42 A43 A44 A45 A47 A48 A49 A5 A53 A54 A55 A56 A59 A6 A68 A69 A7 A70 A71 A73 A74 A75 A76 A8 A84 A85 A86 A87 A88 A89 A9 A90 A91 A93 A94 A95 A96 A97 A98 A99 AA AB ACR ACT AD AE AH AI AK AL AMH AMP ANN APZ AQ AS ASM ASU ATM AWG AY AZ B1 B10 B11 B12 B13 B14 B15 B16 B17 B18 B19 B20 B21 B22 B23 B24 B25 B26 B27 B28 B29 B3 B30 B31 B32 B33 B34 B35 B4 B41 B42 B43 B44 B45 B46 B47 B48 B49 B50 B52 B53 B54 B55 B56 B57 B58 B59 B60 B61 B62 B63 B64 B66 B67 B68 B69 B7 B70 B71 B72 B73 B74 B75 B76 B77 B78 B79 B8 B80 B81 B82 B83 B84 B85 B86 B87 B88 B89 B90 B91 B92 B93 B94 B95 B96 B97 B98 B99 BAR BB BFT BHP BIL BLD BLL BP BPM BQL BTU BUA BUI C0 C10 C11 C12 C13 C14 C15 C16 C17 C18 C19 C20 C21 C22 C23 C24 C25 C26 C27 C28 C29 C3 C30 C31 C32 C33 C34 C35 C36 C37 C38 C39 C40 C41 C42 C43 C44 C45 C46 C47 C48 C49 C50 C51 C52 C53 C54 C55 C56 C57 C58 C59 C60 C61 C62 C63 C64 C65 C66 C67 C68 C69 C7 C70 C71 C72 C73 C74 C75 C76 C78 C79 C8 C80 C81 C82 C83 C84 C85 C86 C87 C88 C89 C9 C90 C91 C92 C93 C94 C95 C96 C97 C99 CCT CDL CEL CEN CG CGM CKG CLF CLT CMK CMQ CMT CNP CNT COU CTG CTM CTN CUR CWA CWI D03 D04 D1 D10 D11 D12 D13 D15 D16 D17 D18 D19 D2 D20 D21 D22 D23 D24 D25 D26 D27 D29 D30 D31 D32 D33 D34 D36 D41 D42 D43 D44 D45 D46 D47 D48 D49 D5 D50 D51 D52 D53 D54 D55 D56 D57 D58 D59 D6 D60 D61 D62 D63 D65 D68 D69 D73 D74 D77 D78 D80 D81 D82 D83 D85 D86 D87 D88 D89 D91 D93 D94 D95 DAA DAD DAY DB DBM DBW DD DEC DG DJ DLT DMA DMK DMO DMQ DMT DN DPC DPR DPT DRA DRI DRL DT DTN DWT DZN DZP E01 E07 E08 E09 E10 E12 E14 E15 E16 E17 E18 E19 E20 E21 E22 E23 E25 E27 E28 E30 E31 E32 E33 E34 E35 E36 E37 E38 E39 E4 E40 E41 E42 E43 E44 E45 E46 E47 E48 E49 E50 E51 E52 E53 E54 E55 E56 E57 E58 E59 E60 E61 E62 E63 E64 E65 E66 E67 E68 E69 E70 E71 E72 E73 E74 E75 E76 E77 E78 E79 E80 E81 E82 E83 E84 E85 E86 E87 E88 E89 E90 E91 E92 E93 E94 E95 E96 E97 E98 E99 EA EB EQ F01 F02 F03 F04 F05 F06 F07 F08 F10 F11 F12 F13 F14 F15 F16 F17 F18 F19 F20 F21 F22 F23 F24 F25 F26 F27 F28 F29 F30 F31 F32 F33 F34 F35 F36 F37 F38 F39 F40 F41 F42 F43 F44 F45 F46 F47 F48 F49 F50 F51 F52 F53 F54 F55 F56 F57 F58 F59 F60 F61 F62 F63 F64 F65 F66 F67 F68 F69 F70 F71 F72 F73 F74 F75 F76 F77 F78 F79 F80 F81 F82 F83 F84 F85 F86 F87 F88 F89 F90 F91 F92 F93 F94 F95 F96 F97 F98 F99 FAH FAR FBM FC FF FH FIT FL FNU FOT FP FR FS FTK FTQ G01 G04 G05 G06 G08 G09 G10 G11 G12 G13 G14 G15 G16 G17 G18 G19 G2 G20 G21 G23 G24 G25 G26 G27 G28 G29 G3 G30 G31 G32 G33 G34 G35 G36 G37 G38 G39 G40 G41 G42 G43 G44 G45 G46 G47 G48 G49 G50 G51 G52 G53 G54 G55 G56 G57 G58 G59 G60 G61 G62 G63 G64 G65 G66 G67 G68 G69 G70 G71 G72 G73 G74 G75 G76 G77 G78 G79 G80 G81 G82 G83 G84 G85 G86 G87 G88 G89 G90 G91 G92 G93 G94 G95 G96 G97 G98 G99 GB GBQ GDW GE GF GFI GGR GIA GIC GII GIP GJ GL GLD GLI GLL GM GO GP GQ GRM GRN GRO GV GWH H03 H04 H05 H06 H07 H08 H09 H10 H11 H12 H13 H14 H15 H16 H18 H19 H20 H21 H22 H23 H24 H25 H26 H27 H28 H29 H30 H31 H32 H33 H34 H35 H36 H37 H38 H39 H40 H41 H42 H43 H44 H45 H46 H47 H48 H49 H50 H51 H52 H53 H54 H55 H56 H57 H58 H59 H60 H61 H62 H63 H64 H65 H66 H67 H68 H69 H70 H71 H72 H73 H74 H75 H76 H77 H79 H80 H81 H82 H83 H84 H85 H87 H88 H89 H90 H91 H92 H93 H94 H95 H96 H98 H99 HA HAD HBA HBX HC HDW HEA HGM HH HIU HKM HLT HM HMO HMQ HMT HPA HTZ HUR IA IE INH INK INQ ISD IU IUG IV J10 J12 J13 J14 J15 J16 J17 J18 J19 J2 J20 J21 J22 J23 J24 J25 J26 J27 J28 J29 J30 J31 J32 J33 J34 J35 J36 J38 J39 J40 J41 J42 J43 J44 J45 J46 J47 J48 J49 J50 J51 J52 J53 J54 J55 J56 J57 J58 J59 J60 J61 J62 J63 J64 J65 J66 J67 J68 J69 J70 J71 J72 J73 J74 J75 J76 J78 J79 J81 J82 J83 J84 J85 J87 J90 J91 J92 J93 J95 J96 J97 J98 J99 JE JK JM JNT JOU JPS JWL K1 K10 K11 K12 K13 K14 K15 K16 K17 K18 K19 K2 K20 K21 K22 K23 K26 K27 K28 K3 K30 K31 K32 K33 K34 K35 K36 K37 K38 K39 K40 K41 K42 K43 K45 K46 K47 K48 K49 K50 K51 K52 K53 K54 K55 K58 K59 K6 K60 K61 K62 K63 K64 K65 K66 K67 K68 K69 K70 K71 K73 K74 K75 K76 K77 K78 K79 K80 K81 K82 K83 K84 K85 K86 K87 K88 K89 K90 K91 K92 K93 K94 K95 K96 K97 K98 K99 KA KAT KB KBA KCC KDW KEL KGM KGS KHY KHZ KI KIC KIP KJ KJO KL KLK KLX KMA KMH KMK KMQ KMT KNI KNM KNS KNT KO KPA KPH KPO KPP KR KSD KSH KT KTN KUR KVA KVR KVT KW KWH KWN KWO KWS KWT KWY KX L10 L11 L12 L13 L14 L15 L16 L17 L18 L19 L2 L20 L21 L23 L24 L25 L26 L27 L28 L29 L30 L31 L32 L33 L34 L35 L36 L37 L38 L39 L40 L41 L42 L43 L44 L45 L46 L47 L48 L49 L50 L51 L52 L53 L54 L55 L56 L57 L58 L59 L60 L63 L64 L65 L66 L67 L68 L69 L70 L71 L72 L73 L74 L75 L76 L77 L78 L79 L80 L81 L82 L83 L84 L85 L86 L87 L88 L89 L90 L91 L92 L93 L94 L95 L96 L98 L99 LA LAC LBR LBT LD LEF LF LH LK LM LN LO LP LPA LR LS LTN LTR LUB LUM LUX LY M1 M10 M11 M12 M13 M14 M15 M16 M17 M18 M19 M20 M21 M22 M23 M24 M25 M26 M27 M29 M30 M31 M32 M33 M34 M35 M36 M37 M38 M39 M4 M40 M41 M42 M43 M44 M45 M46 M47 M48 M49 M5 M50 M51 M52 M53 M55 M56 M57 M58 M59 M60 M61 M62 M63 M64 M65 M66 M67 M68 M69 M7 M70 M71 M72 M73 M74 M75 M76 M77 M78 M79 M80 M81 M82 M83 M84 M85 M86 M87 M88 M89 M9 M90 M91 M92 M93 M94 M95 M96 M97 M98 M99 MAH MAL MAM MAR MAW MBE MBF MBR MC MCU MD MGM MHZ MIK MIL MIN MIO MIU MKD MKM MKW MLD MLT MMK MMQ MMT MND MNJ MON MPA MQD MQH MQM MQS MQW MRD MRM MRW MSK MTK MTQ MTR MTS MTZ MVA MWH N1 N10 N11 N12 N13 N14 N15 N16 N17 N18 N19 N20 N21 N22 N23 N24 N25 N26 N27 N28 N29 N3 N30 N31 N32 N33 N34 N35 N36 N37 N38 N39 N40 N41 N42 N43 N44 N45 N46 N47 N48 N49 N50 N51 N52 N53 N54 N55 N56 N57 N58 N59 N60 N61 N62 N63 N64 N65 N66 N67 N68 N69 N70 N71 N72 N73 N74 N75 N76 N77 N78 N79 N80 N81 N82 N83 N84 N85 N86 N87 N88 N89 N90 N91 N92 N93 N94 N95 N96 N97 N98 N99 NA NAR NCL NEW NF NIL NIU NL NM3 NMI NMP NPT NT NTU NU NX OA ODE ODG ODK ODM OHM ON ONZ OPM OT OZA OZI P1 P10 P11 P12 P13 P14 P15 P16 P17 P18 P19 P2 P20 P21 P22 P23 P24 P25 P26 P27 P28 P29 P30 P31 P32 P33 P34 P35 P36 P37 P38 P39 P40 P41 P42 P43 P44 P45 P46 P47 P48 P49 P5 P50 P51 P52 P53 P54 P55 P56 P57 P58 P59 P60 P61 P62 P63 P64 P65 P66 P67 P68 P69 P70 P71 P72 P73 P74 P75 P76 P77 P78 P79 P80 P81 P82 P83 P84 P85 P86 P87 P88 P89 P90 P91 P92 P93 P94 P95 P96 P97 P98 P99 PAL PD PFL PGL PI PLA PO PQ PR PS PTD PTI PTL PTN Q10 Q11 Q12 Q13 Q14 Q15 Q16 Q17 Q18 Q19 Q20 Q21 Q22 Q23 Q24 Q25 Q26 Q27 Q28 Q29 Q30 Q31 Q32 Q33 Q34 Q35 Q36 Q37 Q38 Q39 Q40 Q41 Q42 Q3 QA QAN QB QR QTD QTI QTL QTR R1 R9 RH RM ROM RP RPM RPS RT S3 S4 SAN SCO SCR SEC SET SG SIE SM3 SMI SQ SQR SR STC STI STK STL STN STW SW SX SYR T0 T3 TAH TAN TI TIC TIP TKM TMS TNE TP TPI TPR TQD TRL TST TTS U1 U2 UB UC VA VLT VP W2 WA WB WCD WE WEB WEE WG WHR WM WSD WTT X1 YDK YDQ YRD Z11 Z9 ZP ZZ X1A X1B X1D X1F X1G X1W X2C X3A X3H X43 X44 X4A X4B X4C X4D X4F X4G X4H X5H X5L X5M X6H X6P X7A X7B X8A X8B X8C XAA XAB XAC XAD XAE XAF XAG XAH XAI XAJ XAL XAM XAP XAT XAV XB4 XBA XBB XBC XBD XBE XBF XBG XBH XBI XBJ XBK XBL XBM XBN XBO XBP XBQ XBR XBS XBT XBU XBV XBW XBX XBY XBZ XCA XCB XCC XCD XCE XCF XCG XCH XCI XCJ XCK XCL XCM XCN XCO XCP XCQ XCR XCS XCT XCU XCV XCW XCX XCY XCZ XDA XDB XDC XDG XDH XDI XDJ XDK XDL XDM XDN XDP XDR XDS XDT XDU XDV XDW XDX XDY XEC XED XEE XEF XEG XEH XEI XEN XFB XFC XFD XFE XFI XFL XFO XFP XFR XFT XFW XFX XGB XGI XGL XGR XGU XGY XGZ XHA XHB XHC XHG XHN XHR XIA XIB XIC XID XIE XIF XIG XIH XIK XIL XIN XIZ XJB XJC XJG XJR XJT XJY XKG XKI XLE XLG XLT XLU XLV XLZ XMA XMB XMC XME XMR XMS XMT XMW XMX XNA XNE XNF XNG XNS XNT XNU XNV XO1 XO2 XO3 XO4 XO5 XO6 XO7 XO8 XO9 XOA XOB XOC XOD XOE XOF XOG XOH XOI XOK XOJ XOL XOM XON XOP XOQ XOR XOS XOV XOW XOT XOU XOX XOY XOZ XP1 XP2 XP3 XP4 XPA XPB XPC XPD XPE XPF XPG XPH XPI XPJ XPK XPL XPN XPO XPP XPR XPT XPU XPV XPX XPY XPZ XQA XQB XQC XQD XQF XQG XQH XQJ XQK XQL XQM XQN XQP XQQ XQR XQS XRD XRG XRJ XRK XRL XRO XRT XRZ XSA XSB XSC XSD XSE XSH XSI XSK XSL XSM XSO XSP XSS XST XSU XSV XSW XSX XSY XSZ XT1 XTB XTC XTD XTE XTG XTI XTK XTL XTN XTO XTR XTS XTT XTU XTV XTW XTY XTZ XUC XUN XVA XVG XVI XVK XVL XVO XVP XVQ XVN XVR XVS XVY XWA XWB XWC XWD XWF XWG XWH XWJ XWK XWL XWM XWN XWP XWQ XWR XWS XWT XWU XWV XWW XWX XWY XWZ XXA XXB XXC XXD XXF XXG XXH XXJ XXK XYA XYB XYC XYD XYF XYG XYH XYJ XYK XYL XYM XYN XYP XYQ XYR XYS XYT XYV XYW XYX XYY XYZ XZA XZB XZC XZD XZF XZG XZH XZJ XZK XZL XZM XZN XZP XZQ XZR XZS XZT XZU XZV XZW XZX XZY XZZ', '\s')"/><let name="clUNCL1001" value="tokenize('1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 1999 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 481 482 483 484 485 486 487 488 489 490 491 493 494 495 496 497 498 499 520 521 522 523 524 525 526 527 528 529 530 531 532 533 534 535 536 537 538 539 550 551 552 553 554 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 610 621 622 623 624 625 626 627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646 647 648 649 650 651 652 653 654 655 656 657 658 659 700 701 702 703 704 705 706 707 708 709 710 711 712 713 714 715 716 717 718 719 720 721 722 723 724 725 726 727 728 729 730 731 732 733 734 735 736 737 738 739 740 741 742 743 744 745 746 747 748 749 750 751 760 761 763 764 765 766 770 775 780 781 782 783 784 785 786 787 788 789 790 791 792 793 794 795 796 797 798 799 810 811 812 820 821 822 823 824 825 830 833 840 841 850 851 852 853 855 856 860 861 862 863 864 865 870 890 895 896 901 910 911 913 914 915 916 917 925 926 927 929 930 931 932 933 934 935 936 937 938 940 941 950 951 952 953 954 955 960 961 962 963 964 965 966 970 971 972 974 975 976 977 978 979 990 991 995 996 998', '\s')"/><let name="clPackagingMarkedLabelAccreditationCode" value="tokenize('3PMSF AGRICULTURE_BIOLOGIQUE AISE_2020_BRAND AISE_2020_COMPANY ALENTEJO_SUSTAINABILITY_PROGRAMME BEE_FRIENDLY 100_PERCENT_CANADIAN_MILK 100_PERCENT_VEGANSKT ACMI ADCCPA AFIA_PET_FOOD_FACILITY AGENCE_BIO AGRI_CONFIANCE AGRI_NATURA AGRICULTURE_BIOLIGIQUE AHAM AISE AISE_2005 AISE_2010 AKC_PEACH_KOSHER ALIMENTATION_DU_TOUT_PETIT ALIMENTS_BIO_PREPARES_AU_QUEBEC ALIMENTS_DU_QUEBEC ALIMENTS_DU_QUEBEC_BIO ALIMENTS_PREPARES_AU_QUEBEC ALUMINIUM_GESAMTVERBAND_DER_ALUMINIUMINDUSTRIE AMA_GENUSSREGION AMA_ORGANIC_SEAL AMA_ORGANIC_SEAL_BLACK AMA_SEAL_OF_APPROVAL AMERICAN_DENTAL_ASSOCIATION AMERICAN_HEART_ASSOCIATION_CERTIFIED ANIMAL_WELFARE_APPROVED_GRASSFED APPELLATION_ORIGINE_CONTROLEE AQUACULTURE_STEWARDSHIP_COUNCIL ARGE_GENTECHNIK_FREI ARGENCERT ARLA_FARMER_OWNED ASCO ASMI ATG AUS_KAUP_ESTONIA AUSTRALIAN_CERTIFIED_ORGANIC AUSTRIA_BIO_GARANTIE AUSTRIAN_ECO_LABEL BCARA_ORGANIC BDIH_LOGO BEBAT BEDRE_DYREVELFAERD_1HEART BEDRE_DYREVELFAERD_2HEART BEDRE_DYREVELFAERD_3HEART BELGAQUA BENOR BERCHTESGADENER_LAND BEST_AQUACULTURE_PRACTICES BEST_AQUACULTURE_PRACTICES_2_STARS BEST_AQUACULTURE_PRACTICES_3_STARS BEST_AQUACULTURE_PRACTICES_4_STARS BETER_LEVEN_1_STER BETER_LEVEN_2_STER BETER_LEVEN_3_STER BETTER_BUSINESS_BUREAU_ACCREDITED BETTER_COTTON_INITIATIVE BEVEG BEWUSST_TIROL BEWUSTE_KEUZE BIKO_TIROL BIO_AUSTRIA_LABEL BIO_BAYERN_WITH_CERTIFICATE_PROVENANCE BIO_BAYERN_WITHOUT_CERTIFICATE_PROVENANCE BIO_CZECH_LABEL BIO_FISCH BIO_LABEL_BADEN_WURTTENBERG BIO_LABEL_GERMAN BIO_LABEL_HESSEN BIO_PARTENAIRE BIO_RING_ALLGAEU BIO_SUISSE_BUD_SEAL BIOCHECKED_NON_GLYPHOSATE_CERTIFIED BIOCHECKED_NON_GMO_VERIFIED BIODEGRADABLE BIODEGRADABLE_PRODUCTS_INSTITUTE BIODYNAMIC_CERTIFICATION BIODYNAMISCH BIOKREIS BIOLAND BIOLAND_ENNSTAL BIOPARK BIOS_KONTROLLE BIRD_FRIENDLY_COFFEE_SMITHSONIAN_CERTIFICATION BK_CHECK_VAAD_HAKASHRUS_OF_BUFFALO BLEU_BLANC_COEUR BLUE_ANGEL BLUE_RIBBON_KOSHER BLUESIGN BORD_BIA_APPROVED BORD_BIA_APPROVED_MEAT BRA_MILJOVAL_LABEL_SWEDISH BRC_GLOBAL_STANDARDS BREATHEWAY BRITISH_DENTAL_HEALTH BRITISH_RETAIL_CONSORTIUM_CERTIFICATION BSCI BULLFROG CA_BEEF CA_BOTH_DOM_IMPORT CA_BULK CA_CANNED CA_DISTILLED CA_IMPORT CA_INGREDIENT CA_MADE CA_MUSTARD_SEEDS CA_OATS CA_PREPARED CA_PROCESSED CA_PRODUCT CA_PROUD CA_REFINED CA_ROASTED_BLENDED CAC_ABSENCE_EGG_MILK CAC_ABSENCE_EGG_MILK_PEANUTS CAC_ABSENCE_OF_ALMOND CAC_ABSENCE_OF_EGG CAC_ABSENCE_OF_MILK CAC_ABSENCE_OF_PEANUT CAC_ABSENCE_PEANUT_ALMOND CAFE_PRACTICES CAN_BNQ_CERTIFIED CANADA_GAP CANADIAN_AGRICULTURAL_PRODUCTS CANADIAN_ASSOCIATION_FIRE_CHIEFS_APPROVED CANADIAN_CERTIFIED_COMPOSTABLE CANADIAN_DERMATOLOGY_ASSOCIATION_SKIN_HEALTH CANADIAN_DERMATOLOGY_ASSOCIATION_SUN_PROTECTION CARBON_FOOTPRINT_STANDARD CARBON_NEUTRAL CARBON_NEUTRAL_NCOS_CERTIFIED CRUELTY_FREE_PETA CARING_CONSUMER_PETA CCA_GLUTEN_FREE CCC CCF_RABBIT CCOF CEBEC CEL CELIAC_SPRUE_ASSOCIATION CENTRAL_RABBINICAL_CONGRESS_KOSHER CERTIFIE_TERROIR_CHARLEVOIX CERTIFIED_ANGUS_BEEF CERTIFIED_B_CORPORATION CERTIFIED_CARBON_FREE CERTIFIED_HUMANE_ORGANISATION CERTIFIED_NATURALLY_GROWN CERTIFIED_OE_100 CERTIFIED_ORGANIC_BAYSTATE_ORGANIC_CERTIFIERS CERTIFIED_ORGANIC_BY_ORGANIC_CERTIFIERS CERTIFIED_PALEO CERTIFIED_PALEO_FRIENDLY CERTIFIED_WBENC CERTIFIED_WILDLIFE_FRIENDLY CFG_PROCESSED_EGG CFIA CFIA_DAIRY CFIA_FISH CFIA_GRADE_A CFIA_GRADE_C CFIA_ORGANIC CFIA_UTILITY_POULTRY_EGG CHASSEURS_DE_FRANCE CHEESE_WORLD_CHAMPION_CHEESE_CONTEST CHICAGO_RABBINICAL_COUNCIL CLIMATE_NEUTRAL CLIMATE_NEUTRAL_PARTNER CNG CO2LOGIC_CO2_NEUTRAL_CERTIFIED COCOA_HORIZONS COCOA_LIFE COMPOSTABLE_DIN_CERTCO COMTE_GREEN_BELL CONFORMITE_EUROPEENNE CONSUMER_CHOICE_AWARD COR_DETROIT COR_KOSHER CORRUGATED_RECYCLES COSMEBIO COSMEBIO_COSMOS_NATURAL COSMEBIO_COSMOS_ORGANIC COTTON_MADE_IN_AFRICA CPE_SCHARREL_EIEREN CPE_VRIJE_UITLOOP_EIEREN CRADLE_TO_CRADLE CROSSED_GRAIN_SYMBOL CROWN_CHK CSA_INTERNATIONAL CSA_NCA_GLUTEN_FREE CSI CZECH_FOOD DALLAS_KOSHER DANSK_IP_KVALITET DANSK_MAELK DEBIO DEMETER_LABEL DESIGN_FOR_THE_ENVIRONMENT DESIGN_FROM_FINLAND DIAMOND_K DIAMOND_KA_KASHRUT_AUTHORITY_OF_AUSTRALIA_AND_NZ DK_ECO DLG_AWARD DLG_CERTIFIED_ALLERGEN_MANAGEMENT DNV_BUSINESS_ASSURANCE DOLPHIN_SAFE DRP DUURZAAM_VARKENSVLEES DVF_VEGAN DVF_VEGETARIAN DYRENES_BESKYTTELSE DZG_GLUTEN_FREE EARTHKOSHER_KOSHER EARTHSURE ECO_KREIS ECO_LABEL_CZECH ECO_LABEL_LADYBUG ECO_LOGO ECOCERT_CERTIFICATE ECOCERT_COSMOS_NATURAL ECOCERT_COSMOS_ORGANIC ECOCERT_ORGANIC ECOGARANTIE ECOLAND ECOLOGO_CERTIFIED ECOVIN ECZEMA_SOCIETY_OF_CANADA EESTI_OKOMARK EESTI_PARIM_TOIDUAINE EKO ENEC ENERGY_LABEL_A ENERGY_LABEL_A+ ENERGY_LABEL_A++ ENERGY_LABEL_A+++ ENERGY_LABEL_B ENERGY_LABEL_C ENERGY_LABEL_D ENERGY_LABEL_E ENERGY_LABEL_F ENERGY_LABEL_G ENERGY_STAR EPA_DFE EPEAT_BRONZE EPEAT_GOLD EPEAT_SILVER EQUAL_EXCHANGE_FAIRLY_TRADED ERDE_SAAT ERKEND_STREEK_PRODUCT ETP EU_ECO_LABEL EU_ENERGY_LABEL EU_ORGANIC_FARMING EUROPEAN_V_LABEL_VEGAN EUROPEAN_V_LABEL_VEGETARIAN EUROPEAN_VEGETARIAN_UNION EWG_VERIFIED FAIR_FLOWERS_FAIR_PLANTS FAIR_FOOD_PROGRAM_LABEL FAIR_FOR_LIFE FAIR_TRADE_MARK FAIR_TRADE_USA FAIR_TRADE_USA_INGREDIENTS FAIR_TSA FAIRTRADE_COCOA FAIRTRADE_COTTON FAIRTRADE_SUGAR FALKEN FCC FEDERALLY_REGISTERED_INSPECTED_CANADA FINNISH_HEART_SYMBOL FISH_WISE_CERTIFICATION FLAMME_VERTE FLEURS_DE_FRANCE FODMAP FODMAP_FRIENDLY FOOD_ALLIANCE_CERTIFIED FOOD_JUSTICE_CERTIFIED FOOD_SAFETY_SYSTEM_CERTIFICATION_22000 FOODLAND_ONTARIO FOR_LIFE FOREST_PRODUCTS_Z809 FOREST_STEWARDSHIP_COUNCIL_100_PERCENT FOREST_STEWARDSHIP_COUNCIL_LABEL FOREST_STEWARDSHIP_COUNCIL_MIX FOREST_STEWARDSHIP_COUNCIL_RECYCLED FOUNDATION_ART FRAN_SVERIGE FRANCE_LIMOUSIN_MEAT FREILAND FRIEND_OF_THE_SEA FRUITS_ET_LEGUMES_DE_FRANCE GAA GAP_1 GAP_2 GAP_3 GAP_4 GAP_5 GAP_5_PLUS GASKEUR GASTEC GENUSS_REGION_AUSTRIA GEPRUEFTE_SICHERHEIT GEZONDERE_KEUZE GFCO GFCP GIG_GLUTEN_FREE_FOODSERVICE GLOBAL_CARE GLOBAL_GAP GLOBAL_ORGANIC_LATEX_STANDARD GLOBAL_ORGANIC_TEXTILE_STANDARD GLOBAL_RECYCLED_STANDARD GLYCAEMIC_INDEX_FOUNDATION GLYCAEMIC_RESEARCH_INSTITUTE GMO_GUARD_FROM_NATURAL_FOOD_CERTIFIERS GMO_MARKED GMP_CERTIFIED GMP_ISO_22716 GOA_ORGANIC GOOD_HOUSEKEEPING GOODS_FROM_FINLAND_BLUE_SWAN GOODWEAVE GRASKEURMERK GREEN_AMERICA_CERTIFIED_BUSINESS GREEN_DOT GREEN_E_ENERGY_CERT GREEN_E_ORG GREEN_RESTAURANT_ASSOCIATION_ENDORSED GREEN_SEAL GREEN_SEAL_CERTIFIED GREEN_SHIELD_CERTIFIED GREEN_STAR_CERTIFIED GREENCHOICE GROEN_LABEL_KAS GRUYERE_FRANCE GUARANTEED_IRISH HALAL_AUSTRALIA HALAL_CORRECT HALAL_FOOD_COUNCIL_OF_SOUTH_EAST_ASIA_THAILAND HALAL_HIC HALAL_HPDS HALAL_INDIA HALAL_ISLAMIC_FOOD_CANADA HALAL_ISLAMIC_SOCIETY_OF_NORTH_AMERICA HALAL_PLUS HAUTE_VALEUR_ENVIRONNEMENTALE HAZARD_ANALYSIS_CRITICAL_CONTROL_POINT HEALTH_CHECK HEALTH_FOOD_BLUE_HAT_SIGN HEUMILCH HFAC_HUMANE HMCA_HALAL_MONTREAL_CERTIFICATION_AUTHORITY HOW_2_RECYCLE HUMANE_HEARTLAND HYPERTENSION_CANADA_MEDICAL_DEVICE ICADA ICEA ICELAND_RESPONSIBLE_FISHERIES ICS_ORGANIC IFANCA_HALAL IFOAM IFS_HPC IHTK_SEAL IKB_EIEREN IKB_KIP IKB_VARKEN INDEKLIMA_MAERKET INSTITUT_FRESENIUS INT_PROTECTION INTERNATIONAL_ALOE_SCIENCE_COUNCIL_CERTIFICATE INTERNATIONAL_KOSHER_COUNCIL INTERNATIONAL_TASTE_QUALITY INTERTEK_CERTIFICATE INTERTEK_ETL ISCC ISCC_SUPPORTING_THE_BIOECONOMY ISEAL_ALLIANCE ISO_QUALITY IVN_NATURAL_LEATHER IVN_NATURAL_TEXTILES_BEST IVO_OMEGA3 JAS_ORGANIC JAY_KOSHER_PAREVE JODSALZ_BZGA KABELKEUR KEHILLA_KOSHER_CALIFORNIA_K KEHILLA_KOSHER_HEART_K KEMA_KEUR KIWA KLASA KOF_K_KOSHER KOMO KOSHER_AUSTRALIA KOSHER_BDMC KOSHER_CERTIFICATION_SERVICE KOSHER_CHECK KOSHER_CHICAGO_RABBINICAL_COUNCIL_DAIRY KOSHER_CHICAGO_RABBINICAL_COUNCIL_PAREVE KOSHER_COR_DAIRY KOSHER_COR_DAIRY_EQUIPMENT KOSHER_COR_FISH KOSHER_EIDAH_HACHAREIDIS KOSHER_GRAND_RABBINATE_OF_QUEBEC_PARVE KOSHER_GREECE KOSHER_INSPECTION_SERVICE_INDIA KOSHER_KW_YOUNG_ISRAEL_OF_WEST_HEMPSTEAD KOSHER_MADRID_SPAIN KOSHER_OK_DAIRY KOSHER_ORTHODOX_JEWISH_CONGREGATION_PARVE KOSHER_OTTAWA_VAAD_HAKASHRUT_CANADA KOSHER_PARVE_BKA KOSHER_PARVE_NATURAL_FOOD_CERTIFIER KOSHER_PERU KOSHER_RAV_LANDAU KOSHER_STAR_K_PARVE KOSHER_STAR_K_PARVE_PASSOVER KOSHER_STAR_S_P_KITNIYOT KOTT_FRAN_SVERIGE KRAV_MARK KSA_KOSHER KSA_KOSHER_DAIRY KVBG_APPROVED LAATUVASTUU LABEL_OF_THE_ALLERGY_AND_ASTHMA_FEDERATION LABEL_ROUGE LACON LAENDLE_QUALITAET LAPIN_DE_FRANCE LE_PORC_FRANCAIS LEAPING_BUNNY LETIS_ORGANIC LGA LOCALIZE LONDON_BETH_DIN_KOSHER LOODUSSOBRALIK_TOODE_ESTONIA LOVE_IRISH_FOOD LVA MADE_IN_FINLAND_FLAG_WITH_KEY MADE_OF_PLASTIC_BEVERAGE_CUPS MADE_WITH_CANADIAN_BEEF MAITRE_ARTISAN MARINE_STEWARDSHIP_COUNCIL_LABEL MAX_HAVELAAR MCIA_ORGANIC MEHR_WEG MILIEUKEUR MJOLK_FRAN_SVERIGE MOMS_CHOICE_AWARD MONTREAL_VAAD_HAIR_PAREVE MPS_A MUNDUSVINI_GOLD MUNDUSVINI_SILVER MUSLIM_JUDICIAL_COUNCIL_HALAAL_TRUST MY_CLIMATE NAOOA_CERTIFIED_QUALITY NASAA_CERTIFIED_ORGANIC NATRUE_LABEL NATURE_ET_PROGRES NATUREPLUS NATURLAND NATURLAND_FAIR_TRADE NATURLAND_WILDFISH NC_NATURAL_COSMETICS_STANDARD NC_NATURAL_COSMETICS_STANDARD_ORGANIC_QUALITY NC_VEGAN_NATURAL_COSMETICS NC_VEGAN_NATURAL_COSMETICS_STANDARD_ORGANIC_QUALITY NCA_GLUTEN_FREE NDOA NEA NEULAND NF_MARQUE NFCA_GLUTEN_FREE NIX18 NMX NOM NON_GMO_BY_EARTHKOSHER NON_GMO_PROJECT NPA NSF NSF_CERTIFIED_FOR_SPORT NSF_GLUTEN_FREE NSF_NON_GMO_TRUE_NORTH NSF_SUSTAINABILITY_CERTIFIED NSM NYCKELHALET OCEAN_WISE OCIA OCQV_ORGANIC OECD_BIO_INGREDIENTS OEKO_CONTROL OEKO_KREISLAUF OEKO_QUALITY_GUARANTEE_BAVARIA OEKO_TEX_LABEL OEUFS_DE_FRANCE OFF_ORGANIC OFFICIAL_ECO_LABEL_SUN OFG_ORGANIC OHNE_GEN_TECHNIK OK_COMPOST_VINCOTTE OK_KOSHER OKOTEST ONE_PERCENT_FOR_THE_PLANET ONTARIO_APPROVED ONTARIO_PORK ORBI OREGON_KOSHER OREGON_TILTH ORGANIC_100_CONTENT_STANDARD ORGANIC_COTTON ORGANIC_TRADE_ASSOCIATION ORIGIN_OF_EGGS ORIGINE_FRANCE_GARANTIE OTCO_ORGANIC OU_KOSHER OU_KOSHER_DAIRY OU_KOSHER_FISH OU_KOSHER_MEAT OU_KOSHER_PASSOVER OZONE_FRIENDLY_GENERAL_CLAIM PACS_ORGANIC PALEO_APPROVED PALEO_BY_EARTHKOSHER PARENT_TESTED_PARENT_APPROVED PAVILLON_FRANCE PCO PEFC PEFC_CERTIFIED PEFC_RECYCLED PET_TO_PET PGI_CNIPA PGI_GAQSIQ PGI_MARA PGI_TO_SAIC PLASTIC_IN_FILTER_TOBACCO PLASTIC_IN_PRODUCT_BEVERAGE_CUPS PLASTIC_IN_PRODUCT_TAMPONS PLASTIC_IN_PRODUCT_WIPES_SANITARY_PADS PLASTIC_NEUTRAL POMMES_DE_TERRES_DE_FRANCE PREGNANCY_WARNING PRO_TERRA_NON_GMO_CERTIFICATION PROCERT_ORGANIC PRODERM PRODUCT_OF_THE_YEAR_CONSUMER_SURVEY PRODUIT_EN_BRETAGNE PROTECTED_DESIGNATION_OF_ORIGIN PROTECTED_GEOGRAPHICAL_INDICATION PROTECTED_HARVEST_CERTIFIED PROVEN_QUALITY_BAVARIA PUHTAASTI_KOTIMAINEN QAI QCS_ORGANIC QS QS_PRODUCTION_PERMIT QUALITAET_TIROL QUALITY_CONFORMANCE_MARKING_CN QUALITY_MARK_IRELAND QUALITY_RHOEN RABBINICAL_COUNCIL_OF_BRITISH_COLUMBIA RABBINICAL_COUNCIL_OF_CALIFORNIA_(RCC) RABBINICAL_COUNCIL_OF_NEW_ENGLAND RAINFOREST_ALLIANCE RAINFOREST_ALLIANCE_PEOPLE_NATURE RAL_QUALITY_CANDLES REAL_CALIFORNIA_CHEESE REAL_CALIFORNIA_MILK REAL_FOOD_SEAL RECUPEL RECYCLABLE_GENERAL_CLAIM REGIONAL_FOOD_CZECH REGIONALFENSTER REGIONALTHEKE_FRANKEN RETURNABLE_PET_BOTTLE_NL RHP ROQUEFORT_RED_EWE ROUNDTABLE_ON_RESPONSIBLE_SOY SAFE_FEED_SAFE_FOOD SAFE_QUALITY_FOOD SAFER_CHOICE SALMON_SAFE_CERTIFICATION SALZBURGER_LAND_HERKUNFT SCHARRELVLEES SCHLESWIG_HOLSTEIN_QUALITY SCROLL_K SCS_RECYCLED_CONTENT_CERTIFICATION SCS_SUSTAINABLY_GROWN SEACHOICE SFC_MEMBER_SEAL SFC_MEMBER_SEAL_GOLD SFC_MEMBER_SEAL_PLATINUM SFC_MEMBER_SEAL_SILVER SGS_ORGANIC SHOPPER_ARMY SKG_CERTIFICATE SKG_CERTIFICATE_1_STAR SKG_CERTIFICATE_2_STAR SKG_CERTIFICATE_3_STAR SLG_CHILD_SAFETY SLG_TYPE_TESTED SLK_BIO SOCIETY_PLASTICS_INDUSTRY SOIL_ASSOCIATION_ORGANIC_SYMBOL SPCA_BC STAR_D_KOSHER STAR_K_KOSHER STEEL_RECYCLING STELLAR_CERTIFICATION_SERVICES STIFTUNG_WARENTEST STOP_CLIMATE_CHANGE STRICTLY_KOSHER_NORWAY SUOMEN_HAMMASLAAKARILIITTO_SUOSITTELEE_KSYLITOLIA SUS SUSTAINABLE_FORESTRY_INITIATIVE SUSTAINABLE_PALM_OIL_RSPO SUSTAINABLE_PALM_OIL_RSPO_CREDITS SUSTAINABLE_PALM_OIL_RSPO_MIXED SVANEN SVENSK_FAGEL SVENSKT_KOTT SWEDISH_SEAL_OF_QUALITY TARNOPOL_KASHRUS_KOSHER TCO_DEVELOPMENT TCO_ORGANIC THE_NATURAL_AND_ORGANIC_AWARDS THREE_LINE_KOSHER TIERSCHUTZBUND TNO_APPROVED TOOTHFRIENDLY TRADITIONAL_SPECIALTY_GUARANTEED TRIANGLE_K TRUE_FOODS_CANADA_TRUSTMARK TRUE_SOURCE_CERTIFIED TUEV_GEPRUEFT TUNNUSTATUD_EESTI_MAITSE TUNNUSTATUD_MAITSE UDEN_GMO_FODER UMWELTBAUM UNDERWRITERS_LABORATORY UNDERWRITERS_LABORATORY_CERTIFIED_CANADA_US UNIQUELY_FINNISH UNITED_EGG_PRODUCERS_CERTIFIED UNSER_LAND USDA USDA_GRADE_A USDA_GRADE_AA USDA_ORGANIC UTZ_CERTIFIED UTZ_CERTIFIED_COCOA VAAD_HOEIR_KOSHER VAELG_FULDKORN_FORST VDE VDS_CERTIFICATE VEGAN_AWARENESS_FOUNDATION VEGAN_BY_EARTHKOSHER VEGAN_NATURAL_FOOD_CERTIFIERS VEGAN_SOCIETY_VEGAN_LOGO VEGAPLAN VEGATARIAN_SOCIETY_V_LOGO VEGECERT VEILIG_WONEN_POLITIE_KEURMERK VERBUND_OEKOHOEFE VIANDE_AGNEAU_FRANCAIS VIANDE_BOVINE_FRANCAISE VIANDE_CHEVALINE_FRANCAISE VIANDE_DE_CHEVRE_FRANCAISE VIANDE_DE_CHEVREAU_FRANCAISE VIANDE_DE_VEAU_FRANCAISE VIANDES_DE_FRANCE VIANDE_OVINE_FRANCAISE VINHO_VERDE VOLAILLE_FRANCAISE WARRANT_HOLDER_OF_THE_COURT_OF_BELGIUM WEIDEMELK WEIGHT_WATCHERS_ENDORSED WESTERN_KOSHER WHOLE_GRAIN_100_PERCENT_STAMP WHOLE_GRAIN_BASIC_STAMP WHOLE_GRAIN_COUNCIL_STAMP WHOLE_GRAINS_50_PERCENT_STAMP WISCONSIN_K WQA_TESTED_CERTIFIED_WATER WSDA WWF_PANDA_LABEL ZELDZAAM_LEKKER ZERO_WASTE_BUSINESS_COUNCIL_CERTIFIED', '\s')"/><let name="clImage" value="tokenize('PRODUCT_IMAGE TRADE_ITEM_DESCRIPTION', '\s')"/><let name="clUNCL5305" value="tokenize('AE E S Z G O K L M', '\s')"/><let name="clTrueFalse" value="tokenize('true false', '\s')"/><let name="clUNCL7143" value="tokenize('AA AB AC AD AE AF AG AH AI AJ AK AL AM AN AO AP AQ AR AS AT AU AV AW AX AY AZ BA BB BC BD BE BF BG BH BI BJ BK BL BM BN BO BP BQ BR BS BT BU BV BW BX BY BZ CC CG CL CR CV DR DW EC EF EN FS GB GN GS HS IB IN IS IT IZ MA MF MN MP NB ON PD PL PO PV QS RC RN RU RY SA SG SK SN SRS SRT SRU SRV SRW SRX SRY SRZ SS SSA SSB SSC SSD SSE SSF SSG SSH SSI SSJ SSK SSL SSM SSN SSO SSP SSQ SSR SSS SST SSU SSV SSW SSX SSY SSZ ST STA STB STC STD STE STF STG STH STI STJ STK STL STM STN STO STP STQ STR STS STT STU STV STW STX STY STZ SUA SUB SUC SUD SUE SUF SUG SUH SUI SUJ SUK SUL SUM TG TSN TSO TSP TSQ TSR TSS TST TSU UA UP VN VP VS VX ZZZ', '\s')"/><let name="clISO4217" value="tokenize('AED AFN ALL AMD ANG AOA ARS AUD AWG AZN BAM BBD BDT BGN BHD BIF BMD BND BOB BOV BRL BSD BTN BWP BYN BZD CAD CDF CHE CHF CHW CLF CLP CNY COP COU CRC CUC CUP CVE CZK DJF DKK DOP DZD EGP ERN ETB EUR FJD FKP GBP GEL GHS GIP GMD GNF GTQ GYD HKD HNL HRK HTG HUF IDR ILS INR IQD IRR ISK JMD JOD JPY KES KGS KHR KMF KPW KRW KWD KYD KZT LAK LBP LKR LRD LSL LYD MAD MDL MGA MKD MMK MNT MOP MRU MUR MVR MWK MXN MXV MYR MZN NAD NGN NIO NOK NPR NZD OMR PAB PEN PGK PHP PKR PLN PYG QAR RON RSD RUB RWF SAR SBD SCR SDG SEK SGD SHP SLL SOS SRD SSP STN SVC SYP SZL THB TJS TMT TND TOP TRY TTD TWD TZS UAH UGX USD USN UYI UYU UZS VEF VND VUV WST XAF XAG XAU XBA XBB XBC XBD XCD XDR XOF XPD XPF XPT XSU XTS XUA YER ZAR ZMW ZWL', '\s')"/><let name="clMimeCode" value="tokenize('application/pdf image/png image/jpeg image/tiff application/acad application/dwg drawing/dwg application/vnd.openxmlformats-officedocument.spreadsheetml.sheet application/vnd.oasis.opendocument.spreadsheet', '\s')"/><let name="clISO3166" value="tokenize('AD AE AF AG AI AL AM AO AQ AR AS AT AU AW AX AZ BA BB BD BE BF BG BH BI BJ BL BM BN BO BQ BR BS BT BV BW BY BZ CA CC CD CF CG CH CI CK CL CM CN CO CR CU CV CW CX CY CZ DE DJ DK DM DO DZ EC EE EG EH ER ES ET FI FJ FK FM FO FR GA GB GD GE GF GG GH GI GL GM GN GP GQ GR GS GT GU GW GY HK HM HN HR HT HU ID IE IL IM IN IO IQ IR IS IT JE JM JO JP KE KG KH KI KM KN KP KR KW KY KZ LA LB LC LI LK LR LS LT LU LV LY MA MC MD ME MF MG MH MK ML MM MN MO MP MQ MR MS MT MU MV MW MX MY MZ NA NC NE NF NG NI NL NO NP NR NU NZ OM PA PE PF PG PH PK PL PM PN PR PS PT PW PY QA RE RO RS RU RW SA SB SC SD SE SG SH SI SJ SK SL SM SN SO SR SS ST SV SX SY SZ TC TD TF TG TH TJ TK TL TM TN TO TR TT TV TW TZ UA UG UM US UY UZ VA VC VE VG VI VN VU WF WS YE YT ZA ZM ZW 1A XI', '\s')"/><let name="clNA" value="tokenize('NA', '\s')"/><rule context="/ubl:Catalogue"><assert test="cbc:CustomizationID" flag="fatal" id="EHF-T77-B00101">Element 'cbc:CustomizationID' MUST be provided.</assert><assert test="cbc:ProfileID" flag="fatal" id="EHF-T77-B00102">Element 'cbc:ProfileID' MUST be provided.</assert><assert test="cbc:ID" flag="fatal" id="EHF-T77-B00103">Element 'cbc:ID' MUST be provided.</assert><assert test="cbc:IssueDate" flag="fatal" id="EHF-T77-B00104">Element 'cbc:IssueDate' MUST be provided.</assert><assert test="cbc:IssueTime" flag="fatal" id="EHF-T77-B00105">Element 'cbc:IssueTime' MUST be provided.</assert><assert test="cac:ProviderParty" flag="fatal" id="EHF-T77-B00106">Element 'cac:ProviderParty' MUST be provided.</assert><assert test="cac:ReceiverParty" flag="fatal" id="EHF-T77-B00107">Element 'cac:ReceiverParty' MUST be provided.</assert><assert test="cac:CatalogueLine" flag="fatal" id="EHF-T77-B00108">Element 'cac:CatalogueLine' MUST be provided.</assert><assert test="not(@*:schemaLocation)" flag="fatal" id="EHF-T77-B00109">Document MUST not contain schema location.</assert></rule><rule context="/ubl:Catalogue/cbc:CustomizationID"><assert test="normalize-space(text()) = 'urn:fdc:peppol.eu:poacc:trns:punch_out:3:extended:urn:fdc:anskaffelser.no:2019:ehf:spec:3.0'" flag="fatal" id="EHF-T77-B00201">Element 'cbc:CustomizationID' MUST contain value 'urn:fdc:peppol.eu:poacc:trns:punch_out:3:extended:urn:fdc:anskaffelser.no:2019:ehf:spec:3.0'.</assert></rule><rule context="/ubl:Catalogue/cbc:CustomizationID/*"><assert test="false()" flag="fatal" id="EHF-T77-B00202">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cbc:ProfileID"><assert test="normalize-space(text()) = 'urn:fdc:anskaffelser.no:2019:ehf:postaward:g3:04:1.0'" flag="fatal" id="EHF-T77-B00301">Element 'cbc:ProfileID' MUST contain value 'urn:fdc:anskaffelser.no:2019:ehf:postaward:g3:04:1.0'.</assert></rule><rule context="/ubl:Catalogue/cbc:ProfileID/*"><assert test="false()" flag="fatal" id="EHF-T77-B00302">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cbc:ID"/><rule context="/ubl:Catalogue/cbc:ID/*"><assert test="false()" flag="fatal" id="EHF-T77-B00401">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cbc:ActionCode"><assert test="(some $code in $clTrueFalse satisfies $code = normalize-space(text()))" flag="fatal" id="EHF-T77-B00501">Value MUST be part of code list 'Boolean indicator (openPEPPOL)'.</assert></rule><rule context="/ubl:Catalogue/cbc:ActionCode/*"><assert test="false()" flag="fatal" id="EHF-T77-B00502">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cbc:IssueDate"/><rule context="/ubl:Catalogue/cbc:IssueDate/*"><assert test="false()" flag="fatal" id="EHF-T77-B00601">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cbc:IssueTime"/><rule context="/ubl:Catalogue/cbc:IssueTime/*"><assert test="false()" flag="fatal" id="EHF-T77-B00701">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ValidityPeriod"><assert test="cbc:EndDate" flag="fatal" id="EHF-T77-B00801">Element 'cbc:EndDate' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:ValidityPeriod/cbc:EndDate"/><rule context="/ubl:Catalogue/cac:ValidityPeriod/cbc:EndDate/*"><assert test="false()" flag="fatal" id="EHF-T77-B00901">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ValidityPeriod/cbc:EndTime"/><rule context="/ubl:Catalogue/cac:ValidityPeriod/cbc:EndTime/*"><assert test="false()" flag="fatal" id="EHF-T77-B01001">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ValidityPeriod/*"><assert test="false()" flag="fatal" id="EHF-T77-B00802">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ReferencedContract"/><rule context="/ubl:Catalogue/cac:ReferencedContract/cbc:ID"/><rule context="/ubl:Catalogue/cac:ReferencedContract/cbc:ID/*"><assert test="false()" flag="fatal" id="EHF-T77-B01201">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ReferencedContract/*"><assert test="false()" flag="fatal" id="EHF-T77-B01101">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ProviderParty"><assert test="cac:PartyLegalEntity" flag="fatal" id="EHF-T77-B01301">Element 'cac:PartyLegalEntity' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:ProviderParty/cbc:EndpointID"><assert test="not(@schemeID) or @schemeID = '0192'" flag="fatal" id="EHF-T77-B01401">Attribute 'schemeID' MUST contain value '0192'</assert><assert test="@schemeID" flag="fatal" id="EHF-T77-B01402">Attribute 'schemeID' MUST be present.</assert></rule><rule context="/ubl:Catalogue/cac:ProviderParty/cbc:EndpointID/*"><assert test="false()" flag="fatal" id="EHF-T77-B01403">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ProviderParty/cac:PartyIdentification"><assert test="cbc:ID" flag="fatal" id="EHF-T77-B01601">Element 'cbc:ID' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:ProviderParty/cac:PartyIdentification/cbc:ID"><assert test="not(@schemeID) or (some $code in $clICD satisfies $code = @schemeID)" flag="fatal" id="EHF-T77-B01701">Value MUST be part of code list 'ISO 6523 ICD list'.</assert></rule><rule context="/ubl:Catalogue/cac:ProviderParty/cac:PartyIdentification/cbc:ID/*"><assert test="false()" flag="fatal" id="EHF-T77-B01702">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ProviderParty/cac:PartyIdentification/*"><assert test="false()" flag="fatal" id="EHF-T77-B01602">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ProviderParty/cac:PartyLegalEntity"><assert test="cbc:RegistrationName" flag="fatal" id="EHF-T77-B01901">Element 'cbc:RegistrationName' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:ProviderParty/cac:PartyLegalEntity/cbc:RegistrationName"/><rule context="/ubl:Catalogue/cac:ProviderParty/cac:PartyLegalEntity/cbc:RegistrationName/*"><assert test="false()" flag="fatal" id="EHF-T77-B02001">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ProviderParty/cac:PartyLegalEntity/*"><assert test="false()" flag="fatal" id="EHF-T77-B01902">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ProviderParty/*"><assert test="false()" flag="fatal" id="EHF-T77-B01302">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ReceiverParty"><assert test="cac:PartyLegalEntity" flag="fatal" id="EHF-T77-B02101">Element 'cac:PartyLegalEntity' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:ReceiverParty/cbc:EndpointID"><assert test="not(@schemeID) or @schemeID = '0192'" flag="fatal" id="EHF-T77-B02201">Attribute 'schemeID' MUST contain value '0192'</assert><assert test="@schemeID" flag="fatal" id="EHF-T77-B02202">Attribute 'schemeID' MUST be present.</assert></rule><rule context="/ubl:Catalogue/cac:ReceiverParty/cbc:EndpointID/*"><assert test="false()" flag="fatal" id="EHF-T77-B02203">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ReceiverParty/cac:PartyIdentification"><assert test="cbc:ID" flag="fatal" id="EHF-T77-B02401">Element 'cbc:ID' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:ReceiverParty/cac:PartyIdentification/cbc:ID"><assert test="not(@schemeID) or (some $code in $clICD satisfies $code = @schemeID)" flag="fatal" id="EHF-T77-B02501">Value MUST be part of code list 'ISO 6523 ICD list'.</assert></rule><rule context="/ubl:Catalogue/cac:ReceiverParty/cac:PartyIdentification/cbc:ID/*"><assert test="false()" flag="fatal" id="EHF-T77-B02502">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ReceiverParty/cac:PartyIdentification/*"><assert test="false()" flag="fatal" id="EHF-T77-B02402">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ReceiverParty/cac:PartyLegalEntity"><assert test="cbc:RegistrationName" flag="fatal" id="EHF-T77-B02701">Element 'cbc:RegistrationName' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:ReceiverParty/cac:PartyLegalEntity/cbc:RegistrationName"/><rule context="/ubl:Catalogue/cac:ReceiverParty/cac:PartyLegalEntity/cbc:RegistrationName/*"><assert test="false()" flag="fatal" id="EHF-T77-B02801">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ReceiverParty/cac:PartyLegalEntity/*"><assert test="false()" flag="fatal" id="EHF-T77-B02702">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ReceiverParty/cac:Contact"/><rule context="/ubl:Catalogue/cac:ReceiverParty/cac:Contact/cbc:ID"/><rule context="/ubl:Catalogue/cac:ReceiverParty/cac:Contact/cbc:ID/*"><assert test="false()" flag="fatal" id="EHF-T77-B03001">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ReceiverParty/cac:Contact/*"><assert test="false()" flag="fatal" id="EHF-T77-B02901">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:ReceiverParty/*"><assert test="false()" flag="fatal" id="EHF-T77-B02102">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine"><assert test="cbc:ID" flag="fatal" id="EHF-T77-B03101">Element 'cbc:ID' MUST be provided.</assert><assert test="cac:RequiredItemLocationQuantity" flag="fatal" id="EHF-T77-B03102">Element 'cac:RequiredItemLocationQuantity' MUST be provided.</assert><assert test="cac:Item" flag="fatal" id="EHF-T77-B03103">Element 'cac:Item' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cbc:ID"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cbc:ID/*"><assert test="false()" flag="fatal" id="EHF-T77-B03201">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cbc:ContractSubdivision"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cbc:ContractSubdivision/*"><assert test="false()" flag="fatal" id="EHF-T77-B03301">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:LineValidityPeriod"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:LineValidityPeriod/cbc:StartDate"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:LineValidityPeriod/cbc:StartDate/*"><assert test="false()" flag="fatal" id="EHF-T77-B03501">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:LineValidityPeriod/cbc:EndDate"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:LineValidityPeriod/cbc:EndDate/*"><assert test="false()" flag="fatal" id="EHF-T77-B03601">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:LineValidityPeriod/cbc:EndTime"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:LineValidityPeriod/cbc:EndTime/*"><assert test="false()" flag="fatal" id="EHF-T77-B03701">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:LineValidityPeriod/*"><assert test="false()" flag="fatal" id="EHF-T77-B03401">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity"><assert test="cac:Price" flag="fatal" id="EHF-T77-B03801">Element 'cac:Price' MUST be provided.</assert><assert test="cac:DeliveryUnit" flag="fatal" id="EHF-T77-B03802">Element 'cac:DeliveryUnit' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cbc:LeadTimeMeasure"><assert test="@unitCode" flag="fatal" id="EHF-T77-B03901">Attribute 'unitCode' MUST be present.</assert><assert test="not(@unitCode) or (some $code in $clUNECERec20 satisfies $code = @unitCode)" flag="fatal" id="EHF-T77-B03902">Value MUST be part of code list 'Recommendation 20, including Recommendation 21 codes - prefixed with X (UN/ECE)'.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cbc:LeadTimeMeasure/*"><assert test="false()" flag="fatal" id="EHF-T77-B03903">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cbc:StreetName"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cbc:StreetName/*"><assert test="false()" flag="fatal" id="EHF-T77-B04201">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cbc:AdditionalStreetName"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cbc:AdditionalStreetName/*"><assert test="false()" flag="fatal" id="EHF-T77-B04301">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cbc:CityName"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cbc:CityName/*"><assert test="false()" flag="fatal" id="EHF-T77-B04401">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cbc:PostalZone"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cbc:PostalZone/*"><assert test="false()" flag="fatal" id="EHF-T77-B04501">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cbc:CountrySubentity"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cbc:CountrySubentity/*"><assert test="false()" flag="fatal" id="EHF-T77-B04601">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cac:AddressLine"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cac:AddressLine/cbc:Line"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cac:AddressLine/cbc:Line/*"><assert test="false()" flag="fatal" id="EHF-T77-B04801">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cac:AddressLine/*"><assert test="false()" flag="fatal" id="EHF-T77-B04701">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cac:Country"><assert test="cbc:IdentificationCode" flag="fatal" id="EHF-T77-B04901">Element 'cbc:IdentificationCode' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cac:Country/cbc:IdentificationCode"><assert test="(some $code in $clISO3166 satisfies $code = normalize-space(text()))" flag="fatal" id="EHF-T77-B05001">Value MUST be part of code list 'Country codes (ISO 3166-1:Alpha2)'.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cac:Country/cbc:IdentificationCode/*"><assert test="false()" flag="fatal" id="EHF-T77-B05002">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/cac:Country/*"><assert test="false()" flag="fatal" id="EHF-T77-B04902">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:ApplicableTerritoryAddress/*"><assert test="false()" flag="fatal" id="EHF-T77-B04101">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:Price"><assert test="cbc:PriceAmount" flag="fatal" id="EHF-T77-B05101">Element 'cbc:PriceAmount' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:Price/cbc:PriceAmount"><assert test="@currencyID" flag="fatal" id="EHF-T77-B05201">Attribute 'currencyID' MUST be present.</assert><assert test="not(@currencyID) or (some $code in $clISO4217 satisfies $code = @currencyID)" flag="fatal" id="EHF-T77-B05202">Value MUST be part of code list 'Currency codes (ISO 4217)'.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:Price/cbc:PriceAmount/*"><assert test="false()" flag="fatal" id="EHF-T77-B05203">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:Price/cbc:BaseQuantity"><assert test="@unitCode" flag="fatal" id="EHF-T77-B05401">Attribute 'unitCode' MUST be present.</assert><assert test="not(@unitCode) or (some $code in $clUNECERec20 satisfies $code = @unitCode)" flag="fatal" id="EHF-T77-B05402">Value MUST be part of code list 'Recommendation 20, including Recommendation 21 codes - prefixed with X (UN/ECE)'.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:Price/cbc:BaseQuantity/*"><assert test="false()" flag="fatal" id="EHF-T77-B05403">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:Price/cbc:PriceType"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:Price/cbc:PriceType/*"><assert test="false()" flag="fatal" id="EHF-T77-B05601">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:Price/*"><assert test="false()" flag="fatal" id="EHF-T77-B05102">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:DeliveryUnit"><assert test="cbc:BatchQuantity" flag="fatal" id="EHF-T77-B05701">Element 'cbc:BatchQuantity' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:DeliveryUnit/cbc:BatchQuantity"><assert test="@unitCode" flag="fatal" id="EHF-T77-B05801">Attribute 'unitCode' MUST be present.</assert><assert test="not(@unitCode) or (some $code in $clUNECERec20 satisfies $code = @unitCode)" flag="fatal" id="EHF-T77-B05802">Value MUST be part of code list 'Recommendation 20, including Recommendation 21 codes - prefixed with X (UN/ECE)'.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:DeliveryUnit/cbc:BatchQuantity/*"><assert test="false()" flag="fatal" id="EHF-T77-B05803">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/cac:DeliveryUnit/*"><assert test="false()" flag="fatal" id="EHF-T77-B05702">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:RequiredItemLocationQuantity/*"><assert test="false()" flag="fatal" id="EHF-T77-B03803">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item"><assert test="cbc:Name" flag="fatal" id="EHF-T77-B06001">Element 'cbc:Name' MUST be provided.</assert><assert test="cac:ClassifiedTaxCategory" flag="fatal" id="EHF-T77-B06002">Element 'cac:ClassifiedTaxCategory' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cbc:Description"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cbc:Description/*"><assert test="false()" flag="fatal" id="EHF-T77-B06101">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cbc:Name"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cbc:Name/*"><assert test="false()" flag="fatal" id="EHF-T77-B06201">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:BuyersItemIdentification"><assert test="cbc:ID" flag="fatal" id="EHF-T77-B06301">Element 'cbc:ID' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:BuyersItemIdentification/cbc:ID"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:BuyersItemIdentification/cbc:ID/*"><assert test="false()" flag="fatal" id="EHF-T77-B06401">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:BuyersItemIdentification/*"><assert test="false()" flag="fatal" id="EHF-T77-B06302">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:SellersItemIdentification"><assert test="cbc:ID" flag="fatal" id="EHF-T77-B06501">Element 'cbc:ID' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:SellersItemIdentification/cbc:ID"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:SellersItemIdentification/cbc:ID/*"><assert test="false()" flag="fatal" id="EHF-T77-B06601">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:SellersItemIdentification/*"><assert test="false()" flag="fatal" id="EHF-T77-B06502">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ManufacturersItemIdentification"><assert test="cbc:ID" flag="fatal" id="EHF-T77-B06701">Element 'cbc:ID' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ManufacturersItemIdentification/cbc:ID"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ManufacturersItemIdentification/cbc:ID/*"><assert test="false()" flag="fatal" id="EHF-T77-B06801">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ManufacturersItemIdentification/*"><assert test="false()" flag="fatal" id="EHF-T77-B06702">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:StandardItemIdentification"><assert test="cbc:ID" flag="fatal" id="EHF-T77-B06901">Element 'cbc:ID' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:StandardItemIdentification/cbc:ID"><assert test="@schemeID" flag="fatal" id="EHF-T77-B07001">Attribute 'schemeID' MUST be present.</assert><assert test="not(@schemeID) or (some $code in $clICD satisfies $code = @schemeID)" flag="fatal" id="EHF-T77-B07002">Value MUST be part of code list 'ISO 6523 ICD list'.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:StandardItemIdentification/cbc:ID/*"><assert test="false()" flag="fatal" id="EHF-T77-B07003">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:StandardItemIdentification/*"><assert test="false()" flag="fatal" id="EHF-T77-B06902">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ItemSpecificationDocumentReference"><assert test="cbc:ID" flag="fatal" id="EHF-T77-B07201">Element 'cbc:ID' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ItemSpecificationDocumentReference/cbc:ID"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ItemSpecificationDocumentReference/cbc:ID/*"><assert test="false()" flag="fatal" id="EHF-T77-B07301">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ItemSpecificationDocumentReference/cbc:DocumentTypeCode"><assert test="(some $code in $clUNCL1001 satisfies $code = normalize-space(text())) or (some $code in $clImage satisfies $code = normalize-space(text()))" flag="fatal" id="EHF-T77-B07401">Value MUST be part of code list 'Document name code, full list (UNCL1001)' or 'Image code (openPEPPOL)'.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ItemSpecificationDocumentReference/cbc:DocumentTypeCode/*"><assert test="false()" flag="fatal" id="EHF-T77-B07402">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ItemSpecificationDocumentReference/cbc:DocumentDescription"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ItemSpecificationDocumentReference/cbc:DocumentDescription/*"><assert test="false()" flag="fatal" id="EHF-T77-B07501">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ItemSpecificationDocumentReference/cac:Attachment"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ItemSpecificationDocumentReference/cac:Attachment/cbc:EmbeddedDocumentBinaryObject"><assert test="@mimeCode" flag="fatal" id="EHF-T77-B07701">Attribute 'mimeCode' MUST be present.</assert><assert test="not(@mimeCode) or (some $code in $clMimeCode satisfies $code = @mimeCode)" flag="fatal" id="EHF-T77-B07702">Value MUST be part of code list 'Mime code (IANA Subset)'.</assert><assert test="@filename" flag="fatal" id="EHF-T77-B07703">Attribute 'filename' MUST be present.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ItemSpecificationDocumentReference/cac:Attachment/cbc:EmbeddedDocumentBinaryObject/*"><assert test="false()" flag="fatal" id="EHF-T77-B07704">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ItemSpecificationDocumentReference/cac:Attachment/*"><assert test="false()" flag="fatal" id="EHF-T77-B07601">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ItemSpecificationDocumentReference/*"><assert test="false()" flag="fatal" id="EHF-T77-B07202">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:OriginCountry"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:OriginCountry/cbc:IdentificationCode"><assert test="(some $code in $clISO3166 satisfies $code = normalize-space(text()))" flag="fatal" id="EHF-T77-B08101">Value MUST be part of code list 'Country codes (ISO 3166-1:Alpha2)'.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:OriginCountry/cbc:IdentificationCode/*"><assert test="false()" flag="fatal" id="EHF-T77-B08102">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:OriginCountry/*"><assert test="false()" flag="fatal" id="EHF-T77-B08001">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:CommodityClassification"><assert test="cbc:ItemClassificationCode" flag="fatal" id="EHF-T77-B08201">Element 'cbc:ItemClassificationCode' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:CommodityClassification/cbc:ItemClassificationCode"><assert test="@listID" flag="fatal" id="EHF-T77-B08301">Attribute 'listID' MUST be present.</assert><assert test="not(@listID) or (some $code in $clUNCL7143 satisfies $code = @listID)" flag="fatal" id="EHF-T77-B08302">Value MUST be part of code list 'Item type identification code (UNCL7143)'.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:CommodityClassification/cbc:ItemClassificationCode/*"><assert test="false()" flag="fatal" id="EHF-T77-B08303">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:CommodityClassification/*"><assert test="false()" flag="fatal" id="EHF-T77-B08202">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:TransactionConditions"><assert test="cbc:ActionCode" flag="fatal" id="EHF-T77-B08601">Element 'cbc:ActionCode' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:TransactionConditions/cbc:ActionCode"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:TransactionConditions/cbc:ActionCode/*"><assert test="false()" flag="fatal" id="EHF-T77-B08701">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:TransactionConditions/*"><assert test="false()" flag="fatal" id="EHF-T77-B08602">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ClassifiedTaxCategory"><assert test="cbc:ID" flag="fatal" id="EHF-T77-B08801">Element 'cbc:ID' MUST be provided.</assert><assert test="cbc:Percent" flag="fatal" id="EHF-T77-B08802">Element 'cbc:Percent' MUST be provided.</assert><assert test="cac:TaxScheme" flag="fatal" id="EHF-T77-B08803">Element 'cac:TaxScheme' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ClassifiedTaxCategory/cbc:ID"><assert test="(some $code in $clUNCL5305 satisfies $code = normalize-space(text()))" flag="fatal" id="EHF-T77-B08901">Value MUST be part of code list 'Duty or tax or fee category code (UNCL5305)'.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ClassifiedTaxCategory/cbc:ID/*"><assert test="false()" flag="fatal" id="EHF-T77-B08902">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ClassifiedTaxCategory/cbc:Percent"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ClassifiedTaxCategory/cbc:Percent/*"><assert test="false()" flag="fatal" id="EHF-T77-B09001">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ClassifiedTaxCategory/cac:TaxScheme"><assert test="cbc:ID" flag="fatal" id="EHF-T77-B09101">Element 'cbc:ID' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ClassifiedTaxCategory/cac:TaxScheme/cbc:ID"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ClassifiedTaxCategory/cac:TaxScheme/cbc:ID/*"><assert test="false()" flag="fatal" id="EHF-T77-B09201">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ClassifiedTaxCategory/cac:TaxScheme/*"><assert test="false()" flag="fatal" id="EHF-T77-B09102">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ClassifiedTaxCategory/*"><assert test="false()" flag="fatal" id="EHF-T77-B08804">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:AdditionalItemProperty"><assert test="cbc:Name" flag="fatal" id="EHF-T77-B09301">Element 'cbc:Name' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:AdditionalItemProperty/cbc:Name"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:AdditionalItemProperty/cbc:Name/*"><assert test="false()" flag="fatal" id="EHF-T77-B09401">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:AdditionalItemProperty/cbc:NameCode"><assert test="@listID" flag="fatal" id="EHF-T77-B09501">Attribute 'listID' MUST be present.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:AdditionalItemProperty/cbc:NameCode/*"><assert test="false()" flag="fatal" id="EHF-T77-B09502">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:AdditionalItemProperty/cbc:Value"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:AdditionalItemProperty/cbc:Value/*"><assert test="false()" flag="fatal" id="EHF-T77-B09701">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:AdditionalItemProperty/cbc:ValueQuantity"><assert test="@unitCode" flag="fatal" id="EHF-T77-B09801">Attribute 'unitCode' MUST be present.</assert><assert test="not(@unitCode) or (some $code in $clUNECERec20 satisfies $code = @unitCode)" flag="fatal" id="EHF-T77-B09802">Value MUST be part of code list 'Recommendation 20, including Recommendation 21 codes - prefixed with X (UN/ECE)'.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:AdditionalItemProperty/cbc:ValueQuantity/*"><assert test="false()" flag="fatal" id="EHF-T77-B09803">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:AdditionalItemProperty/cbc:ValueQualifier"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:AdditionalItemProperty/cbc:ValueQualifier/*"><assert test="false()" flag="fatal" id="EHF-T77-B10001">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:AdditionalItemProperty/cbc:ListValue"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:AdditionalItemProperty/cbc:ListValue/*"><assert test="false()" flag="fatal" id="EHF-T77-B10101">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:AdditionalItemProperty/*"><assert test="false()" flag="fatal" id="EHF-T77-B09302">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ManufacturerParty"><assert test="cac:PartyName" flag="fatal" id="EHF-T77-B10201">Element 'cac:PartyName' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ManufacturerParty/cac:PartyName"><assert test="cbc:Name" flag="fatal" id="EHF-T77-B10301">Element 'cbc:Name' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ManufacturerParty/cac:PartyName/cbc:Name"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ManufacturerParty/cac:PartyName/cbc:Name/*"><assert test="false()" flag="fatal" id="EHF-T77-B10401">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ManufacturerParty/cac:PartyName/*"><assert test="false()" flag="fatal" id="EHF-T77-B10302">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:ManufacturerParty/*"><assert test="false()" flag="fatal" id="EHF-T77-B10202">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate"><assert test="cbc:ID" flag="fatal" id="EHF-T77-B10501">Element 'cbc:ID' MUST be provided.</assert><assert test="cbc:CertificateTypeCode" flag="fatal" id="EHF-T77-B10502">Element 'cbc:CertificateTypeCode' MUST be provided.</assert><assert test="cbc:CertificateType" flag="fatal" id="EHF-T77-B10503">Element 'cbc:CertificateType' MUST be provided.</assert><assert test="cac:IssuerParty" flag="fatal" id="EHF-T77-B10504">Element 'cac:IssuerParty' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate/cbc:ID"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate/cbc:ID/*"><assert test="false()" flag="fatal" id="EHF-T77-B10601">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate/cbc:CertificateTypeCode"><assert test="(some $code in $clNA satisfies $code = normalize-space(text())) or (some $code in $clPackagingMarkedLabelAccreditationCode satisfies $code = normalize-space(text()))" flag="fatal" id="EHF-T77-B10701">Value MUST be part of code list 'NA codes' or 'PackagingMarkedLabelAccreditationCode'.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate/cbc:CertificateTypeCode/*"><assert test="false()" flag="fatal" id="EHF-T77-B10702">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate/cbc:CertificateType"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate/cbc:CertificateType/*"><assert test="false()" flag="fatal" id="EHF-T77-B10801">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate/cbc:Remarks"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate/cbc:Remarks/*"><assert test="false()" flag="fatal" id="EHF-T77-B10901">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate/cac:IssuerParty"><assert test="cac:PartyName" flag="fatal" id="EHF-T77-B11001">Element 'cac:PartyName' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate/cac:IssuerParty/cac:PartyName"><assert test="cbc:Name" flag="fatal" id="EHF-T77-B11101">Element 'cbc:Name' MUST be provided.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate/cac:IssuerParty/cac:PartyName/cbc:Name"/><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate/cac:IssuerParty/cac:PartyName/cbc:Name/*"><assert test="false()" flag="fatal" id="EHF-T77-B11201">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate/cac:IssuerParty/cac:PartyName/*"><assert test="false()" flag="fatal" id="EHF-T77-B11102">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate/cac:IssuerParty/*"><assert test="false()" flag="fatal" id="EHF-T77-B11002">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/cac:Certificate/*"><assert test="false()" flag="fatal" id="EHF-T77-B10505">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/cac:Item/*"><assert test="false()" flag="fatal" id="EHF-T77-B06003">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/cac:CatalogueLine/*"><assert test="false()" flag="fatal" id="EHF-T77-B03104">Document MUST NOT contain elements not part of the data model.</assert></rule><rule context="/ubl:Catalogue/*"><assert test="false()" flag="fatal" id="EHF-T77-B00110">Document MUST NOT contain elements not part of the data model.</assert></rule></pattern>
	<pattern>

    

    <rule context="cbc:EndpointID[@schemeID = '0192'] | cac:PartyIdentification/cbc:ID[@schemeID = '0192'] | cbc:CompanyID[@schemeID = '0192']">
        <assert id="EHF-COMMON-R003" test="matches(normalize-space(), '^[0-9]{9}$') and u:mod11(normalize-space())" flag="fatal">MUST be a valid Norwegian organization number. Only numerical value allowed</assert>
    </rule>

    

    <rule context="/*">
        <assert id="PEPPOL-COMMON-R003" test="not(@*:schemaLocation)" flag="warning">Document SHOULD not contain schema location.</assert>

    </rule>

    <rule context="cbc:IssueDate | cbc:DueDate | cbc:TaxPointDate | cbc:StartDate | cbc:EndDate | cbc:ActualDeliveryDate">
        <assert id="PEPPOL-COMMON-R030" test="(string(.) castable as xs:date) and (string-length(.) = 10)" flag="fatal">A date must be formatted YYYY-MM-DD.</assert>
    </rule>
    <rule context="cbc:EndpointID[@schemeID = '0088'] | cac:PartyIdentification/cbc:ID[@schemeID = '0088'] | cbc:CompanyID[@schemeID = '0088']">
        <assert id="PEPPOL-COMMON-R040" test="matches(normalize-space(), '^[0-9]+$') and u:gln(normalize-space())" flag="fatal">GLN must have a valid format according to GS1 rules.</assert>
    </rule>
    <rule context="cbc:EndpointID[@schemeID = '0208'] | cac:PartyIdentification/cbc:ID[@schemeID = '0208'] | cbc:CompanyID[@schemeID = '0208']">
      <assert id="PEPPOL-COMMON-R043" test="matches(normalize-space(), '^[0-9]{10}$') and u:mod97-0208(normalize-space())" flag="fatal">Belgian enterprise number MUST be stated in the correct format.</assert>
    </rule>	
    <rule context="cbc:EndpointID[@schemeID = '0201'] | cac:PartyIdentification/cbc:ID[@schemeID = '0201'] | cbc:CompanyID[@schemeID = '0201']">
      <assert id="PEPPOL-COMMON-R044" test="u:checkCodiceIPA(normalize-space())" flag="warning">IPA Code (Codice Univoco Unità Organizzativa) must be stated in the correct format</assert>
    </rule>
    <rule context="cbc:EndpointID[@schemeID = '0210'] | cac:PartyIdentification/cbc:ID[@schemeID = '0210'] | cbc:CompanyID[@schemeID = '0210']">
      <assert id="PEPPOL-COMMON-R045" test="u:checkCF(normalize-space())" flag="warning">Tax Code (Codice Fiscale) must be stated in the correct format</assert>
    </rule>
    <rule context="cbc:EndpointID[@schemeID = '9907']">
      <assert id="PEPPOL-COMMON-R046" test="u:checkCF(normalize-space())" flag="warning">Tax Code (Codice Fiscale) must be stated in the correct format</assert>
    </rule>
    <rule context="cbc:EndpointID[@schemeID = '0211'] | cac:PartyIdentification/cbc:ID[@schemeID = '0211'] | cbc:CompanyID[@schemeID = '0211']">
      <assert id="PEPPOL-COMMON-R047" test="u:checkPIVAseIT(normalize-space())" flag="warning">Italian VAT Code (Partita Iva) must be stated in the correct format</assert>
    </rule>
    <rule context="cbc:EndpointID[@schemeID = '9906']">
      <assert id="PEPPOL-COMMON-R048" test="u:checkPIVAseIT(normalize-space())" flag="warning">Italian VAT Code (Partita Iva) must be stated in the correct format</assert>
    </rule>
    <rule context="cbc:EndpointID[@schemeID = '0007'] | cac:PartyIdentification/cbc:ID[@schemeID = '0007'] | cbc:CompanyID[@schemeID = '0007']">
      <assert id="PEPPOL-COMMON-R049" test="string-length(normalize-space()) = 10 and string(number(normalize-space())) != 'NaN'" flag="warning">Swedish organization number MUST be stated in the correct format.</assert>     
    </rule> 
    <rule context="cbc:EndpointID[@schemeID = '0151'] | cac:PartyIdentification/cbc:ID[@schemeID = '0151'] | cbc:CompanyID[@schemeID = '0151']">
      <assert id="PEPPOL-COMMON-R050" test="u:abn(normalize-space())" flag="warning">Australian Business Number (ABN) MUST be stated in the correct format.</assert>
    </rule>

  </pattern>
	<pattern>
	
	<rule context="cbc:CustomizationID">
			<assert id="PEPPOL-T77-R010" test="starts-with(normalize-space(.), 'urn:fdc:peppol.eu:poacc:trns:punch_out:3')" flag="fatal">Specification identifier SHALL start with the value 'urn:fdc:peppol.eu:poacc:trns:punch_out:3'.</assert>
	</rule>

	<rule context="ubl:Catalogue/cac:ValidityPeriod">
		<assert id="PEPPOL-T77-R001" test="(cbc:EndDate) and (number(translate(cbc:EndDate,'-','')) &gt;= number(translate(../cbc:IssueDate,'-','')))" flag="fatal">The validity period end date SHALL NOT be earlier than the issue date.</assert>
	</rule>

	<rule context="cac:RequiredItemLocationQuantity/cac:Price">
		<assert id="PEPPOL-T77-R003" test="number(cbc:PriceAmount) &gt;=0" flag="fatal">Prices of items SHALL not be negative</assert>
	</rule>

	<rule context="cac:Item">
		<assert id="PEPPOL-T77-R004" test="(cac:StandardItemIdentification/cbc:ID) or  (cac:SellersItemIdentification/cbc:ID)" flag="fatal">Each item in a shopping cart line SHALL be identifiable by either "item sellers identifier" or "item standard identifier"</assert>
		<assert id="PEPPOL-T77-R005" test="(count(cac:ItemSpecificationDocumentReference[cbc:DocumentTypeCode = 'PRODUCT_IMAGE']) &lt;= 1)" flag="fatal">Only one attachment may be identified as main image.</assert>
	</rule>

	<rule context="cac:CatalogueLine/cac:RequiredItemLocationQuantity">
		<assert id="PEPPOL-T77-R006" test="(cac:Price/cbc:BaseQuantity/@unitCode) = (cac:DeliveryUnit/cbc:BatchQuantity/@unitCode) or (not(cac:Price/cbc:BaseQuantity)) or (not(cac:DeliveryUnit/cbc:BatchQuantity))" flag="fatal">Unit code for price base quantity SHALL be same as for batch quantity.</assert>
		<assert id="PEPPOL-T77-R002" test="(number(cac:Price/cbc:BaseQuantity) &gt; 0) and (number(cac:DeliveryUnit/cbc:BatchQuantity) &gt; 0) or (not(cac:Price/cbc:BaseQuantity)) or (not(cac:DeliveryUnit/cbc:BatchQuantity))" flag="fatal">Shopping cart line quantities SHALL be greater than ZERO.</assert>
	</rule>

	<rule context="cac:Item/cac:AdditionalItemProperty[cbc:Name = 'ServiceIndicator']">
		<assert id="PEPPOL-T77-R007" test="(cbc:Value = 'true' or cbc:Value = 'false')" flag="fatal">For AdditionalItemProperties where name is ServiceIndicator the value may only be "true" or "false".</assert>
	</rule>

	<rule context="cac:ClassifiedTaxCategory">
		<assert id="PEPPOL-T77-R008" test="cbc:Percent or (normalize-space(cbc:ID)='O')" flag="fatal">Each Tax Category SHALL have a TAX category rate, except if the shopping cart is not subject to TAX.</assert>
		<assert id="PEPPOL-T77-R009" test="not(normalize-space(cbc:ID)='S') or (cbc:Percent) &gt; 0" flag="fatal">When TAX category code is "Standard rated" (S) the TAX rate SHALL be greater than zero.</assert>
	</rule>
	
</pattern>
	<pattern>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]">
    <assert id="EHF-QII-G1-R000001" flag="fatal" test="cbc:Name">Property 'Name' is mandatory.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']"/>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cbc:Name">
    <assert id="EHF-QII-G1-R000002" flag="fatal" test="normalize-space()">Property 'Name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000003" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cbc:Description">
    <assert id="EHF-QII-G1-R000004" flag="fatal" test="normalize-space()">Property 'Description' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cbc:Keyword">
    <assert id="EHF-QII-G1-R000005" flag="fatal" test="normalize-space()">Property 'Keywords' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cbc:BrandName">
    <assert id="EHF-QII-G1-R000006" flag="fatal" test="normalize-space()">Property 'Brand name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000007" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Brand name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cbc:PackQuantity">
    <assert id="EHF-QII-G1-R000008" flag="fatal" test="normalize-space()">Property 'Packed quantity' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cbc:PackSizeNumeric">
    <assert id="EHF-QII-G1-R000009" flag="fatal" test="normalize-space()">Property 'Consumable unit' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cac:BuyersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000010" flag="fatal" test="normalize-space()">Property 'Buyers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cac:SellersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000011" flag="fatal" test="normalize-space()">Property 'Sellers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cac:ManufacturersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000012" flag="fatal" test="normalize-space()">Property 'Manufacturers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cac:StandardItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000013" flag="fatal" test="normalize-space()">Property 'Standard item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cac:CommodityClassification/cbc:ItemClassificationCode">
    <assert id="EHF-QII-G1-R000014" flag="fatal" test="normalize-space()">Property 'Classification code' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cac:OriginCountry/cbc:IdentificationCode">
    <assert id="EHF-QII-G1-R000015" flag="fatal" test="normalize-space()">Property 'Origin country' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cac:ItemInstance/cbc:BestBeforeDate">
    <assert id="EHF-QII-G1-R000016" flag="fatal" test="normalize-space()">Property 'Best before date' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000017" flag="fatal" test="not(normalize-space()) or (normalize-space() castable as xs:date)">Property 'Best before date' value must be a valid date.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cac:ItemInstance/cac:LotIdentification/cbc:LotNumberID">
    <assert id="EHF-QII-G1-R000018" flag="fatal" test="normalize-space()">Property 'Lot number' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#used']]">
    <assert id="EHF-QII-G1-R000019" flag="fatal" test="normalize-space(cbc:Name) = 'Used'">Property 'Used' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000020" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Used' may be used.</assert>
    <assert id="EHF-QII-G1-R000021" flag="fatal" test="normalize-space(cbc:Value)">Property 'Used' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]">
    <assert id="EHF-QII-G1-R000022" flag="fatal" test="cbc:Name">Property 'Name' is mandatory.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']"/>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cbc:Name">
    <assert id="EHF-QII-G1-R000023" flag="fatal" test="normalize-space()">Property 'Name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000024" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cbc:Description">
    <assert id="EHF-QII-G1-R000025" flag="fatal" test="normalize-space()">Property 'Description' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cbc:Keyword">
    <assert id="EHF-QII-G1-R000026" flag="fatal" test="normalize-space()">Property 'Keywords' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cbc:BrandName">
    <assert id="EHF-QII-G1-R000027" flag="fatal" test="normalize-space()">Property 'Brand name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000028" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Brand name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cbc:PackQuantity">
    <assert id="EHF-QII-G1-R000029" flag="fatal" test="normalize-space()">Property 'Packed quantity' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cbc:PackSizeNumeric">
    <assert id="EHF-QII-G1-R000030" flag="fatal" test="normalize-space()">Property 'Consumable unit' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:BuyersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000031" flag="fatal" test="normalize-space()">Property 'Buyers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:SellersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000032" flag="fatal" test="normalize-space()">Property 'Sellers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:ManufacturersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000033" flag="fatal" test="normalize-space()">Property 'Manufacturers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:StandardItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000034" flag="fatal" test="normalize-space()">Property 'Standard item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:CommodityClassification/cbc:ItemClassificationCode">
    <assert id="EHF-QII-G1-R000035" flag="fatal" test="normalize-space()">Property 'Classification code' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:OriginCountry/cbc:IdentificationCode">
    <assert id="EHF-QII-G1-R000036" flag="fatal" test="normalize-space()">Property 'Origin country' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:ItemInstance/cbc:BestBeforeDate">
    <assert id="EHF-QII-G1-R000037" flag="fatal" test="normalize-space()">Property 'Best before date' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000038" flag="fatal" test="not(normalize-space()) or (normalize-space() castable as xs:date)">Property 'Best before date' value must be a valid date.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:ItemInstance/cac:LotIdentification/cbc:LotNumberID">
    <assert id="EHF-QII-G1-R000039" flag="fatal" test="normalize-space()">Property 'Lot number' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Beskrivelse']]">
    <assert id="EHF-QII-G1-R000040" flag="fatal" test="normalize-space(cbc:Name) = 'Produktnavn'">Property 'Produktnavn' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000041" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produktnavn' may be used.</assert>
    <assert id="EHF-QII-G1-R000042" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produktnavn' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000043" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Produktnavn' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseEngelsk']]">
    <assert id="EHF-QII-G1-R000044" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse [Engelsk]'">Property 'Beskrivelse [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000045" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R000046" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000047" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Beskrivelse [Engelsk]' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseUmerkedeSalgsenheter']]">
    <assert id="EHF-QII-G1-R000048" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse umerkede salgsenheter'">Property 'Beskrivelse umerkede salgsenheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000049" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse umerkede salgsenheter' may be used.</assert>
    <assert id="EHF-QII-G1-R000050" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse umerkede salgsenheter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Informasjonstekst']]">
    <assert id="EHF-QII-G1-R000051" flag="fatal" test="normalize-space(cbc:Name) = 'Informasjonstekst'">Property 'Informasjonstekst' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000052" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Informasjonstekst' may be used.</assert>
    <assert id="EHF-QII-G1-R000053" flag="fatal" test="normalize-space(cbc:Value)">Property 'Informasjonstekst' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000054" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Informasjonstekst' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#InformasjonstekstEngelsk']]">
    <assert id="EHF-QII-G1-R000055" flag="fatal" test="normalize-space(cbc:Name) = 'Informasjonstekst [Engelsk]'">Property 'Informasjonstekst [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000056" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Informasjonstekst [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R000057" flag="fatal" test="normalize-space(cbc:Value)">Property 'Informasjonstekst [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000058" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Informasjonstekst [Engelsk]' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MVAKode']]">
    <assert id="EHF-QII-G1-R000059" flag="fatal" test="normalize-space(cbc:Name) = 'Mva sats'">Property 'Mva sats' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000060" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Mva sats' may be used.</assert>
    <assert id="EHF-QII-G1-R000061" flag="fatal" test="normalize-space(cbc:Value)">Property 'Mva sats' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Varemerke']]">
    <assert id="EHF-QII-G1-R000062" flag="fatal" test="normalize-space(cbc:Name) = 'Varemerke'">Property 'Varemerke' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000063" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varemerke' may be used.</assert>
    <assert id="EHF-QII-G1-R000064" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varemerke' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000065" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Varemerke' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AttributtverdiID']]">
    <assert id="EHF-QII-G1-R000066" flag="fatal" test="normalize-space(cbc:Name) = 'Varegruppe attributter'">Property 'Varegruppe attributter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000067" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varegruppe attributter' may be used.</assert>
    <assert id="EHF-QII-G1-R000068" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varegruppe attributter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#VaregruppeID']]">
    <assert id="EHF-QII-G1-R000069" flag="fatal" test="normalize-space(cbc:Name) = 'Varegruppe'">Property 'Varegruppe' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000070" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varegruppe' may be used.</assert>
    <assert id="EHF-QII-G1-R000071" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varegruppe' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Egenskaper']]">
    <assert id="EHF-QII-G1-R000072" flag="fatal" test="normalize-space(cbc:Name) = 'Egenskaper'">Property 'Egenskaper' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000073" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Egenskaper' may be used.</assert>
    <assert id="EHF-QII-G1-R000074" flag="fatal" test="normalize-space(cbc:Value)">Property 'Egenskaper' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000075" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Egenskaper' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EgenskaperEngelsk']]">
    <assert id="EHF-QII-G1-R000076" flag="fatal" test="normalize-space(cbc:Name) = 'Egenskaper [Engelsk]'">Property 'Egenskaper [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000077" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Egenskaper [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R000078" flag="fatal" test="normalize-space(cbc:Value)">Property 'Egenskaper [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000079" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Egenskaper [Engelsk]' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErForbrukerpakning']]">
    <assert id="EHF-QII-G1-R000080" flag="fatal" test="normalize-space(cbc:Name) = 'ErForbrukerpakning'">Property 'ErForbrukerpakning' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000081" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'ErForbrukerpakning' may be used.</assert>
    <assert id="EHF-QII-G1-R000082" flag="fatal" test="normalize-space(cbc:Value)">Property 'ErForbrukerpakning' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#GS1Databaarer']]">
    <assert id="EHF-QII-G1-R000083" flag="fatal" test="normalize-space(cbc:Name) = 'GS1 Databær'">Property 'GS1 Databær' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000084" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'GS1 Databær' may be used.</assert>
    <assert id="EHF-QII-G1-R000085" flag="fatal" test="normalize-space(cbc:Value)">Property 'GS1 Databær' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Markedsnavn']]">
    <assert id="EHF-QII-G1-R000086" flag="fatal" test="normalize-space(cbc:Name) = 'Fullstendig produktnavn'">Property 'Fullstendig produktnavn' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000087" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Fullstendig produktnavn' may be used.</assert>
    <assert id="EHF-QII-G1-R000088" flag="fatal" test="normalize-space(cbc:Value)">Property 'Fullstendig produktnavn' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000089" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Fullstendig produktnavn' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MarkedsnavnEngelsk']]">
    <assert id="EHF-QII-G1-R000090" flag="fatal" test="normalize-space(cbc:Name) = 'Fullstendig produktnavn [Engelsk]'">Property 'Fullstendig produktnavn [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000091" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Fullstendig produktnavn [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R000092" flag="fatal" test="normalize-space(cbc:Value)">Property 'Fullstendig produktnavn [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000093" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Fullstendig produktnavn [Engelsk]' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EPDnr']]">
    <assert id="EHF-QII-G1-R000094" flag="fatal" test="normalize-space(cbc:Name) = 'EPDnr'">Property 'EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000095" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R000096" flag="fatal" test="normalize-space(cbc:Value)">Property 'EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErstattetAvProduktID']]">
    <assert id="EHF-QII-G1-R000097" flag="fatal" test="normalize-space(cbc:Name) = 'Erstattet av EPDnr'">Property 'Erstattet av EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000098" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Erstattet av EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R000099" flag="fatal" test="normalize-space(cbc:Value)">Property 'Erstattet av EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LeverandorVarenr']]">
    <assert id="EHF-QII-G1-R000100" flag="fatal" test="normalize-space(cbc:Name) = 'Leverandør varenr'">Property 'Leverandør varenr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000101" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Leverandør varenr' may be used.</assert>
    <assert id="EHF-QII-G1-R000102" flag="fatal" test="normalize-space(cbc:Value)">Property 'Leverandør varenr' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000103" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Leverandør varenr' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MottakerTilgang']]">
    <assert id="EHF-QII-G1-R000104" flag="fatal" test="normalize-space(cbc:Name) = 'Mottaker tilgang'">Property 'Mottaker tilgang' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000105" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Mottaker tilgang' may be used.</assert>
    <assert id="EHF-QII-G1-R000106" flag="fatal" test="normalize-space(cbc:Value)">Property 'Mottaker tilgang' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000107" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Mottaker tilgang' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProdusentVarenr']]">
    <assert id="EHF-QII-G1-R000108" flag="fatal" test="normalize-space(cbc:Name) = 'Produsent varenr'">Property 'Produsent varenr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000109" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produsent varenr' may be used.</assert>
    <assert id="EHF-QII-G1-R000110" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produsent varenr' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000111" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Produsent varenr' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#TilgjengeligFraDato']]">
    <assert id="EHF-QII-G1-R000112" flag="fatal" test="normalize-space(cbc:Name) = 'Tilgjengelig fra dato'">Property 'Tilgjengelig fra dato' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000113" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Tilgjengelig fra dato' may be used.</assert>
    <assert id="EHF-QII-G1-R000114" flag="fatal" test="normalize-space(cbc:Value)">Property 'Tilgjengelig fra dato' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ikke_fysiske_varer']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErBestillbar']]">
    <assert id="EHF-QII-G1-R000115" flag="fatal" test="normalize-space(cbc:Name) = 'Bestillbar'">Property 'Bestillbar' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000116" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Bestillbar' may be used.</assert>
    <assert id="EHF-QII-G1-R000117" flag="fatal" test="normalize-space(cbc:Value)">Property 'Bestillbar' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]">
    <assert id="EHF-QII-G1-R000118" flag="fatal" test="cbc:Name">Property 'Name' is mandatory.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']"/>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cbc:Name">
    <assert id="EHF-QII-G1-R000119" flag="fatal" test="normalize-space()">Property 'Name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000120" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cbc:Description">
    <assert id="EHF-QII-G1-R000121" flag="fatal" test="normalize-space()">Property 'Description' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cbc:Keyword">
    <assert id="EHF-QII-G1-R000122" flag="fatal" test="normalize-space()">Property 'Keywords' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cbc:BrandName">
    <assert id="EHF-QII-G1-R000123" flag="fatal" test="normalize-space()">Property 'Brand name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000124" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Brand name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cbc:PackQuantity">
    <assert id="EHF-QII-G1-R000125" flag="fatal" test="normalize-space()">Property 'Packed quantity' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cbc:PackSizeNumeric">
    <assert id="EHF-QII-G1-R000126" flag="fatal" test="normalize-space()">Property 'Consumable unit' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:BuyersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000127" flag="fatal" test="normalize-space()">Property 'Buyers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:SellersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000128" flag="fatal" test="normalize-space()">Property 'Sellers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:ManufacturersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000129" flag="fatal" test="normalize-space()">Property 'Manufacturers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:StandardItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000130" flag="fatal" test="normalize-space()">Property 'Standard item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:CommodityClassification/cbc:ItemClassificationCode">
    <assert id="EHF-QII-G1-R000131" flag="fatal" test="normalize-space()">Property 'Classification code' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:OriginCountry/cbc:IdentificationCode">
    <assert id="EHF-QII-G1-R000132" flag="fatal" test="normalize-space()">Property 'Origin country' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:ItemInstance/cbc:BestBeforeDate">
    <assert id="EHF-QII-G1-R000133" flag="fatal" test="normalize-space()">Property 'Best before date' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000134" flag="fatal" test="not(normalize-space()) or (normalize-space() castable as xs:date)">Property 'Best before date' value must be a valid date.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:ItemInstance/cac:LotIdentification/cbc:LotNumberID">
    <assert id="EHF-QII-G1-R000135" flag="fatal" test="normalize-space()">Property 'Lot number' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AldersgrenseKode']]">
    <assert id="EHF-QII-G1-R000136" flag="fatal" test="normalize-space(cbc:Name) = 'Aldersgrense'">Property 'Aldersgrense' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000137" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Aldersgrense' may be used.</assert>
    <assert id="EHF-QII-G1-R000138" flag="fatal" test="normalize-space(cbc:Value)">Property 'Aldersgrense' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Beskrivelse']]">
    <assert id="EHF-QII-G1-R000139" flag="fatal" test="normalize-space(cbc:Name) = 'Produktnavn'">Property 'Produktnavn' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000140" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produktnavn' may be used.</assert>
    <assert id="EHF-QII-G1-R000141" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produktnavn' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000142" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Produktnavn' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseEngelsk']]">
    <assert id="EHF-QII-G1-R000143" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse [Engelsk]'">Property 'Beskrivelse [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000144" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R000145" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000146" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Beskrivelse [Engelsk]' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseUmerkedeEnheter']]">
    <assert id="EHF-QII-G1-R000147" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse umerkede enheter'">Property 'Beskrivelse umerkede enheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000148" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse umerkede enheter' may be used.</assert>
    <assert id="EHF-QII-G1-R000149" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse umerkede enheter' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000150" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Beskrivelse umerkede enheter' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseUmerkedeSalgsenheter']]">
    <assert id="EHF-QII-G1-R000151" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse umerkede salgsenheter'">Property 'Beskrivelse umerkede salgsenheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000152" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse umerkede salgsenheter' may be used.</assert>
    <assert id="EHF-QII-G1-R000153" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse umerkede salgsenheter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErMerketMedUtsalgspris']]">
    <assert id="EHF-QII-G1-R000154" flag="fatal" test="normalize-space(cbc:Name) = 'Merket med utsalgspris'">Property 'Merket med utsalgspris' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000155" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Merket med utsalgspris' may be used.</assert>
    <assert id="EHF-QII-G1-R000156" flag="fatal" test="normalize-space(cbc:Value)">Property 'Merket med utsalgspris' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErStorhusholdningsprodukt']]">
    <assert id="EHF-QII-G1-R000157" flag="fatal" test="normalize-space(cbc:Name) = 'Storhusholdningsprodukt'">Property 'Storhusholdningsprodukt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000158" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Storhusholdningsprodukt' may be used.</assert>
    <assert id="EHF-QII-G1-R000159" flag="fatal" test="normalize-space(cbc:Value)">Property 'Storhusholdningsprodukt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Fyllingsgrad']]">
    <assert id="EHF-QII-G1-R000160" flag="fatal" test="normalize-space(cbc:Name) = 'Fyllingsgrad'">Property 'Fyllingsgrad' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000161" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Fyllingsgrad'.</assert>
    <assert id="EHF-QII-G1-R000162" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Fyllingsgrad' may be used.</assert>
    <assert id="EHF-QII-G1-R000163" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Fyllingsgrad' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000164" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Fyllingsgrad' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilDetaljist']]">
    <assert id="EHF-QII-G1-R000165" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til detaljist'">Property 'Holdbarhetsdager til detaljist' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000166" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til detaljist' may be used.</assert>
    <assert id="EHF-QII-G1-R000167" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til detaljist' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilDistributor']]">
    <assert id="EHF-QII-G1-R000168" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til distributør'">Property 'Holdbarhetsdager til distributør' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000169" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til distributør' may be used.</assert>
    <assert id="EHF-QII-G1-R000170" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til distributør' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilProdusent']]">
    <assert id="EHF-QII-G1-R000171" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til produsent'">Property 'Holdbarhetsdager til produsent' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000172" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til produsent' may be used.</assert>
    <assert id="EHF-QII-G1-R000173" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til produsent' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTotalt']]">
    <assert id="EHF-QII-G1-R000174" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager totalt'">Property 'Holdbarhetsdager totalt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000175" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager totalt' may be used.</assert>
    <assert id="EHF-QII-G1-R000176" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager totalt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Informasjonstekst']]">
    <assert id="EHF-QII-G1-R000177" flag="fatal" test="normalize-space(cbc:Name) = 'Informasjonstekst'">Property 'Informasjonstekst' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000178" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Informasjonstekst' may be used.</assert>
    <assert id="EHF-QII-G1-R000179" flag="fatal" test="normalize-space(cbc:Value)">Property 'Informasjonstekst' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000180" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Informasjonstekst' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#InformasjonstekstEngelsk']]">
    <assert id="EHF-QII-G1-R000181" flag="fatal" test="normalize-space(cbc:Name) = 'Informasjonstekst [Engelsk]'">Property 'Informasjonstekst [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000182" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Informasjonstekst [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R000183" flag="fatal" test="normalize-space(cbc:Value)">Property 'Informasjonstekst [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000184" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Informasjonstekst [Engelsk]' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Legitimasjonskrav']]">
    <assert id="EHF-QII-G1-R000185" flag="fatal" test="normalize-space(cbc:Name) = 'Legitimasjonskrav'">Property 'Legitimasjonskrav' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000186" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Legitimasjonskrav' may be used.</assert>
    <assert id="EHF-QII-G1-R000187" flag="fatal" test="normalize-space(cbc:Value)">Property 'Legitimasjonskrav' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MaksimumstemperaturCelcius']]">
    <assert id="EHF-QII-G1-R000188" flag="fatal" test="normalize-space(cbc:Name) = 'Maksimumstemperatur'">Property 'Maksimumstemperatur' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000189" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Maksimumstemperatur'.</assert>
    <assert id="EHF-QII-G1-R000190" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Maksimumstemperatur' may be used.</assert>
    <assert id="EHF-QII-G1-R000191" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Maksimumstemperatur' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000192" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Maksimumstemperatur' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Mengde']]">
    <assert id="EHF-QII-G1-R000193" flag="fatal" test="normalize-space(cbc:Name) = 'Mengde'">Property 'Mengde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000194" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Mengde'.</assert>
    <assert id="EHF-QII-G1-R000195" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Mengde' may be used.</assert>
    <assert id="EHF-QII-G1-R000196" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Mengde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000197" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Mengde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Mengdetypeenhet']]">
    <assert id="EHF-QII-G1-R000198" flag="fatal" test="normalize-space(cbc:Name) = 'Enhet til mengde'">Property 'Enhet til mengde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000199" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Enhet til mengde' may be used.</assert>
    <assert id="EHF-QII-G1-R000200" flag="fatal" test="normalize-space(cbc:Value)">Property 'Enhet til mengde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MerketMedEgenskaper']]">
    <assert id="EHF-QII-G1-R000201" flag="fatal" test="normalize-space(cbc:Name) = 'Er produktet merket med en eller flere egenskaper?'">Property 'Er produktet merket med en eller flere egenskaper?' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000202" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Er produktet merket med en eller flere egenskaper?' may be used.</assert>
    <assert id="EHF-QII-G1-R000203" flag="fatal" test="normalize-space(cbc:Value)">Property 'Er produktet merket med en eller flere egenskaper?' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MinimumstemperaturCelsius']]">
    <assert id="EHF-QII-G1-R000204" flag="fatal" test="normalize-space(cbc:Name) = 'Minimumstemperatur'">Property 'Minimumstemperatur' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000205" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Minimumstemperatur'.</assert>
    <assert id="EHF-QII-G1-R000206" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Minimumstemperatur' may be used.</assert>
    <assert id="EHF-QII-G1-R000207" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Minimumstemperatur' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000208" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Minimumstemperatur' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MVAKode']]">
    <assert id="EHF-QII-G1-R000209" flag="fatal" test="normalize-space(cbc:Name) = 'Mva sats'">Property 'Mva sats' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000210" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Mva sats' may be used.</assert>
    <assert id="EHF-QII-G1-R000211" flag="fatal" test="normalize-space(cbc:Value)">Property 'Mva sats' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Nettovekt']]">
    <assert id="EHF-QII-G1-R000212" flag="fatal" test="normalize-space(cbc:Name) = 'Nettovekt'">Property 'Nettovekt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000213" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Nettovekt'.</assert>
    <assert id="EHF-QII-G1-R000214" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Nettovekt' may be used.</assert>
    <assert id="EHF-QII-G1-R000215" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Nettovekt' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000216" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Nettovekt' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#OpprinnelseOgOpphav']]">
    <assert id="EHF-QII-G1-R000217" flag="fatal" test="normalize-space(cbc:Name) = 'Opprinnelsesland/Opphavssted hovedingrediens(er)'">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000218" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' may be used.</assert>
    <assert id="EHF-QII-G1-R000219" flag="fatal" test="normalize-space(cbc:Value)">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000220" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 200">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' value must have a length of maximum 200 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Produksjonsland']]">
    <assert id="EHF-QII-G1-R000221" flag="fatal" test="normalize-space(cbc:Name) = 'Produksjonsland'">Property 'Produksjonsland' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000222" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produksjonsland' may be used.</assert>
    <assert id="EHF-QII-G1-R000223" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produksjonsland' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProduktmerkingEgenskaper']]">
    <assert id="EHF-QII-G1-R000224" flag="fatal" test="normalize-space(cbc:Name) = 'Produktmerking egenskaper'">Property 'Produktmerking egenskaper' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000225" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produktmerking egenskaper' may be used.</assert>
    <assert id="EHF-QII-G1-R000226" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produktmerking egenskaper' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Stablingsfaktor']]">
    <assert id="EHF-QII-G1-R000227" flag="fatal" test="normalize-space(cbc:Name) = 'Stablingsfaktor'">Property 'Stablingsfaktor' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000228" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Stablingsfaktor'.</assert>
    <assert id="EHF-QII-G1-R000229" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Stablingsfaktor' may be used.</assert>
    <assert id="EHF-QII-G1-R000230" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Stablingsfaktor' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000231" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Stablingsfaktor' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Varemerke']]">
    <assert id="EHF-QII-G1-R000232" flag="fatal" test="normalize-space(cbc:Name) = 'Varemerke'">Property 'Varemerke' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000233" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varemerke' may be used.</assert>
    <assert id="EHF-QII-G1-R000234" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varemerke' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000235" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Varemerke' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AttributtverdiID']]">
    <assert id="EHF-QII-G1-R000236" flag="fatal" test="normalize-space(cbc:Name) = 'Varegruppe attributter'">Property 'Varegruppe attributter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000237" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varegruppe attributter' may be used.</assert>
    <assert id="EHF-QII-G1-R000238" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varegruppe attributter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PakningID']]">
    <assert id="EHF-QII-G1-R000239" flag="fatal" test="normalize-space(cbc:Name) = 'Sertifiseringer'">Property 'Sertifiseringer' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000240" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Sertifiseringer' may be used.</assert>
    <assert id="EHF-QII-G1-R000241" flag="fatal" test="normalize-space(cbc:Value)">Property 'Sertifiseringer' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#VaregruppeID']]">
    <assert id="EHF-QII-G1-R000242" flag="fatal" test="normalize-space(cbc:Name) = 'Varegruppe'">Property 'Varegruppe' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000243" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varegruppe' may be used.</assert>
    <assert id="EHF-QII-G1-R000244" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varegruppe' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Aldersgruppe']]">
    <assert id="EHF-QII-G1-R000245" flag="fatal" test="normalize-space(cbc:Name) = 'Aldersgruppe'">Property 'Aldersgruppe' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000246" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Aldersgruppe' may be used.</assert>
    <assert id="EHF-QII-G1-R000247" flag="fatal" test="normalize-space(cbc:Value)">Property 'Aldersgruppe' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000248" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Aldersgruppe' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallEnheterSamtidig']]">
    <assert id="EHF-QII-G1-R000249" flag="fatal" test="normalize-space(cbc:Name) = 'Antall forbrukerenheter som kan selges samtidig ut av kasse'">Property 'Antall forbrukerenheter som kan selges samtidig ut av kasse' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000250" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall forbrukerenheter som kan selges samtidig ut av kasse' may be used.</assert>
    <assert id="EHF-QII-G1-R000251" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall forbrukerenheter som kan selges samtidig ut av kasse' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MengdeVirkestoff']]">
    <assert id="EHF-QII-G1-R000252" flag="fatal" test="normalize-space(cbc:Name) = 'Mengde virkestoff'">Property 'Mengde virkestoff' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000253" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Mengde virkestoff'.</assert>
    <assert id="EHF-QII-G1-R000254" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Mengde virkestoff' may be used.</assert>
    <assert id="EHF-QII-G1-R000255" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Mengde virkestoff' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000256" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Mengde virkestoff' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NAFNr']]">
    <assert id="EHF-QII-G1-R000257" flag="fatal" test="normalize-space(cbc:Name) = 'Varenummer'">Property 'Varenummer' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000258" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varenummer' may be used.</assert>
    <assert id="EHF-QII-G1-R000259" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varenummer' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000260" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Varenummer' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#VirkestoffLegemiddelEnhetKode']]">
    <assert id="EHF-QII-G1-R000261" flag="fatal" test="normalize-space(cbc:Name) = 'Virkestoff legemiddelenhet'">Property 'Virkestoff legemiddelenhet' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000262" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Virkestoff legemiddelenhet' may be used.</assert>
    <assert id="EHF-QII-G1-R000263" flag="fatal" test="normalize-space(cbc:Value)">Property 'Virkestoff legemiddelenhet' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#VirkestoffLegemiddelKode']]">
    <assert id="EHF-QII-G1-R000264" flag="fatal" test="normalize-space(cbc:Name) = 'Virkestoff legemiddel'">Property 'Virkestoff legemiddel' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000265" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Virkestoff legemiddel' may be used.</assert>
    <assert id="EHF-QII-G1-R000266" flag="fatal" test="normalize-space(cbc:Value)">Property 'Virkestoff legemiddel' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Antall']]">
    <assert id="EHF-QII-G1-R000267" flag="fatal" test="normalize-space(cbc:Name) = 'Antall'">Property 'Antall' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000268" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall' may be used.</assert>
    <assert id="EHF-QII-G1-R000269" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallAvPant']]">
    <assert id="EHF-QII-G1-R000270" flag="fatal" test="normalize-space(cbc:Name) = 'Antall av pant'">Property 'Antall av pant' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000271" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall av pant' may be used.</assert>
    <assert id="EHF-QII-G1-R000272" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall av pant' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriBredden']]">
    <assert id="EHF-QII-G1-R000273" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i bredde'">Property 'Antall basispakninger i bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000274" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R000275" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i bredde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriDybden']]">
    <assert id="EHF-QII-G1-R000276" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i dybde'">Property 'Antall basispakninger i dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000277" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R000278" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i dybde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriHoyden']]">
    <assert id="EHF-QII-G1-R000279" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i høyde'">Property 'Antall basispakninger i høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000280" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R000281" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i høyde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallLag']]">
    <assert id="EHF-QII-G1-R000282" flag="fatal" test="normalize-space(cbc:Name) = 'Antall lag'">Property 'Antall lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000283" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall lag' may be used.</assert>
    <assert id="EHF-QII-G1-R000284" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall lag' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallPrLag']]">
    <assert id="EHF-QII-G1-R000285" flag="fatal" test="normalize-space(cbc:Name) = 'Antall pr lag'">Property 'Antall pr lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000286" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall pr lag' may be used.</assert>
    <assert id="EHF-QII-G1-R000287" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall pr lag' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AvvikendePakkemonster']]">
    <assert id="EHF-QII-G1-R000288" flag="fatal" test="normalize-space(cbc:Name) = 'Avvikende pakkemønster'">Property 'Avvikende pakkemønster' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000289" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Avvikende pakkemønster' may be used.</assert>
    <assert id="EHF-QII-G1-R000290" flag="fatal" test="normalize-space(cbc:Value)">Property 'Avvikende pakkemønster' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Bredde']]">
    <assert id="EHF-QII-G1-R000291" flag="fatal" test="normalize-space(cbc:Name) = 'Bredde'">Property 'Bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000292" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Bredde'.</assert>
    <assert id="EHF-QII-G1-R000293" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R000294" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Bredde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000295" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Bredde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Bruttovekt']]">
    <assert id="EHF-QII-G1-R000296" flag="fatal" test="normalize-space(cbc:Name) = 'Bruttovekt'">Property 'Bruttovekt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000297" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Bruttovekt'.</assert>
    <assert id="EHF-QII-G1-R000298" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Bruttovekt' may be used.</assert>
    <assert id="EHF-QII-G1-R000299" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Bruttovekt' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000300" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Bruttovekt' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Dybde']]">
    <assert id="EHF-QII-G1-R000301" flag="fatal" test="normalize-space(cbc:Name) = 'Dybde'">Property 'Dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000302" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Dybde'.</assert>
    <assert id="EHF-QII-G1-R000303" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R000304" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Dybde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000305" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Dybde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Egenskaper']]">
    <assert id="EHF-QII-G1-R000306" flag="fatal" test="normalize-space(cbc:Name) = 'Egenskaper'">Property 'Egenskaper' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000307" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Egenskaper' may be used.</assert>
    <assert id="EHF-QII-G1-R000308" flag="fatal" test="normalize-space(cbc:Value)">Property 'Egenskaper' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000309" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Egenskaper' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EgenskaperEngelsk']]">
    <assert id="EHF-QII-G1-R000310" flag="fatal" test="normalize-space(cbc:Name) = 'Egenskaper [Engelsk]'">Property 'Egenskaper [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000311" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Egenskaper [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R000312" flag="fatal" test="normalize-space(cbc:Value)">Property 'Egenskaper [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000313" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Egenskaper [Engelsk]' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Emballasjekode']]">
    <assert id="EHF-QII-G1-R000314" flag="fatal" test="normalize-space(cbc:Name) = 'Emballasje'">Property 'Emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000315" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R000316" flag="fatal" test="normalize-space(cbc:Value)">Property 'Emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErForbrukerpakning']]">
    <assert id="EHF-QII-G1-R000317" flag="fatal" test="normalize-space(cbc:Name) = 'ErForbrukerpakning'">Property 'ErForbrukerpakning' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000318" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'ErForbrukerpakning' may be used.</assert>
    <assert id="EHF-QII-G1-R000319" flag="fatal" test="normalize-space(cbc:Value)">Property 'ErForbrukerpakning' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#GS1Databaarer']]">
    <assert id="EHF-QII-G1-R000320" flag="fatal" test="normalize-space(cbc:Name) = 'GS1 Databær'">Property 'GS1 Databær' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000321" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'GS1 Databær' may be used.</assert>
    <assert id="EHF-QII-G1-R000322" flag="fatal" test="normalize-space(cbc:Value)">Property 'GS1 Databær' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Hoyde']]">
    <assert id="EHF-QII-G1-R000323" flag="fatal" test="normalize-space(cbc:Name) = 'Høyde'">Property 'Høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000324" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Høyde'.</assert>
    <assert id="EHF-QII-G1-R000325" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R000326" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Høyde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000327" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Høyde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoydePrLag']]">
    <assert id="EHF-QII-G1-R000328" flag="fatal" test="normalize-space(cbc:Name) = 'Høyde pr lag'">Property 'Høyde pr lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000329" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Høyde pr lag'.</assert>
    <assert id="EHF-QII-G1-R000330" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Høyde pr lag' may be used.</assert>
    <assert id="EHF-QII-G1-R000331" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Høyde pr lag' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000332" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Høyde pr lag' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LastbaererKode']]">
    <assert id="EHF-QII-G1-R000333" flag="fatal" test="normalize-space(cbc:Name) = 'Lastbærer'">Property 'Lastbærer' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000334" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Lastbærer' may be used.</assert>
    <assert id="EHF-QII-G1-R000335" flag="fatal" test="normalize-space(cbc:Value)">Property 'Lastbærer' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Markedsnavn']]">
    <assert id="EHF-QII-G1-R000336" flag="fatal" test="normalize-space(cbc:Name) = 'Fullstendig produktnavn'">Property 'Fullstendig produktnavn' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000337" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Fullstendig produktnavn' may be used.</assert>
    <assert id="EHF-QII-G1-R000338" flag="fatal" test="normalize-space(cbc:Value)">Property 'Fullstendig produktnavn' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000339" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Fullstendig produktnavn' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MarkedsnavnEngelsk']]">
    <assert id="EHF-QII-G1-R000340" flag="fatal" test="normalize-space(cbc:Name) = 'Fullstendig produktnavn [Engelsk]'">Property 'Fullstendig produktnavn [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000341" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Fullstendig produktnavn [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R000342" flag="fatal" test="normalize-space(cbc:Value)">Property 'Fullstendig produktnavn [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000343" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Fullstendig produktnavn [Engelsk]' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MaxTopplast']]">
    <assert id="EHF-QII-G1-R000344" flag="fatal" test="normalize-space(cbc:Name) = 'Max topplast'">Property 'Max topplast' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000345" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Max topplast'.</assert>
    <assert id="EHF-QII-G1-R000346" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Max topplast' may be used.</assert>
    <assert id="EHF-QII-G1-R000347" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Max topplast' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000348" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Max topplast' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PantGTIN']]">
    <assert id="EHF-QII-G1-R000349" flag="fatal" test="normalize-space(cbc:Name) = 'Pant GTIN'">Property 'Pant GTIN' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000350" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Pant GTIN' may be used.</assert>
    <assert id="EHF-QII-G1-R000351" flag="fatal" test="normalize-space(cbc:Value)">Property 'Pant GTIN' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ResirkulerbarEmballasje']]">
    <assert id="EHF-QII-G1-R000352" flag="fatal" test="normalize-space(cbc:Name) = 'Resirkulerbar emballasje'">Property 'Resirkulerbar emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000353" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Resirkulerbar emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R000354" flag="fatal" test="normalize-space(cbc:Value)">Property 'Resirkulerbar emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReturnerbarEmballasje']]">
    <assert id="EHF-QII-G1-R000355" flag="fatal" test="normalize-space(cbc:Name) = 'Returnerbar emballasje'">Property 'Returnerbar emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000356" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Returnerbar emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R000357" flag="fatal" test="normalize-space(cbc:Value)">Property 'Returnerbar emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SistKontrollmaalt']]">
    <assert id="EHF-QII-G1-R000358" flag="fatal" test="normalize-space(cbc:Name) = 'Sist kontrollmålt'">Property 'Sist kontrollmålt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000359" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Sist kontrollmålt' may be used.</assert>
    <assert id="EHF-QII-G1-R000360" flag="fatal" test="normalize-space(cbc:Value)">Property 'Sist kontrollmålt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceAvvikerFraLogistikkMaal']]">
    <assert id="EHF-QII-G1-R000361" flag="fatal" test="normalize-space(cbc:Name) = 'Avviker logistikkmål fra hyllemål'">Property 'Avviker logistikkmål fra hyllemål' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000362" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Avviker logistikkmål fra hyllemål' may be used.</assert>
    <assert id="EHF-QII-G1-R000363" flag="fatal" test="normalize-space(cbc:Value)">Property 'Avviker logistikkmål fra hyllemål' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceBredde']]">
    <assert id="EHF-QII-G1-R000364" flag="fatal" test="normalize-space(cbc:Name) = 'Space bredde'">Property 'Space bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000365" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space bredde'.</assert>
    <assert id="EHF-QII-G1-R000366" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R000367" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space bredde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000368" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space bredde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceDybde']]">
    <assert id="EHF-QII-G1-R000369" flag="fatal" test="normalize-space(cbc:Name) = 'Space dybde'">Property 'Space dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000370" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space dybde'.</assert>
    <assert id="EHF-QII-G1-R000371" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R000372" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space dybde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000373" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space dybde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceHoyde']]">
    <assert id="EHF-QII-G1-R000374" flag="fatal" test="normalize-space(cbc:Name) = 'Space høyde'">Property 'Space høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000375" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space høyde'.</assert>
    <assert id="EHF-QII-G1-R000376" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R000377" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space høyde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000378" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space høyde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#TotaltAntall']]">
    <assert id="EHF-QII-G1-R000379" flag="fatal" test="normalize-space(cbc:Name) = 'Totalt antall'">Property 'Totalt antall' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000380" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Totalt antall' may be used.</assert>
    <assert id="EHF-QII-G1-R000381" flag="fatal" test="normalize-space(cbc:Value)">Property 'Totalt antall' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PantEPDnr']]">
    <assert id="EHF-QII-G1-R000382" flag="fatal" test="normalize-space(cbc:Name) = 'Pant EPDnr'">Property 'Pant EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000383" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Pant EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R000384" flag="fatal" test="normalize-space(cbc:Value)">Property 'Pant EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EPDnr']]">
    <assert id="EHF-QII-G1-R000385" flag="fatal" test="normalize-space(cbc:Name) = 'EPDnr'">Property 'EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000386" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R000387" flag="fatal" test="normalize-space(cbc:Value)">Property 'EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErstattetAvProduktID']]">
    <assert id="EHF-QII-G1-R000388" flag="fatal" test="normalize-space(cbc:Name) = 'Erstattet av EPDnr'">Property 'Erstattet av EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000389" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Erstattet av EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R000390" flag="fatal" test="normalize-space(cbc:Value)">Property 'Erstattet av EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LeverandorVarenr']]">
    <assert id="EHF-QII-G1-R000391" flag="fatal" test="normalize-space(cbc:Name) = 'Leverandør varenr'">Property 'Leverandør varenr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000392" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Leverandør varenr' may be used.</assert>
    <assert id="EHF-QII-G1-R000393" flag="fatal" test="normalize-space(cbc:Value)">Property 'Leverandør varenr' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000394" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Leverandør varenr' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MottakerTilgang']]">
    <assert id="EHF-QII-G1-R000395" flag="fatal" test="normalize-space(cbc:Name) = 'Mottaker tilgang'">Property 'Mottaker tilgang' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000396" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Mottaker tilgang' may be used.</assert>
    <assert id="EHF-QII-G1-R000397" flag="fatal" test="normalize-space(cbc:Value)">Property 'Mottaker tilgang' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000398" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Mottaker tilgang' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProdusentVarenr']]">
    <assert id="EHF-QII-G1-R000399" flag="fatal" test="normalize-space(cbc:Name) = 'Produsent varenr'">Property 'Produsent varenr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000400" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produsent varenr' may be used.</assert>
    <assert id="EHF-QII-G1-R000401" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produsent varenr' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000402" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Produsent varenr' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#TilgjengeligFraDato']]">
    <assert id="EHF-QII-G1-R000403" flag="fatal" test="normalize-space(cbc:Name) = 'Tilgjengelig fra dato'">Property 'Tilgjengelig fra dato' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000404" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Tilgjengelig fra dato' may be used.</assert>
    <assert id="EHF-QII-G1-R000405" flag="fatal" test="normalize-space(cbc:Value)">Property 'Tilgjengelig fra dato' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProduktID']]">
    <assert id="EHF-QII-G1-R000406" flag="fatal" test="normalize-space(cbc:Name) = 'Hentesteder'">Property 'Hentesteder' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000407" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Hentesteder' may be used.</assert>
    <assert id="EHF-QII-G1-R000408" flag="fatal" test="normalize-space(cbc:Value)">Property 'Hentesteder' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErBestillbar']]">
    <assert id="EHF-QII-G1-R000409" flag="fatal" test="normalize-space(cbc:Name) = 'Bestillbar'">Property 'Bestillbar' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000410" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Bestillbar' may be used.</assert>
    <assert id="EHF-QII-G1-R000411" flag="fatal" test="normalize-space(cbc:Value)">Property 'Bestillbar' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallUmerkedeEnheter']]">
    <assert id="EHF-QII-G1-R000412" flag="fatal" test="normalize-space(cbc:Name) = 'Antall umerkede enheter'">Property 'Antall umerkede enheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000413" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall umerkede enheter' may be used.</assert>
    <assert id="EHF-QII-G1-R000414" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall umerkede enheter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Ingredienser']]">
    <assert id="EHF-QII-G1-R000415" flag="fatal" test="normalize-space(cbc:Name) = 'Ingredienser'">Property 'Ingredienser' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000416" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Ingredienser' may be used.</assert>
    <assert id="EHF-QII-G1-R000417" flag="fatal" test="normalize-space(cbc:Value)">Property 'Ingredienser' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000418" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2560">Property 'Ingredienser' value must have a length of maximum 2560 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Umerketvariantbeskrivelse']]">
    <assert id="EHF-QII-G1-R000419" flag="fatal" test="normalize-space(cbc:Name) = 'Umerketvariantbeskrivelse'">Property 'Umerketvariantbeskrivelse' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000420" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Umerketvariantbeskrivelse' may be used.</assert>
    <assert id="EHF-QII-G1-R000421" flag="fatal" test="normalize-space(cbc:Value)">Property 'Umerketvariantbeskrivelse' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000422" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Umerketvariantbeskrivelse' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:legemidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Umerketvariantnr']]">
    <assert id="EHF-QII-G1-R000423" flag="fatal" test="normalize-space(cbc:Name) = 'Umerketvariantnr'">Property 'Umerketvariantnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000424" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Umerketvariantnr' may be used.</assert>
    <assert id="EHF-QII-G1-R000425" flag="fatal" test="normalize-space(cbc:Value)">Property 'Umerketvariantnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]">
    <assert id="EHF-QII-G1-R000426" flag="fatal" test="cbc:Name">Property 'Name' is mandatory.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']"/>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cbc:Name">
    <assert id="EHF-QII-G1-R000427" flag="fatal" test="normalize-space()">Property 'Name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000428" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cbc:Description">
    <assert id="EHF-QII-G1-R000429" flag="fatal" test="normalize-space()">Property 'Description' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cbc:Keyword">
    <assert id="EHF-QII-G1-R000430" flag="fatal" test="normalize-space()">Property 'Keywords' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cbc:BrandName">
    <assert id="EHF-QII-G1-R000431" flag="fatal" test="normalize-space()">Property 'Brand name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000432" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Brand name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cbc:PackQuantity">
    <assert id="EHF-QII-G1-R000433" flag="fatal" test="normalize-space()">Property 'Packed quantity' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cbc:PackSizeNumeric">
    <assert id="EHF-QII-G1-R000434" flag="fatal" test="normalize-space()">Property 'Consumable unit' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:BuyersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000435" flag="fatal" test="normalize-space()">Property 'Buyers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:SellersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000436" flag="fatal" test="normalize-space()">Property 'Sellers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:ManufacturersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000437" flag="fatal" test="normalize-space()">Property 'Manufacturers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:StandardItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R000438" flag="fatal" test="normalize-space()">Property 'Standard item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:CommodityClassification/cbc:ItemClassificationCode">
    <assert id="EHF-QII-G1-R000439" flag="fatal" test="normalize-space()">Property 'Classification code' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:OriginCountry/cbc:IdentificationCode">
    <assert id="EHF-QII-G1-R000440" flag="fatal" test="normalize-space()">Property 'Origin country' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:ItemInstance/cbc:BestBeforeDate">
    <assert id="EHF-QII-G1-R000441" flag="fatal" test="normalize-space()">Property 'Best before date' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000442" flag="fatal" test="not(normalize-space()) or (normalize-space() castable as xs:date)">Property 'Best before date' value must be a valid date.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:ItemInstance/cac:LotIdentification/cbc:LotNumberID">
    <assert id="EHF-QII-G1-R000443" flag="fatal" test="normalize-space()">Property 'Lot number' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.blotdyr']]">
    <assert id="EHF-QII-G1-R000444" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Bløtdyr'">Property 'Allergener, Bløtdyr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000445" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Bløtdyr' may be used.</assert>
    <assert id="EHF-QII-G1-R000446" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Bløtdyr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.egg']]">
    <assert id="EHF-QII-G1-R000447" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Egg'">Property 'Allergener, Egg' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000448" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Egg' may be used.</assert>
    <assert id="EHF-QII-G1-R000449" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Egg' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.fisk']]">
    <assert id="EHF-QII-G1-R000450" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Fisk'">Property 'Allergener, Fisk' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000451" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Fisk' may be used.</assert>
    <assert id="EHF-QII-G1-R000452" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Fisk' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_bygg_gluten']]">
    <assert id="EHF-QII-G1-R000453" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Bygg gluten'">Property 'Allergener, Bygg gluten' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000454" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Bygg gluten' may be used.</assert>
    <assert id="EHF-QII-G1-R000455" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Bygg gluten' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_havre_gluten']]">
    <assert id="EHF-QII-G1-R000456" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Havre gluten'">Property 'Allergener, Havre gluten' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000457" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Havre gluten' may be used.</assert>
    <assert id="EHF-QII-G1-R000458" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Havre gluten' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_hvete_gluten']]">
    <assert id="EHF-QII-G1-R000459" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Hvete gluten'">Property 'Allergener, Hvete gluten' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000460" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Hvete gluten' may be used.</assert>
    <assert id="EHF-QII-G1-R000461" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Hvete gluten' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_rug_gluten']]">
    <assert id="EHF-QII-G1-R000462" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Rug gluten'">Property 'Allergener, Rug gluten' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000463" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Rug gluten' may be used.</assert>
    <assert id="EHF-QII-G1-R000464" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Rug gluten' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.lupin']]">
    <assert id="EHF-QII-G1-R000465" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Lupiner'">Property 'Allergener, Lupiner' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000466" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Lupiner' may be used.</assert>
    <assert id="EHF-QII-G1-R000467" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Lupiner' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.melk']]">
    <assert id="EHF-QII-G1-R000468" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Melk'">Property 'Allergener, Melk' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000469" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Melk' may be used.</assert>
    <assert id="EHF-QII-G1-R000470" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Melk' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter']]">
    <assert id="EHF-QII-G1-R000471" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Nøtter'">Property 'Allergener, Nøtter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000472" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Nøtter' may be used.</assert>
    <assert id="EHF-QII-G1-R000473" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Nøtter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_hasselnotter']]">
    <assert id="EHF-QII-G1-R000474" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Hasselnøtter'">Property 'Allergener, Hasselnøtter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000475" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Hasselnøtter' may be used.</assert>
    <assert id="EHF-QII-G1-R000476" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Hasselnøtter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_kasjunotter']]">
    <assert id="EHF-QII-G1-R000477" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Kasjunøtter'">Property 'Allergener, Kasjunøtter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000478" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Kasjunøtter' may be used.</assert>
    <assert id="EHF-QII-G1-R000479" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Kasjunøtter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_macademianotter']]">
    <assert id="EHF-QII-G1-R000480" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Macademiannøtter'">Property 'Allergener, Macademiannøtter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000481" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Macademiannøtter' may be used.</assert>
    <assert id="EHF-QII-G1-R000482" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Macademiannøtter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_mandler']]">
    <assert id="EHF-QII-G1-R000483" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Mandler'">Property 'Allergener, Mandler' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000484" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Mandler' may be used.</assert>
    <assert id="EHF-QII-G1-R000485" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Mandler' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_paranotter']]">
    <assert id="EHF-QII-G1-R000486" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Paranøtter'">Property 'Allergener, Paranøtter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000487" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Paranøtter' may be used.</assert>
    <assert id="EHF-QII-G1-R000488" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Paranøtter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_peanotter']]">
    <assert id="EHF-QII-G1-R000489" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Peanøtter'">Property 'Allergener, Peanøtter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000490" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Peanøtter' may be used.</assert>
    <assert id="EHF-QII-G1-R000491" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Peanøtter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_pekannotter']]">
    <assert id="EHF-QII-G1-R000492" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Pekannøtter'">Property 'Allergener, Pekannøtter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000493" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Pekannøtter' may be used.</assert>
    <assert id="EHF-QII-G1-R000494" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Pekannøtter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_pistasienotter']]">
    <assert id="EHF-QII-G1-R000495" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Pistasienøtter'">Property 'Allergener, Pistasienøtter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000496" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Pistasienøtter' may be used.</assert>
    <assert id="EHF-QII-G1-R000497" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Pistasienøtter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_valnotter']]">
    <assert id="EHF-QII-G1-R000498" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Valnøtter'">Property 'Allergener, Valnøtter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000499" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Valnøtter' may be used.</assert>
    <assert id="EHF-QII-G1-R000500" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Valnøtter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.selleri']]">
    <assert id="EHF-QII-G1-R000501" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Selleri'">Property 'Allergener, Selleri' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000502" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Selleri' may be used.</assert>
    <assert id="EHF-QII-G1-R000503" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Selleri' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.sennep']]">
    <assert id="EHF-QII-G1-R000504" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Sennep'">Property 'Allergener, Sennep' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000505" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Sennep' may be used.</assert>
    <assert id="EHF-QII-G1-R000506" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Sennep' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.sesamfro']]">
    <assert id="EHF-QII-G1-R000507" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Sesamfrø'">Property 'Allergener, Sesamfrø' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000508" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Sesamfrø' may be used.</assert>
    <assert id="EHF-QII-G1-R000509" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Sesamfrø' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.skalldyr']]">
    <assert id="EHF-QII-G1-R000510" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Skalldyr'">Property 'Allergener, Skalldyr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000511" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Skalldyr' may be used.</assert>
    <assert id="EHF-QII-G1-R000512" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Skalldyr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.soya']]">
    <assert id="EHF-QII-G1-R000513" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Soya'">Property 'Allergener, Soya' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000514" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Soya' may be used.</assert>
    <assert id="EHF-QII-G1-R000515" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Soya' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_spelt_gluten']]">
    <assert id="EHF-QII-G1-R000516" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Spelt gluten'">Property 'Allergener, Spelt gluten' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000517" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Spelt gluten' may be used.</assert>
    <assert id="EHF-QII-G1-R000518" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Spelt gluten' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_khorasanhvete_gluten']]">
    <assert id="EHF-QII-G1-R000519" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Khorasanhvete gluten'">Property 'Allergener, Khorasanhvete gluten' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000520" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Khorasanhvete gluten' may be used.</assert>
    <assert id="EHF-QII-G1-R000521" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Khorasanhvete gluten' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.svoveldioksid_sulfitter']]">
    <assert id="EHF-QII-G1-R000522" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Svoveldioksid eller sulfitter'">Property 'Allergener, Svoveldioksid eller sulfitter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000523" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Svoveldioksid eller sulfitter' may be used.</assert>
    <assert id="EHF-QII-G1-R000524" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Svoveldioksid eller sulfitter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.gluten']]">
    <assert id="EHF-QII-G1-R000525" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Gluten'">Property 'Allergener, Gluten' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000526" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Gluten' may be used.</assert>
    <assert id="EHF-QII-G1-R000527" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Gluten' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AndelFiskSjomat']]">
    <assert id="EHF-QII-G1-R000528" flag="fatal" test="normalize-space(cbc:Name) = 'Andel fisk/sjømat'">Property 'Andel fisk/sjømat' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000529" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Andel fisk/sjømat'.</assert>
    <assert id="EHF-QII-G1-R000530" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Andel fisk/sjømat' may be used.</assert>
    <assert id="EHF-QII-G1-R000531" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Andel fisk/sjømat' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000532" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Andel fisk/sjømat' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AndelFullkorn']]">
    <assert id="EHF-QII-G1-R000533" flag="fatal" test="normalize-space(cbc:Name) = 'Andel fullkorn (g/100g)'">Property 'Andel fullkorn (g/100g)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000534" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Andel fullkorn (g/100g)'.</assert>
    <assert id="EHF-QII-G1-R000535" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Andel fullkorn (g/100g)' may be used.</assert>
    <assert id="EHF-QII-G1-R000536" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Andel fullkorn (g/100g)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000537" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Andel fullkorn (g/100g)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AndelGronsakerFruktBar']]">
    <assert id="EHF-QII-G1-R000538" flag="fatal" test="normalize-space(cbc:Name) = 'Andel grønnsaker, frukt og bær (g/100g)'">Property 'Andel grønnsaker, frukt og bær (g/100g)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000539" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Andel grønnsaker, frukt og bær (g/100g)'.</assert>
    <assert id="EHF-QII-G1-R000540" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Andel grønnsaker, frukt og bær (g/100g)' may be used.</assert>
    <assert id="EHF-QII-G1-R000541" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Andel grønnsaker, frukt og bær (g/100g)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000542" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Andel grønnsaker, frukt og bær (g/100g)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AndelNotterFro']]">
    <assert id="EHF-QII-G1-R000543" flag="fatal" test="normalize-space(cbc:Name) = 'Andel nøtter, frø (g/100g)'">Property 'Andel nøtter, frø (g/100g)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000544" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Andel nøtter, frø (g/100g)'.</assert>
    <assert id="EHF-QII-G1-R000545" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Andel nøtter, frø (g/100g)' may be used.</assert>
    <assert id="EHF-QII-G1-R000546" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Andel nøtter, frø (g/100g)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000547" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Andel nøtter, frø (g/100g)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallHoldbarhetsdagerEtterBruttFrysekjede']]">
    <assert id="EHF-QII-G1-R000548" flag="fatal" test="normalize-space(cbc:Name) = 'Antall holdbarhetsdager igjen etter brutt frysekjede'">Property 'Antall holdbarhetsdager igjen etter brutt frysekjede' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000549" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall holdbarhetsdager igjen etter brutt frysekjede' may be used.</assert>
    <assert id="EHF-QII-G1-R000550" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall holdbarhetsdager igjen etter brutt frysekjede' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Beskrivelse']]">
    <assert id="EHF-QII-G1-R000551" flag="fatal" test="normalize-space(cbc:Name) = 'Produktnavn'">Property 'Produktnavn' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000552" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produktnavn' may be used.</assert>
    <assert id="EHF-QII-G1-R000553" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produktnavn' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000554" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Produktnavn' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseEngelsk']]">
    <assert id="EHF-QII-G1-R000555" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse [Engelsk]'">Property 'Beskrivelse [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000556" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R000557" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000558" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Beskrivelse [Engelsk]' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseUmerkedeEnheter']]">
    <assert id="EHF-QII-G1-R000559" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse umerkede enheter'">Property 'Beskrivelse umerkede enheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000560" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse umerkede enheter' may be used.</assert>
    <assert id="EHF-QII-G1-R000561" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse umerkede enheter' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000562" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Beskrivelse umerkede enheter' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseUmerkedeSalgsenheter']]">
    <assert id="EHF-QII-G1-R000563" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse umerkede salgsenheter'">Property 'Beskrivelse umerkede salgsenheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000564" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse umerkede salgsenheter' may be used.</assert>
    <assert id="EHF-QII-G1-R000565" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse umerkede salgsenheter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EnhetsprisbetegnelseKode']]">
    <assert id="EHF-QII-G1-R000566" flag="fatal" test="normalize-space(cbc:Name) = 'Enhetsprisbetegnelse'">Property 'Enhetsprisbetegnelse' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000567" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Enhetsprisbetegnelse' may be used.</assert>
    <assert id="EHF-QII-G1-R000568" flag="fatal" test="normalize-space(cbc:Value)">Property 'Enhetsprisbetegnelse' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Enhetsprisfaktor']]">
    <assert id="EHF-QII-G1-R000569" flag="fatal" test="normalize-space(cbc:Name) = 'Enhetsprisfaktor'">Property 'Enhetsprisfaktor' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000570" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Enhetsprisfaktor'.</assert>
    <assert id="EHF-QII-G1-R000571" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Enhetsprisfaktor' may be used.</assert>
    <assert id="EHF-QII-G1-R000572" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Enhetsprisfaktor' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000573" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Enhetsprisfaktor' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EnhetspristypeKode']]">
    <assert id="EHF-QII-G1-R000574" flag="fatal" test="normalize-space(cbc:Name) = 'Enhetspris sammenligningsgrunnlag'">Property 'Enhetspris sammenligningsgrunnlag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000575" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Enhetspris sammenligningsgrunnlag' may be used.</assert>
    <assert id="EHF-QII-G1-R000576" flag="fatal" test="normalize-space(cbc:Value)">Property 'Enhetspris sammenligningsgrunnlag' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErMengdevariabelt']]">
    <assert id="EHF-QII-G1-R000577" flag="fatal" test="normalize-space(cbc:Name) = 'Mengdevariabelt'">Property 'Mengdevariabelt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000578" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Mengdevariabelt' may be used.</assert>
    <assert id="EHF-QII-G1-R000579" flag="fatal" test="normalize-space(cbc:Value)">Property 'Mengdevariabelt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErMerketMedUtsalgspris']]">
    <assert id="EHF-QII-G1-R000580" flag="fatal" test="normalize-space(cbc:Name) = 'Merket med utsalgspris'">Property 'Merket med utsalgspris' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000581" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Merket med utsalgspris' may be used.</assert>
    <assert id="EHF-QII-G1-R000582" flag="fatal" test="normalize-space(cbc:Value)">Property 'Merket med utsalgspris' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErStorhusholdningsprodukt']]">
    <assert id="EHF-QII-G1-R000583" flag="fatal" test="normalize-space(cbc:Name) = 'Storhusholdningsprodukt'">Property 'Storhusholdningsprodukt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000584" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Storhusholdningsprodukt' may be used.</assert>
    <assert id="EHF-QII-G1-R000585" flag="fatal" test="normalize-space(cbc:Value)">Property 'Storhusholdningsprodukt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Fyllingsgrad']]">
    <assert id="EHF-QII-G1-R000586" flag="fatal" test="normalize-space(cbc:Name) = 'Fyllingsgrad'">Property 'Fyllingsgrad' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000587" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Fyllingsgrad'.</assert>
    <assert id="EHF-QII-G1-R000588" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Fyllingsgrad' may be used.</assert>
    <assert id="EHF-QII-G1-R000589" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Fyllingsgrad' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000590" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Fyllingsgrad' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilDetaljist']]">
    <assert id="EHF-QII-G1-R000591" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til detaljist'">Property 'Holdbarhetsdager til detaljist' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000592" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til detaljist' may be used.</assert>
    <assert id="EHF-QII-G1-R000593" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til detaljist' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilDistributor']]">
    <assert id="EHF-QII-G1-R000594" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til distributør'">Property 'Holdbarhetsdager til distributør' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000595" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til distributør' may be used.</assert>
    <assert id="EHF-QII-G1-R000596" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til distributør' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilProdusent']]">
    <assert id="EHF-QII-G1-R000597" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til produsent'">Property 'Holdbarhetsdager til produsent' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000598" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til produsent' may be used.</assert>
    <assert id="EHF-QII-G1-R000599" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til produsent' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTotalt']]">
    <assert id="EHF-QII-G1-R000600" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager totalt'">Property 'Holdbarhetsdager totalt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000601" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager totalt' may be used.</assert>
    <assert id="EHF-QII-G1-R000602" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager totalt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Informasjonstekst']]">
    <assert id="EHF-QII-G1-R000603" flag="fatal" test="normalize-space(cbc:Name) = 'Informasjonstekst'">Property 'Informasjonstekst' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000604" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Informasjonstekst' may be used.</assert>
    <assert id="EHF-QII-G1-R000605" flag="fatal" test="normalize-space(cbc:Value)">Property 'Informasjonstekst' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000606" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Informasjonstekst' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#InformasjonstekstEngelsk']]">
    <assert id="EHF-QII-G1-R000607" flag="fatal" test="normalize-space(cbc:Name) = 'Informasjonstekst [Engelsk]'">Property 'Informasjonstekst [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000608" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Informasjonstekst [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R000609" flag="fatal" test="normalize-space(cbc:Value)">Property 'Informasjonstekst [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000610" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Informasjonstekst [Engelsk]' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#KanFrysekjedenBrytesIButikk']]">
    <assert id="EHF-QII-G1-R000611" flag="fatal" test="normalize-space(cbc:Name) = 'Kan frysekjeden brytes i butikk'">Property 'Kan frysekjeden brytes i butikk' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000612" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Kan frysekjeden brytes i butikk' may be used.</assert>
    <assert id="EHF-QII-G1-R000613" flag="fatal" test="normalize-space(cbc:Value)">Property 'Kan frysekjeden brytes i butikk' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MaksimumstemperaturCelcius']]">
    <assert id="EHF-QII-G1-R000614" flag="fatal" test="normalize-space(cbc:Name) = 'Maksimumstemperatur'">Property 'Maksimumstemperatur' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000615" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Maksimumstemperatur'.</assert>
    <assert id="EHF-QII-G1-R000616" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Maksimumstemperatur' may be used.</assert>
    <assert id="EHF-QII-G1-R000617" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Maksimumstemperatur' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000618" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Maksimumstemperatur' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MaksTempKorttidslagringCelcius']]">
    <assert id="EHF-QII-G1-R000619" flag="fatal" test="normalize-space(cbc:Name) = 'Maks temperatur kortidslagring/butikk'">Property 'Maks temperatur kortidslagring/butikk' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000620" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Maks temperatur kortidslagring/butikk'.</assert>
    <assert id="EHF-QII-G1-R000621" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Maks temperatur kortidslagring/butikk' may be used.</assert>
    <assert id="EHF-QII-G1-R000622" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Maks temperatur kortidslagring/butikk' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000623" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Maks temperatur kortidslagring/butikk' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Mengde']]">
    <assert id="EHF-QII-G1-R000624" flag="fatal" test="normalize-space(cbc:Name) = 'Mengde'">Property 'Mengde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000625" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Mengde'.</assert>
    <assert id="EHF-QII-G1-R000626" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Mengde' may be used.</assert>
    <assert id="EHF-QII-G1-R000627" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Mengde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000628" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Mengde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MengdeTilsattSalt']]">
    <assert id="EHF-QII-G1-R000629" flag="fatal" test="normalize-space(cbc:Name) = 'Mengde tilsatt salt pr 100g'">Property 'Mengde tilsatt salt pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000630" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Mengde tilsatt salt pr 100g'.</assert>
    <assert id="EHF-QII-G1-R000631" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Mengde tilsatt salt pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R000632" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Mengde tilsatt salt pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000633" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Mengde tilsatt salt pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MengdeTilsattSukker']]">
    <assert id="EHF-QII-G1-R000634" flag="fatal" test="normalize-space(cbc:Name) = 'Mengde tilsatt sukker pr 100g'">Property 'Mengde tilsatt sukker pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000635" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Mengde tilsatt sukker pr 100g'.</assert>
    <assert id="EHF-QII-G1-R000636" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Mengde tilsatt sukker pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R000637" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Mengde tilsatt sukker pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000638" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Mengde tilsatt sukker pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Mengdetypeenhet']]">
    <assert id="EHF-QII-G1-R000639" flag="fatal" test="normalize-space(cbc:Name) = 'Måleenhet for produktutbytte'">Property 'Måleenhet for produktutbytte' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000640" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Måleenhet for produktutbytte' may be used.</assert>
    <assert id="EHF-QII-G1-R000641" flag="fatal" test="normalize-space(cbc:Value)">Property 'Måleenhet for produktutbytte' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000642" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Måleenhet for produktutbytte' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MerketMedEgenskaper']]">
    <assert id="EHF-QII-G1-R000643" flag="fatal" test="normalize-space(cbc:Name) = 'Er produktet merket med en eller flere egenskaper?'">Property 'Er produktet merket med en eller flere egenskaper?' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000644" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Er produktet merket med en eller flere egenskaper?' may be used.</assert>
    <assert id="EHF-QII-G1-R000645" flag="fatal" test="normalize-space(cbc:Value)">Property 'Er produktet merket med en eller flere egenskaper?' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MinimumstemperaturCelsius']]">
    <assert id="EHF-QII-G1-R000646" flag="fatal" test="normalize-space(cbc:Name) = 'Minimumstemperatur'">Property 'Minimumstemperatur' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000647" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Minimumstemperatur'.</assert>
    <assert id="EHF-QII-G1-R000648" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Minimumstemperatur' may be used.</assert>
    <assert id="EHF-QII-G1-R000649" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Minimumstemperatur' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000650" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Minimumstemperatur' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MinTempKorttidslagringCelcius']]">
    <assert id="EHF-QII-G1-R000651" flag="fatal" test="normalize-space(cbc:Name) = 'Min temperatur kortidslagring/butikk'">Property 'Min temperatur kortidslagring/butikk' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000652" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Min temperatur kortidslagring/butikk'.</assert>
    <assert id="EHF-QII-G1-R000653" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Min temperatur kortidslagring/butikk' may be used.</assert>
    <assert id="EHF-QII-G1-R000654" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Min temperatur kortidslagring/butikk' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000655" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Min temperatur kortidslagring/butikk' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MVAKode']]">
    <assert id="EHF-QII-G1-R000656" flag="fatal" test="normalize-space(cbc:Name) = 'Mva sats'">Property 'Mva sats' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000657" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Mva sats' may be used.</assert>
    <assert id="EHF-QII-G1-R000658" flag="fatal" test="normalize-space(cbc:Value)">Property 'Mva sats' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaringsdeklarasjonKode']]">
    <assert id="EHF-QII-G1-R000659" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsdeklarasjon oppgis i'">Property 'Næringsdeklarasjon oppgis i' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000660" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Næringsdeklarasjon oppgis i' may be used.</assert>
    <assert id="EHF-QII-G1-R000661" flag="fatal" test="normalize-space(cbc:Value)">Property 'Næringsdeklarasjon oppgis i' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaringsinnholdKode']]">
    <assert id="EHF-QII-G1-R000662" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold per 100 g/ml'">Property 'Næringsinnhold per 100 g/ml' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000663" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Næringsinnhold per 100 g/ml' may be used.</assert>
    <assert id="EHF-QII-G1-R000664" flag="fatal" test="normalize-space(cbc:Value)">Property 'Næringsinnhold per 100 g/ml' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Nettovekt']]">
    <assert id="EHF-QII-G1-R000665" flag="fatal" test="normalize-space(cbc:Name) = 'Nettovekt'">Property 'Nettovekt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000666" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Nettovekt'.</assert>
    <assert id="EHF-QII-G1-R000667" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Nettovekt' may be used.</assert>
    <assert id="EHF-QII-G1-R000668" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Nettovekt' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000669" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Nettovekt' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#OpprinnelseOgOpphav']]">
    <assert id="EHF-QII-G1-R000670" flag="fatal" test="normalize-space(cbc:Name) = 'Opprinnelsesland/Opphavssted hovedingrediens(er)'">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000671" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' may be used.</assert>
    <assert id="EHF-QII-G1-R000672" flag="fatal" test="normalize-space(cbc:Value)">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000673" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 200">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' value must have a length of maximum 200 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Produksjonsland']]">
    <assert id="EHF-QII-G1-R000674" flag="fatal" test="normalize-space(cbc:Name) = 'Produksjonsland'">Property 'Produksjonsland' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000675" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produksjonsland' may be used.</assert>
    <assert id="EHF-QII-G1-R000676" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produksjonsland' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProduksjonsmetodeFiskKode']]">
    <assert id="EHF-QII-G1-R000677" flag="fatal" test="normalize-space(cbc:Name) = 'Produksjonsmetode fisk'">Property 'Produksjonsmetode fisk' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000678" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produksjonsmetode fisk' may be used.</assert>
    <assert id="EHF-QII-G1-R000679" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produksjonsmetode fisk' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProduktmerkingEgenskaper']]">
    <assert id="EHF-QII-G1-R000680" flag="fatal" test="normalize-space(cbc:Name) = 'Produktmerking egenskaper'">Property 'Produktmerking egenskaper' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000681" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produktmerking egenskaper' may be used.</assert>
    <assert id="EHF-QII-G1-R000682" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produktmerking egenskaper' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Stablingsfaktor']]">
    <assert id="EHF-QII-G1-R000683" flag="fatal" test="normalize-space(cbc:Name) = 'Stablingsfaktor'">Property 'Stablingsfaktor' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000684" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Stablingsfaktor'.</assert>
    <assert id="EHF-QII-G1-R000685" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Stablingsfaktor' may be used.</assert>
    <assert id="EHF-QII-G1-R000686" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Stablingsfaktor' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000687" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Stablingsfaktor' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Varemerke']]">
    <assert id="EHF-QII-G1-R000688" flag="fatal" test="normalize-space(cbc:Name) = 'Varemerke'">Property 'Varemerke' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000689" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varemerke' may be used.</assert>
    <assert id="EHF-QII-G1-R000690" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varemerke' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000691" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Varemerke' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PakningID']]">
    <assert id="EHF-QII-G1-R000692" flag="fatal" test="normalize-space(cbc:Name) = 'Sertifiseringer'">Property 'Sertifiseringer' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000693" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Sertifiseringer' may be used.</assert>
    <assert id="EHF-QII-G1-R000694" flag="fatal" test="normalize-space(cbc:Value)">Property 'Sertifiseringer' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#VaregruppeID']]">
    <assert id="EHF-QII-G1-R000695" flag="fatal" test="normalize-space(cbc:Name) = 'Varegruppe'">Property 'Varegruppe' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000696" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varegruppe' may be used.</assert>
    <assert id="EHF-QII-G1-R000697" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varegruppe' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Antall']]">
    <assert id="EHF-QII-G1-R000698" flag="fatal" test="normalize-space(cbc:Name) = 'Antall'">Property 'Antall' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000699" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall' may be used.</assert>
    <assert id="EHF-QII-G1-R000700" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallAvPant']]">
    <assert id="EHF-QII-G1-R000701" flag="fatal" test="normalize-space(cbc:Name) = 'Antall av pant'">Property 'Antall av pant' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000702" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall av pant' may be used.</assert>
    <assert id="EHF-QII-G1-R000703" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall av pant' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriBredden']]">
    <assert id="EHF-QII-G1-R000704" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i bredde'">Property 'Antall basispakninger i bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000705" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R000706" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i bredde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriDybden']]">
    <assert id="EHF-QII-G1-R000707" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i dybde'">Property 'Antall basispakninger i dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000708" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R000709" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i dybde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriHoyden']]">
    <assert id="EHF-QII-G1-R000710" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i høyde'">Property 'Antall basispakninger i høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000711" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R000712" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i høyde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallLag']]">
    <assert id="EHF-QII-G1-R000713" flag="fatal" test="normalize-space(cbc:Name) = 'Antall lag'">Property 'Antall lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000714" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall lag' may be used.</assert>
    <assert id="EHF-QII-G1-R000715" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall lag' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallPrLag']]">
    <assert id="EHF-QII-G1-R000716" flag="fatal" test="normalize-space(cbc:Name) = 'Antall pr lag'">Property 'Antall pr lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000717" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall pr lag' may be used.</assert>
    <assert id="EHF-QII-G1-R000718" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall pr lag' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AvvikendePakkemonster']]">
    <assert id="EHF-QII-G1-R000719" flag="fatal" test="normalize-space(cbc:Name) = 'Avvikende pakkemønster'">Property 'Avvikende pakkemønster' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000720" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Avvikende pakkemønster' may be used.</assert>
    <assert id="EHF-QII-G1-R000721" flag="fatal" test="normalize-space(cbc:Value)">Property 'Avvikende pakkemønster' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Bredde']]">
    <assert id="EHF-QII-G1-R000722" flag="fatal" test="normalize-space(cbc:Name) = 'Bredde'">Property 'Bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000723" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Bredde'.</assert>
    <assert id="EHF-QII-G1-R000724" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R000725" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Bredde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000726" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Bredde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Bruttovekt']]">
    <assert id="EHF-QII-G1-R000727" flag="fatal" test="normalize-space(cbc:Name) = 'Bruttovekt'">Property 'Bruttovekt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000728" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Bruttovekt'.</assert>
    <assert id="EHF-QII-G1-R000729" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Bruttovekt' may be used.</assert>
    <assert id="EHF-QII-G1-R000730" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Bruttovekt' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000731" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Bruttovekt' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Dybde']]">
    <assert id="EHF-QII-G1-R000732" flag="fatal" test="normalize-space(cbc:Name) = 'Dybde'">Property 'Dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000733" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Dybde'.</assert>
    <assert id="EHF-QII-G1-R000734" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R000735" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Dybde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000736" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Dybde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Egenskaper']]">
    <assert id="EHF-QII-G1-R000737" flag="fatal" test="normalize-space(cbc:Name) = 'Egenskaper'">Property 'Egenskaper' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000738" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Egenskaper' may be used.</assert>
    <assert id="EHF-QII-G1-R000739" flag="fatal" test="normalize-space(cbc:Value)">Property 'Egenskaper' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000740" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Egenskaper' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EgenskaperEngelsk']]">
    <assert id="EHF-QII-G1-R000741" flag="fatal" test="normalize-space(cbc:Name) = 'Egenskaper [Engelsk]'">Property 'Egenskaper [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000742" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Egenskaper [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R000743" flag="fatal" test="normalize-space(cbc:Value)">Property 'Egenskaper [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000744" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Egenskaper [Engelsk]' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Emballasjekode']]">
    <assert id="EHF-QII-G1-R000745" flag="fatal" test="normalize-space(cbc:Name) = 'Emballasje'">Property 'Emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000746" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R000747" flag="fatal" test="normalize-space(cbc:Value)">Property 'Emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErForbrukerpakning']]">
    <assert id="EHF-QII-G1-R000748" flag="fatal" test="normalize-space(cbc:Name) = 'ErForbrukerpakning'">Property 'ErForbrukerpakning' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000749" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'ErForbrukerpakning' may be used.</assert>
    <assert id="EHF-QII-G1-R000750" flag="fatal" test="normalize-space(cbc:Value)">Property 'ErForbrukerpakning' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#GS1Databaarer']]">
    <assert id="EHF-QII-G1-R000751" flag="fatal" test="normalize-space(cbc:Name) = 'GS1 Databær'">Property 'GS1 Databær' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000752" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'GS1 Databær' may be used.</assert>
    <assert id="EHF-QII-G1-R000753" flag="fatal" test="normalize-space(cbc:Value)">Property 'GS1 Databær' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Hoyde']]">
    <assert id="EHF-QII-G1-R000754" flag="fatal" test="normalize-space(cbc:Name) = 'Høyde'">Property 'Høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000755" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Høyde'.</assert>
    <assert id="EHF-QII-G1-R000756" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R000757" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Høyde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000758" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Høyde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoydePrLag']]">
    <assert id="EHF-QII-G1-R000759" flag="fatal" test="normalize-space(cbc:Name) = 'Høyde pr lag'">Property 'Høyde pr lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000760" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Høyde pr lag'.</assert>
    <assert id="EHF-QII-G1-R000761" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Høyde pr lag' may be used.</assert>
    <assert id="EHF-QII-G1-R000762" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Høyde pr lag' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000763" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Høyde pr lag' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LastbaererKode']]">
    <assert id="EHF-QII-G1-R000764" flag="fatal" test="normalize-space(cbc:Name) = 'Lastbærer'">Property 'Lastbærer' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000765" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Lastbærer' may be used.</assert>
    <assert id="EHF-QII-G1-R000766" flag="fatal" test="normalize-space(cbc:Value)">Property 'Lastbærer' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Markedsnavn']]">
    <assert id="EHF-QII-G1-R000767" flag="fatal" test="normalize-space(cbc:Name) = 'Fullstendig produktnavn'">Property 'Fullstendig produktnavn' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000768" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Fullstendig produktnavn' may be used.</assert>
    <assert id="EHF-QII-G1-R000769" flag="fatal" test="normalize-space(cbc:Value)">Property 'Fullstendig produktnavn' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000770" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Fullstendig produktnavn' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MarkedsnavnEngelsk']]">
    <assert id="EHF-QII-G1-R000771" flag="fatal" test="normalize-space(cbc:Name) = 'Fullstendig produktnavn [Engelsk]'">Property 'Fullstendig produktnavn [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000772" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Fullstendig produktnavn [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R000773" flag="fatal" test="normalize-space(cbc:Value)">Property 'Fullstendig produktnavn [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000774" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Fullstendig produktnavn [Engelsk]' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MaxTopplast']]">
    <assert id="EHF-QII-G1-R000775" flag="fatal" test="normalize-space(cbc:Name) = 'Max topplast'">Property 'Max topplast' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000776" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Max topplast'.</assert>
    <assert id="EHF-QII-G1-R000777" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Max topplast' may be used.</assert>
    <assert id="EHF-QII-G1-R000778" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Max topplast' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000779" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Max topplast' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PantGTIN']]">
    <assert id="EHF-QII-G1-R000780" flag="fatal" test="normalize-space(cbc:Name) = 'Pant GTIN'">Property 'Pant GTIN' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000781" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Pant GTIN' may be used.</assert>
    <assert id="EHF-QII-G1-R000782" flag="fatal" test="normalize-space(cbc:Value)">Property 'Pant GTIN' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PEGhullBredde']]">
    <assert id="EHF-QII-G1-R000783" flag="fatal" test="normalize-space(cbc:Name) = 'PEG-hullets bredde'">Property 'PEG-hullets bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000784" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'PEG-hullets bredde'.</assert>
    <assert id="EHF-QII-G1-R000785" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'PEG-hullets bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R000786" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'PEG-hullets bredde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000787" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'PEG-hullets bredde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PEGhullX']]">
    <assert id="EHF-QII-G1-R000788" flag="fatal" test="normalize-space(cbc:Name) = 'PEG-hull X'">Property 'PEG-hull X' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000789" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'PEG-hull X'.</assert>
    <assert id="EHF-QII-G1-R000790" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'PEG-hull X' may be used.</assert>
    <assert id="EHF-QII-G1-R000791" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'PEG-hull X' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000792" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'PEG-hull X' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PEGhullY']]">
    <assert id="EHF-QII-G1-R000793" flag="fatal" test="normalize-space(cbc:Name) = 'PEG-hull Y'">Property 'PEG-hull Y' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000794" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'PEG-hull Y'.</assert>
    <assert id="EHF-QII-G1-R000795" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'PEG-hull Y' may be used.</assert>
    <assert id="EHF-QII-G1-R000796" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'PEG-hull Y' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000797" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'PEG-hull Y' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ResirkulerbarEmballasje']]">
    <assert id="EHF-QII-G1-R000798" flag="fatal" test="normalize-space(cbc:Name) = 'Resirkulerbar emballasje'">Property 'Resirkulerbar emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000799" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Resirkulerbar emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R000800" flag="fatal" test="normalize-space(cbc:Value)">Property 'Resirkulerbar emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReturnerbarEmballasje']]">
    <assert id="EHF-QII-G1-R000801" flag="fatal" test="normalize-space(cbc:Name) = 'Returnerbar emballasje'">Property 'Returnerbar emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000802" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Returnerbar emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R000803" flag="fatal" test="normalize-space(cbc:Value)">Property 'Returnerbar emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SistKontrollmaalt']]">
    <assert id="EHF-QII-G1-R000804" flag="fatal" test="normalize-space(cbc:Name) = 'Sist kontrollmålt'">Property 'Sist kontrollmålt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000805" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Sist kontrollmålt' may be used.</assert>
    <assert id="EHF-QII-G1-R000806" flag="fatal" test="normalize-space(cbc:Value)">Property 'Sist kontrollmålt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceAvvikerFraLogistikkMaal']]">
    <assert id="EHF-QII-G1-R000807" flag="fatal" test="normalize-space(cbc:Name) = 'Avviker logistikkmål fra hyllemål'">Property 'Avviker logistikkmål fra hyllemål' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000808" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Avviker logistikkmål fra hyllemål' may be used.</assert>
    <assert id="EHF-QII-G1-R000809" flag="fatal" test="normalize-space(cbc:Value)">Property 'Avviker logistikkmål fra hyllemål' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceBredde']]">
    <assert id="EHF-QII-G1-R000810" flag="fatal" test="normalize-space(cbc:Name) = 'Space bredde'">Property 'Space bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000811" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space bredde'.</assert>
    <assert id="EHF-QII-G1-R000812" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R000813" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space bredde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000814" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space bredde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceDybde']]">
    <assert id="EHF-QII-G1-R000815" flag="fatal" test="normalize-space(cbc:Name) = 'Space dybde'">Property 'Space dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000816" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space dybde'.</assert>
    <assert id="EHF-QII-G1-R000817" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R000818" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space dybde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000819" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space dybde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceHoyde']]">
    <assert id="EHF-QII-G1-R000820" flag="fatal" test="normalize-space(cbc:Name) = 'Space høyde'">Property 'Space høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000821" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space høyde'.</assert>
    <assert id="EHF-QII-G1-R000822" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R000823" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space høyde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000824" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space høyde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#TotaltAntall']]">
    <assert id="EHF-QII-G1-R000825" flag="fatal" test="normalize-space(cbc:Name) = 'Totalt antall'">Property 'Totalt antall' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000826" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Totalt antall' may be used.</assert>
    <assert id="EHF-QII-G1-R000827" flag="fatal" test="normalize-space(cbc:Value)">Property 'Totalt antall' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PantEPDnr']]">
    <assert id="EHF-QII-G1-R000828" flag="fatal" test="normalize-space(cbc:Name) = 'Pant EPDnr'">Property 'Pant EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000829" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Pant EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R000830" flag="fatal" test="normalize-space(cbc:Value)">Property 'Pant EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EPDnr']]">
    <assert id="EHF-QII-G1-R000831" flag="fatal" test="normalize-space(cbc:Name) = 'EPDnr'">Property 'EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000832" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R000833" flag="fatal" test="normalize-space(cbc:Value)">Property 'EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErstattetAvProduktID']]">
    <assert id="EHF-QII-G1-R000834" flag="fatal" test="normalize-space(cbc:Name) = 'Erstattet av EPDnr'">Property 'Erstattet av EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000835" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Erstattet av EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R000836" flag="fatal" test="normalize-space(cbc:Value)">Property 'Erstattet av EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LeverandorVarenr']]">
    <assert id="EHF-QII-G1-R000837" flag="fatal" test="normalize-space(cbc:Name) = 'Leverandør varenr'">Property 'Leverandør varenr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000838" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Leverandør varenr' may be used.</assert>
    <assert id="EHF-QII-G1-R000839" flag="fatal" test="normalize-space(cbc:Value)">Property 'Leverandør varenr' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000840" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Leverandør varenr' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MottakerTilgang']]">
    <assert id="EHF-QII-G1-R000841" flag="fatal" test="normalize-space(cbc:Name) = 'Mottaker tilgang'">Property 'Mottaker tilgang' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000842" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Mottaker tilgang' may be used.</assert>
    <assert id="EHF-QII-G1-R000843" flag="fatal" test="normalize-space(cbc:Value)">Property 'Mottaker tilgang' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000844" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Mottaker tilgang' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProdusentVarenr']]">
    <assert id="EHF-QII-G1-R000845" flag="fatal" test="normalize-space(cbc:Name) = 'Produsent varenr'">Property 'Produsent varenr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000846" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produsent varenr' may be used.</assert>
    <assert id="EHF-QII-G1-R000847" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produsent varenr' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000848" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Produsent varenr' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#TilgjengeligFraDato']]">
    <assert id="EHF-QII-G1-R000849" flag="fatal" test="normalize-space(cbc:Name) = 'Tilgjengelig fra dato'">Property 'Tilgjengelig fra dato' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000850" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Tilgjengelig fra dato' may be used.</assert>
    <assert id="EHF-QII-G1-R000851" flag="fatal" test="normalize-space(cbc:Value)">Property 'Tilgjengelig fra dato' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProduktID']]">
    <assert id="EHF-QII-G1-R000852" flag="fatal" test="normalize-space(cbc:Name) = 'Hentesteder'">Property 'Hentesteder' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000853" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Hentesteder' may be used.</assert>
    <assert id="EHF-QII-G1-R000854" flag="fatal" test="normalize-space(cbc:Value)">Property 'Hentesteder' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErBestillbar']]">
    <assert id="EHF-QII-G1-R000855" flag="fatal" test="normalize-space(cbc:Name) = 'Bestillbar'">Property 'Bestillbar' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000856" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Bestillbar' may be used.</assert>
    <assert id="EHF-QII-G1-R000857" flag="fatal" test="normalize-space(cbc:Value)">Property 'Bestillbar' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#FerdigTilberedtBeskrivelse']]">
    <assert id="EHF-QII-G1-R000858" flag="fatal" test="normalize-space(cbc:Name) = 'Ferdig tilberedt beskrivelse'">Property 'Ferdig tilberedt beskrivelse' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000859" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Ferdig tilberedt beskrivelse' may be used.</assert>
    <assert id="EHF-QII-G1-R000860" flag="fatal" test="normalize-space(cbc:Value)">Property 'Ferdig tilberedt beskrivelse' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000861" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Ferdig tilberedt beskrivelse' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoyesteAnbefalteSerververingstemperaturCelsius']]">
    <assert id="EHF-QII-G1-R000862" flag="fatal" test="normalize-space(cbc:Name) = 'Høyeste anbefalte serververingstemperatur'">Property 'Høyeste anbefalte serververingstemperatur' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000863" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Høyeste anbefalte serververingstemperatur'.</assert>
    <assert id="EHF-QII-G1-R000864" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Høyeste anbefalte serververingstemperatur' may be used.</assert>
    <assert id="EHF-QII-G1-R000865" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Høyeste anbefalte serververingstemperatur' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000866" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Høyeste anbefalte serververingstemperatur' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MinsteAnbefalteServeringstemperaturCelsius']]">
    <assert id="EHF-QII-G1-R000867" flag="fatal" test="normalize-space(cbc:Name) = 'Minste anbefalte serveringstemperatur'">Property 'Minste anbefalte serveringstemperatur' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000868" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Minste anbefalte serveringstemperatur'.</assert>
    <assert id="EHF-QII-G1-R000869" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Minste anbefalte serveringstemperatur' may be used.</assert>
    <assert id="EHF-QII-G1-R000870" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Minste anbefalte serveringstemperatur' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000871" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Minste anbefalte serveringstemperatur' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Produktutbytte']]">
    <assert id="EHF-QII-G1-R000872" flag="fatal" test="normalize-space(cbc:Name) = 'Produktutbytte'">Property 'Produktutbytte' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000873" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Produktutbytte'.</assert>
    <assert id="EHF-QII-G1-R000874" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Produktutbytte' may be used.</assert>
    <assert id="EHF-QII-G1-R000875" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Produktutbytte' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000876" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Produktutbytte' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProduktutbyttevariasjonProsent']]">
    <assert id="EHF-QII-G1-R000877" flag="fatal" test="normalize-space(cbc:Name) = 'Produktutbyttevariasjon prosent'">Property 'Produktutbyttevariasjon prosent' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000878" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Produktutbyttevariasjon prosent'.</assert>
    <assert id="EHF-QII-G1-R000879" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Produktutbyttevariasjon prosent' may be used.</assert>
    <assert id="EHF-QII-G1-R000880" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Produktutbyttevariasjon prosent' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000881" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Produktutbyttevariasjon prosent' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Tilberedelsebeskrivelse']]">
    <assert id="EHF-QII-G1-R000882" flag="fatal" test="normalize-space(cbc:Name) = 'Tilberedelsebeskrivelse'">Property 'Tilberedelsebeskrivelse' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000883" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Tilberedelsebeskrivelse' may be used.</assert>
    <assert id="EHF-QII-G1-R000884" flag="fatal" test="normalize-space(cbc:Value)">Property 'Tilberedelsebeskrivelse' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000885" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Tilberedelsebeskrivelse' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Tilberedningsforslag']]">
    <assert id="EHF-QII-G1-R000886" flag="fatal" test="normalize-space(cbc:Name) = 'Tilberedningsforslag'">Property 'Tilberedningsforslag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000887" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Tilberedningsforslag' may be used.</assert>
    <assert id="EHF-QII-G1-R000888" flag="fatal" test="normalize-space(cbc:Value)">Property 'Tilberedningsforslag' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000889" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Tilberedningsforslag' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergierklaring']]">
    <assert id="EHF-QII-G1-R000890" flag="fatal" test="normalize-space(cbc:Name) = 'Allergierklæring'">Property 'Allergierklæring' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000891" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergierklæring' may be used.</assert>
    <assert id="EHF-QII-G1-R000892" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergierklæring' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000893" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2560">Property 'Allergierklæring' value must have a length of maximum 2560 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallUmerkedeEnheter']]">
    <assert id="EHF-QII-G1-R000894" flag="fatal" test="normalize-space(cbc:Name) = 'Antall umerkede enheter'">Property 'Antall umerkede enheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000895" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall umerkede enheter' may be used.</assert>
    <assert id="EHF-QII-G1-R000896" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall umerkede enheter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErnaringsmessigePastander']]">
    <assert id="EHF-QII-G1-R000897" flag="fatal" test="normalize-space(cbc:Name) = 'Ernæringsmessige påstander'">Property 'Ernæringsmessige påstander' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000898" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Ernæringsmessige påstander' may be used.</assert>
    <assert id="EHF-QII-G1-R000899" flag="fatal" test="normalize-space(cbc:Value)">Property 'Ernæringsmessige påstander' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000900" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2560">Property 'Ernæringsmessige påstander' value must have a length of maximum 2560 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Ingredienser']]">
    <assert id="EHF-QII-G1-R000901" flag="fatal" test="normalize-space(cbc:Name) = 'Ingredienser'">Property 'Ingredienser' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000902" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Ingredienser' may be used.</assert>
    <assert id="EHF-QII-G1-R000903" flag="fatal" test="normalize-space(cbc:Value)">Property 'Ingredienser' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000904" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2560">Property 'Ingredienser' value must have a length of maximum 2560 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Umerketvariantbeskrivelse']]">
    <assert id="EHF-QII-G1-R000905" flag="fatal" test="normalize-space(cbc:Name) = 'Umerketvariantbeskrivelse'">Property 'Umerketvariantbeskrivelse' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000906" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Umerketvariantbeskrivelse' may be used.</assert>
    <assert id="EHF-QII-G1-R000907" flag="fatal" test="normalize-space(cbc:Value)">Property 'Umerketvariantbeskrivelse' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000908" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Umerketvariantbeskrivelse' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Umerketvariantnr']]">
    <assert id="EHF-QII-G1-R000909" flag="fatal" test="normalize-space(cbc:Name) = 'Umerketvariantnr'">Property 'Umerketvariantnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000910" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Umerketvariantnr' may be used.</assert>
    <assert id="EHF-QII-G1-R000911" flag="fatal" test="normalize-space(cbc:Value)">Property 'Umerketvariantnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.energi_kcal_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R000912" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Energi kcal pr 100 g/ml'">Property 'Næringsinnhold, Energi kcal pr 100 g/ml' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000913" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Energi kcal pr 100 g/ml'.</assert>
    <assert id="EHF-QII-G1-R000914" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Energi kcal pr 100 g/ml' may be used.</assert>
    <assert id="EHF-QII-G1-R000915" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Energi kcal pr 100 g/ml' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000916" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Energi kcal pr 100 g/ml' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.energi_kj_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R000917" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Energi kj pr 100 g/ml'">Property 'Næringsinnhold, Energi kj pr 100 g/ml' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000918" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Energi kj pr 100 g/ml'.</assert>
    <assert id="EHF-QII-G1-R000919" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Energi kj pr 100 g/ml' may be used.</assert>
    <assert id="EHF-QII-G1-R000920" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Energi kj pr 100 g/ml' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000921" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Energi kj pr 100 g/ml' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.fett_totalt_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R000922" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Fett (totalt) pr 100 g/ml'">Property 'Næringsinnhold, Fett (totalt) pr 100 g/ml' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000923" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Fett (totalt) pr 100 g/ml'.</assert>
    <assert id="EHF-QII-G1-R000924" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Fett (totalt) pr 100 g/ml' may be used.</assert>
    <assert id="EHF-QII-G1-R000925" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Fett (totalt) pr 100 g/ml' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000926" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Fett (totalt) pr 100 g/ml' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.karbohydrater_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R000927" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Karbohydrater pr 100 g/ml'">Property 'Næringsinnhold, Karbohydrater pr 100 g/ml' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000928" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Karbohydrater pr 100 g/ml'.</assert>
    <assert id="EHF-QII-G1-R000929" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Karbohydrater pr 100 g/ml' may be used.</assert>
    <assert id="EHF-QII-G1-R000930" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Karbohydrater pr 100 g/ml' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000931" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Karbohydrater pr 100 g/ml' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.mettede_fettsyrer_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R000932" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml'">Property 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000933" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml'.</assert>
    <assert id="EHF-QII-G1-R000934" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml' may be used.</assert>
    <assert id="EHF-QII-G1-R000935" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000936" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.protein_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R000937" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Protein pr 100 g/ml'">Property 'Næringsinnhold, Protein pr 100 g/ml' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000938" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Protein pr 100 g/ml'.</assert>
    <assert id="EHF-QII-G1-R000939" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Protein pr 100 g/ml' may be used.</assert>
    <assert id="EHF-QII-G1-R000940" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Protein pr 100 g/ml' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000941" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Protein pr 100 g/ml' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.salt_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R000942" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Salt pr 100 g/ml'">Property 'Næringsinnhold, Salt pr 100 g/ml' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000943" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Salt pr 100 g/ml'.</assert>
    <assert id="EHF-QII-G1-R000944" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Salt pr 100 g/ml' may be used.</assert>
    <assert id="EHF-QII-G1-R000945" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Salt pr 100 g/ml' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000946" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Salt pr 100 g/ml' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.sukkerarter_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R000947" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Sukkerarter pr 100 g/ml'">Property 'Næringsinnhold, Sukkerarter pr 100 g/ml' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000948" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Sukkerarter pr 100 g/ml'.</assert>
    <assert id="EHF-QII-G1-R000949" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Sukkerarter pr 100 g/ml' may be used.</assert>
    <assert id="EHF-QII-G1-R000950" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Sukkerarter pr 100 g/ml' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000951" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Sukkerarter pr 100 g/ml' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.bitoin_mikrogr']]">
    <assert id="EHF-QII-G1-R000952" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Biotin (mikrogram) pr 100g'">Property 'Næringsinnhold, Biotin (mikrogram) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000953" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Biotin (mikrogram) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R000954" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Biotin (mikrogram) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R000955" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Biotin (mikrogram) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000956" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Biotin (mikrogram) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.fluorid_mg']]">
    <assert id="EHF-QII-G1-R000957" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Fluorid (mg) pr 100g'">Property 'Næringsinnhold, Fluorid (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000958" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Fluorid (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R000959" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Fluorid (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R000960" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Fluorid (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000961" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Fluorid (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.fosfor_mg']]">
    <assert id="EHF-QII-G1-R000962" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Fosfor (mg) pr 100g'">Property 'Næringsinnhold, Fosfor (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000963" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Fosfor (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R000964" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Fosfor (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R000965" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Fosfor (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000966" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Fosfor (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.jern_mg']]">
    <assert id="EHF-QII-G1-R000967" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Jern (mg) pr 100g'">Property 'Næringsinnhold, Jern (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000968" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Jern (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R000969" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Jern (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R000970" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Jern (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000971" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Jern (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.jod_mikrogr']]">
    <assert id="EHF-QII-G1-R000972" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Jod (mikrogram) pr 100g'">Property 'Næringsinnhold, Jod (mikrogram) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000973" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Jod (mikrogram) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R000974" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Jod (mikrogram) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R000975" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Jod (mikrogram) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000976" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Jod (mikrogram) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.kalium_mg']]">
    <assert id="EHF-QII-G1-R000977" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kalium (mg) pr 100g'">Property 'Næringsinnhold, Kalium (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000978" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kalium (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R000979" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kalium (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R000980" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kalium (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000981" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kalium (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.kalsium_mg']]">
    <assert id="EHF-QII-G1-R000982" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kalsium (mg) pr 100g'">Property 'Næringsinnhold, Kalsium (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000983" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kalsium (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R000984" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kalsium (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R000985" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kalsium (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000986" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kalsium (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.klorid_mg']]">
    <assert id="EHF-QII-G1-R000987" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Klorid (mg) pr 100g'">Property 'Næringsinnhold, Klorid (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000988" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Klorid (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R000989" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Klorid (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R000990" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Klorid (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000991" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Klorid (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.kobber_mg']]">
    <assert id="EHF-QII-G1-R000992" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kobber (mg) pr 100g'">Property 'Næringsinnhold, Kobber (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000993" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kobber (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R000994" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kobber (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R000995" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kobber (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R000996" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kobber (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.krom_mikrogr']]">
    <assert id="EHF-QII-G1-R000997" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Krom (mikrogram) pr 100g'">Property 'Næringsinnhold, Krom (mikrogram) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R000998" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Krom (mikrogram) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R000999" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Krom (mikrogram) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001000" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Krom (mikrogram) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001001" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Krom (mikrogram) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.magnesium_mg']]">
    <assert id="EHF-QII-G1-R001002" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Magnesium (mg) pr 100g'">Property 'Næringsinnhold, Magnesium (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001003" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Magnesium (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001004" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Magnesium (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001005" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Magnesium (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001006" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Magnesium (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.mangan_mg']]">
    <assert id="EHF-QII-G1-R001007" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Mangan (mg) pr 100g'">Property 'Næringsinnhold, Mangan (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001008" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Mangan (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001009" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Mangan (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001010" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Mangan (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001011" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Mangan (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.molybden_mikrogr']]">
    <assert id="EHF-QII-G1-R001012" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Molybden (mikrogram) pr 100g'">Property 'Næringsinnhold, Molybden (mikrogram) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001013" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Molybden (mikrogram) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001014" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Molybden (mikrogram) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001015" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Molybden (mikrogram) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001016" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Molybden (mikrogram) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.niacin_mg']]">
    <assert id="EHF-QII-G1-R001017" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Niacin (mg) pr 100g'">Property 'Næringsinnhold, Niacin (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001018" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Niacin (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001019" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Niacin (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001020" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Niacin (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001021" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Niacin (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.pantotensyre_mg']]">
    <assert id="EHF-QII-G1-R001022" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Pantotensyre (mg) pr 100g'">Property 'Næringsinnhold, Pantotensyre (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001023" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Pantotensyre (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001024" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Pantotensyre (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001025" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Pantotensyre (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001026" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Pantotensyre (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_bitoin']]">
    <assert id="EHF-QII-G1-R001027" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001028" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001029" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001030" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001031" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_fluorid']]">
    <assert id="EHF-QII-G1-R001032" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001033" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001034" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001035" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001036" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_folinsyre']]">
    <assert id="EHF-QII-G1-R001037" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001038" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001039" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001040" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001041" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_fosfor']]">
    <assert id="EHF-QII-G1-R001042" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001043" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001044" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001045" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001046" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_jern']]">
    <assert id="EHF-QII-G1-R001047" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Jern (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Jern (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001048" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Jern (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001049" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Jern (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001050" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Jern (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001051" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Jern (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_jod']]">
    <assert id="EHF-QII-G1-R001052" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Jod (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Jod (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001053" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Jod (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001054" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Jod (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001055" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Jod (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001056" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Jod (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_kalium']]">
    <assert id="EHF-QII-G1-R001057" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001058" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001059" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001060" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001061" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_kalsium']]">
    <assert id="EHF-QII-G1-R001062" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001063" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001064" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001065" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001066" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_klorid']]">
    <assert id="EHF-QII-G1-R001067" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001068" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001069" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001070" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001071" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_kobber']]">
    <assert id="EHF-QII-G1-R001072" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001073" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001074" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001075" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001076" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_krom']]">
    <assert id="EHF-QII-G1-R001077" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Krom (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Krom (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001078" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Krom (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001079" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Krom (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001080" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Krom (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001081" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Krom (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_magnesium']]">
    <assert id="EHF-QII-G1-R001082" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001083" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001084" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001085" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001086" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_mangan']]">
    <assert id="EHF-QII-G1-R001087" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001088" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001089" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001090" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001091" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_molybden']]">
    <assert id="EHF-QII-G1-R001092" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001093" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001094" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001095" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001096" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_niacin']]">
    <assert id="EHF-QII-G1-R001097" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001098" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001099" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001100" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001101" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_pantotensyre']]">
    <assert id="EHF-QII-G1-R001102" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001103" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001104" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001105" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001106" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_riboflavin']]">
    <assert id="EHF-QII-G1-R001107" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001108" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001109" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001110" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001111" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_selen']]">
    <assert id="EHF-QII-G1-R001112" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Selen (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Selen (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001113" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Selen (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001114" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Selen (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001115" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Selen (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001116" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Selen (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_sink']]">
    <assert id="EHF-QII-G1-R001117" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Sink (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Sink (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001118" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Sink (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001119" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Sink (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001120" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Sink (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001121" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Sink (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_tiamin']]">
    <assert id="EHF-QII-G1-R001122" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001123" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001124" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001125" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001126" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_a']]">
    <assert id="EHF-QII-G1-R001127" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001128" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001129" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001130" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001131" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_b12']]">
    <assert id="EHF-QII-G1-R001132" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001133" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001134" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001135" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001136" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_b6']]">
    <assert id="EHF-QII-G1-R001137" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001138" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001139" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001140" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001141" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_c']]">
    <assert id="EHF-QII-G1-R001142" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001143" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001144" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001145" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001146" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_d']]">
    <assert id="EHF-QII-G1-R001147" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001148" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001149" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001150" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001151" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_e']]">
    <assert id="EHF-QII-G1-R001152" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001153" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001154" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001155" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001156" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_k']]">
    <assert id="EHF-QII-G1-R001157" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak)'">Property 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001158" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001159" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001160" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001161" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.riboflavin_mg']]">
    <assert id="EHF-QII-G1-R001162" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Riboflavin (mg) pr 100g'">Property 'Næringsinnhold, Riboflavin (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001163" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Riboflavin (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001164" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Riboflavin (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001165" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Riboflavin (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001166" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Riboflavin (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.selen_mikrogr']]">
    <assert id="EHF-QII-G1-R001167" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Selen (mikrogram) pr 100g'">Property 'Næringsinnhold, Selen (mikrogram) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001168" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Selen (mikrogram) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001169" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Selen (mikrogram) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001170" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Selen (mikrogram) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001171" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Selen (mikrogram) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.sink_mg']]">
    <assert id="EHF-QII-G1-R001172" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Sink (mg) pr 100g'">Property 'Næringsinnhold, Sink (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001173" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Sink (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001174" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Sink (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001175" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Sink (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001176" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Sink (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.tiamin_mg']]">
    <assert id="EHF-QII-G1-R001177" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Tiamin (mg) pr 100g'">Property 'Næringsinnhold, Tiamin (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001178" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Tiamin (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001179" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Tiamin (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001180" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Tiamin (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001181" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Tiamin (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_a_mikrogr']]">
    <assert id="EHF-QII-G1-R001182" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin A (mikrogram) pr 100g'">Property 'Næringsinnhold, Vitamin A (mikrogram) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001183" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin A (mikrogram) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001184" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin A (mikrogram) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001185" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin A (mikrogram) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001186" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin A (mikrogram) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_b12_mikrogr']]">
    <assert id="EHF-QII-G1-R001187" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g'">Property 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001188" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001189" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001190" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001191" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_b6_mg']]">
    <assert id="EHF-QII-G1-R001192" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin B6 (mg) pr 100g'">Property 'Næringsinnhold, Vitamin B6 (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001193" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin B6 (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001194" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin B6 (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001195" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin B6 (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001196" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin B6 (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_c_mikrogr']]">
    <assert id="EHF-QII-G1-R001197" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin C (mg) pr 100g'">Property 'Næringsinnhold, Vitamin C (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001198" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin C (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001199" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin C (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001200" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin C (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001201" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin C (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_d_mikrogr']]">
    <assert id="EHF-QII-G1-R001202" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin D (mikrogram) pr 100g'">Property 'Næringsinnhold, Vitamin D (mikrogram) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001203" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin D (mikrogram) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001204" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin D (mikrogram) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001205" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin D (mikrogram) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001206" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin D (mikrogram) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_e_mg']]">
    <assert id="EHF-QII-G1-R001207" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin E (mg) pr 100g'">Property 'Næringsinnhold, Vitamin E (mg) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001208" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin E (mg) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001209" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin E (mg) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001210" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin E (mg) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001211" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin E (mg) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_k_mikrogr']]">
    <assert id="EHF-QII-G1-R001212" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin K (mikrogram) pr 100g'">Property 'Næringsinnhold, Vitamin K (mikrogram) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001213" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin K (mikrogram) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001214" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin K (mikrogram) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001215" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin K (mikrogram) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001216" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin K (mikrogram) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.enummettede_fettsyrer_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R001217" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml'">Property 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001218" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml'.</assert>
    <assert id="EHF-QII-G1-R001219" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml' may be used.</assert>
    <assert id="EHF-QII-G1-R001220" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001221" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.flerumettede_fettsyrer_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R001222" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml'">Property 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001223" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml'.</assert>
    <assert id="EHF-QII-G1-R001224" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml' may be used.</assert>
    <assert id="EHF-QII-G1-R001225" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001226" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.polyoler_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R001227" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Polyoler pr 100 g/ml'">Property 'Næringsinnhold, Polyoler pr 100 g/ml' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001228" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Polyoler pr 100 g/ml'.</assert>
    <assert id="EHF-QII-G1-R001229" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Polyoler pr 100 g/ml' may be used.</assert>
    <assert id="EHF-QII-G1-R001230" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Polyoler pr 100 g/ml' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001231" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Polyoler pr 100 g/ml' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.stivelse_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R001232" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Stivelse pr 100 g/ml'">Property 'Næringsinnhold, Stivelse pr 100 g/ml' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001233" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Stivelse pr 100 g/ml'.</assert>
    <assert id="EHF-QII-G1-R001234" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Stivelse pr 100 g/ml' may be used.</assert>
    <assert id="EHF-QII-G1-R001235" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Stivelse pr 100 g/ml' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001236" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Stivelse pr 100 g/ml' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.kostfibre_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R001237" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kostfiber pr 100 g/ml'">Property 'Næringsinnhold, Kostfiber pr 100 g/ml' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001238" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kostfiber pr 100 g/ml'.</assert>
    <assert id="EHF-QII-G1-R001239" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kostfiber pr 100 g/ml' may be used.</assert>
    <assert id="EHF-QII-G1-R001240" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kostfiber pr 100 g/ml' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001241" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kostfiber pr 100 g/ml' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.folinsyre_mikrogr']]">
    <assert id="EHF-QII-G1-R001242" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Folinsyre (mikrogram) pr 100g'">Property 'Næringsinnhold, Folinsyre (mikrogram) pr 100g' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001243" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Folinsyre (mikrogram) pr 100g'.</assert>
    <assert id="EHF-QII-G1-R001244" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Folinsyre (mikrogram) pr 100g' may be used.</assert>
    <assert id="EHF-QII-G1-R001245" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Folinsyre (mikrogram) pr 100g' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001246" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Folinsyre (mikrogram) pr 100g' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.bitoin_mikrogr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001247" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Biotin (mikrogram) pr porsjon'">Property 'Referanseinntak, Biotin (mikrogram) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001248" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Biotin (mikrogram) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001249" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Biotin (mikrogram) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001250" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Biotin (mikrogram) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001251" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Biotin (mikrogram) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.energi_kcal_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001252" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Energi kcal pr porsjon'">Property 'Referanseinntak, Energi kcal pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001253" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Energi kcal pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001254" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Energi kcal pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001255" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Energi kcal pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001256" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Energi kcal pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.energi_kj_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001257" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Energi kj pr porsjon'">Property 'Referanseinntak, Energi kj pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001258" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Energi kj pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001259" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Energi kj pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001260" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Energi kj pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001261" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Energi kj pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.fett_gr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001262" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Fett gram pr porsjon'">Property 'Referanseinntak, Fett gram pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001263" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Fett gram pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001264" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Fett gram pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001265" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Fett gram pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001266" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Fett gram pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.fluorid_mg_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001267" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Fluorid (mg) pr porsjon'">Property 'Referanseinntak, Fluorid (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001268" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Fluorid (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001269" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Fluorid (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001270" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Fluorid (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001271" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Fluorid (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.fosfor_mg_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001272" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Fosfor (mg) pr porsjon'">Property 'Referanseinntak, Fosfor (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001273" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Fosfor (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001274" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Fosfor (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001275" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Fosfor (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001276" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Fosfor (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.jern_mg_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001277" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Jern (mg) pr porsjon'">Property 'Referanseinntak, Jern (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001278" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Jern (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001279" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Jern (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001280" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Jern (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001281" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Jern (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.jod_mikrogr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001282" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Jod (mikrogram) pr porsjon'">Property 'Referanseinntak, Jod (mikrogram) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001283" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Jod (mikrogram) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001284" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Jod (mikrogram) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001285" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Jod (mikrogram) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001286" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Jod (mikrogram) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.kalium_mg_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001287" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Kalium (mg) pr porsjon'">Property 'Referanseinntak, Kalium (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001288" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Kalium (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001289" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Kalium (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001290" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Kalium (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001291" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Kalium (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.kalsium_mg_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001292" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Kalsium (mg) pr porsjon'">Property 'Referanseinntak, Kalsium (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001293" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Kalsium (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001294" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Kalsium (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001295" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Kalsium (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001296" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Kalsium (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.karbohydrater_gr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001297" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Karbohydrater gram pr porsjon'">Property 'Referanseinntak, Karbohydrater gram pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001298" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Karbohydrater gram pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001299" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Karbohydrater gram pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001300" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Karbohydrater gram pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001301" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Karbohydrater gram pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.klorid_pr_porsjon_mg']]">
    <assert id="EHF-QII-G1-R001302" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Klorid (mg) pr porsjon'">Property 'Referanseinntak, Klorid (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001303" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Klorid (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001304" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Klorid (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001305" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Klorid (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001306" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Klorid (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.kobber_mg_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001307" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Kobber (mg) pr porsjon'">Property 'Referanseinntak, Kobber (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001308" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Kobber (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001309" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Kobber (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001310" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Kobber (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001311" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Kobber (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.krom_mikrogr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001312" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Krom (mikrogram) pr porsjon'">Property 'Referanseinntak, Krom (mikrogram) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001313" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Krom (mikrogram) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001314" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Krom (mikrogram) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001315" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Krom (mikrogram) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001316" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Krom (mikrogram) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.magnesium_mg_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001317" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Magnesium (mg) pr porsjon'">Property 'Referanseinntak, Magnesium (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001318" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Magnesium (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001319" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Magnesium (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001320" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Magnesium (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001321" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Magnesium (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.mangan_mg_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001322" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Mangan (mg) pr porsjon'">Property 'Referanseinntak, Mangan (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001323" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Mangan (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001324" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Mangan (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001325" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Mangan (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001326" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Mangan (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.mettet_fett_gr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001327" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Mettet fett gram pr porsjon'">Property 'Referanseinntak, Mettet fett gram pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001328" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Mettet fett gram pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001329" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Mettet fett gram pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001330" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Mettet fett gram pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001331" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Mettet fett gram pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.molybden_mikrogr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001332" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Molybden (mikrogram) pr porsjon'">Property 'Referanseinntak, Molybden (mikrogram) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001333" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Molybden (mikrogram) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001334" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Molybden (mikrogram) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001335" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Molybden (mikrogram) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001336" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Molybden (mikrogram) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.niacin_mg_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001337" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Niacin (mg) pr porsjon'">Property 'Referanseinntak, Niacin (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001338" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Niacin (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001339" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Niacin (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001340" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Niacin (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001341" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Niacin (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.pantotensyre_mg_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001342" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Pantotensyre (mg) pr porsjon'">Property 'Referanseinntak, Pantotensyre (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001343" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Pantotensyre (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001344" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Pantotensyre (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001345" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Pantotensyre (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001346" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Pantotensyre (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.porsjonsstorrelse_mengde']]">
    <assert id="EHF-QII-G1-R001347" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Porsjonsstørrelse mengde'">Property 'Referanseinntak, Porsjonsstørrelse mengde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001348" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Porsjonsstørrelse mengde'.</assert>
    <assert id="EHF-QII-G1-R001349" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Porsjonsstørrelse mengde' may be used.</assert>
    <assert id="EHF-QII-G1-R001350" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Porsjonsstørrelse mengde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001351" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Porsjonsstørrelse mengde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_energi_kcal']]">
    <assert id="EHF-QII-G1-R001352" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Energi kcal i prosent pr porsjon av en voksens veiledende daglig inntak'">Property 'Referanseinntak, Energi kcal i prosent pr porsjon av en voksens veiledende daglig inntak' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001353" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Energi kcal i prosent pr porsjon av en voksens veiledende daglig inntak'.</assert>
    <assert id="EHF-QII-G1-R001354" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Energi kcal i prosent pr porsjon av en voksens veiledende daglig inntak' may be used.</assert>
    <assert id="EHF-QII-G1-R001355" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Energi kcal i prosent pr porsjon av en voksens veiledende daglig inntak' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001356" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Energi kcal i prosent pr porsjon av en voksens veiledende daglig inntak' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_energi_kj']]">
    <assert id="EHF-QII-G1-R001357" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Energi kj i prosent pr porsjon av en voksens veiledende daglig inntak'">Property 'Referanseinntak, Energi kj i prosent pr porsjon av en voksens veiledende daglig inntak' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001358" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Energi kj i prosent pr porsjon av en voksens veiledende daglig inntak'.</assert>
    <assert id="EHF-QII-G1-R001359" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Energi kj i prosent pr porsjon av en voksens veiledende daglig inntak' may be used.</assert>
    <assert id="EHF-QII-G1-R001360" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Energi kj i prosent pr porsjon av en voksens veiledende daglig inntak' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001361" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Energi kj i prosent pr porsjon av en voksens veiledende daglig inntak' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_fett']]">
    <assert id="EHF-QII-G1-R001362" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Fett i prosent pr porsjon av en voksens veiledende daglig inntak'">Property 'Referanseinntak, Fett i prosent pr porsjon av en voksens veiledende daglig inntak' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001363" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Fett i prosent pr porsjon av en voksens veiledende daglig inntak'.</assert>
    <assert id="EHF-QII-G1-R001364" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Fett i prosent pr porsjon av en voksens veiledende daglig inntak' may be used.</assert>
    <assert id="EHF-QII-G1-R001365" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Fett i prosent pr porsjon av en voksens veiledende daglig inntak' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001366" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Fett i prosent pr porsjon av en voksens veiledende daglig inntak' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_fluorid_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001367" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Fluorid (prosentandel daglig referanseinntak pr porsjon)'">Property 'Referanseinntak, Fluorid (prosentandel daglig referanseinntak pr porsjon)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001368" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Fluorid (prosentandel daglig referanseinntak pr porsjon)'.</assert>
    <assert id="EHF-QII-G1-R001369" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Fluorid (prosentandel daglig referanseinntak pr porsjon)' may be used.</assert>
    <assert id="EHF-QII-G1-R001370" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Fluorid (prosentandel daglig referanseinntak pr porsjon)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001371" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Fluorid (prosentandel daglig referanseinntak pr porsjon)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_fosfor_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001372" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Fosfor (prosentandel daglig referanseinntak pr porsjon)'">Property 'Referanseinntak, Fosfor (prosentandel daglig referanseinntak pr porsjon)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001373" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Fosfor (prosentandel daglig referanseinntak pr porsjon)'.</assert>
    <assert id="EHF-QII-G1-R001374" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Fosfor (prosentandel daglig referanseinntak pr porsjon)' may be used.</assert>
    <assert id="EHF-QII-G1-R001375" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Fosfor (prosentandel daglig referanseinntak pr porsjon)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001376" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Fosfor (prosentandel daglig referanseinntak pr porsjon)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_jern_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001377" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Jern (prosentandel daglig referanseinntak pr porsjon)'">Property 'Referanseinntak, Jern (prosentandel daglig referanseinntak pr porsjon)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001378" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Jern (prosentandel daglig referanseinntak pr porsjon)'.</assert>
    <assert id="EHF-QII-G1-R001379" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Jern (prosentandel daglig referanseinntak pr porsjon)' may be used.</assert>
    <assert id="EHF-QII-G1-R001380" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Jern (prosentandel daglig referanseinntak pr porsjon)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001381" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Jern (prosentandel daglig referanseinntak pr porsjon)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_jod_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001382" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Jod (prosentandel daglig referanseinntak pr porsjon)'">Property 'Referanseinntak, Jod (prosentandel daglig referanseinntak pr porsjon)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001383" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Jod (prosentandel daglig referanseinntak pr porsjon)'.</assert>
    <assert id="EHF-QII-G1-R001384" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Jod (prosentandel daglig referanseinntak pr porsjon)' may be used.</assert>
    <assert id="EHF-QII-G1-R001385" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Jod (prosentandel daglig referanseinntak pr porsjon)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001386" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Jod (prosentandel daglig referanseinntak pr porsjon)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_kalium_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001387" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Kalium (prosentandel daglig referanseinntak)'">Property 'Referanseinntak, Kalium (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001388" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Kalium (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001389" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Kalium (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001390" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Kalium (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001391" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Kalium (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_kalsium_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001392" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Kalsium (prosentandel daglig referanseinntak) (referanseinntak)'">Property 'Referanseinntak, Kalsium (prosentandel daglig referanseinntak) (referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001393" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Kalsium (prosentandel daglig referanseinntak) (referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001394" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Kalsium (prosentandel daglig referanseinntak) (referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001395" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Kalsium (prosentandel daglig referanseinntak) (referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001396" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Kalsium (prosentandel daglig referanseinntak) (referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_karbohydrater']]">
    <assert id="EHF-QII-G1-R001397" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Karbohydrater i prosent pr porsjon av en voksens veiledende daglig inntak'">Property 'Referanseinntak, Karbohydrater i prosent pr porsjon av en voksens veiledende daglig inntak' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001398" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Karbohydrater i prosent pr porsjon av en voksens veiledende daglig inntak'.</assert>
    <assert id="EHF-QII-G1-R001399" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Karbohydrater i prosent pr porsjon av en voksens veiledende daglig inntak' may be used.</assert>
    <assert id="EHF-QII-G1-R001400" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Karbohydrater i prosent pr porsjon av en voksens veiledende daglig inntak' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001401" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Karbohydrater i prosent pr porsjon av en voksens veiledende daglig inntak' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_klorid_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001402" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Klorid (prosentandel daglig referanseinntak)'">Property 'Referanseinntak, Klorid (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001403" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Klorid (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001404" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Klorid (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001405" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Klorid (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001406" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Klorid (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_kobber_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001407" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Kobber (prosentandel daglig referanseinntak) (referanseinntak)'">Property 'Referanseinntak, Kobber (prosentandel daglig referanseinntak) (referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001408" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Kobber (prosentandel daglig referanseinntak) (referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001409" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Kobber (prosentandel daglig referanseinntak) (referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001410" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Kobber (prosentandel daglig referanseinntak) (referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001411" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Kobber (prosentandel daglig referanseinntak) (referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_krom_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001412" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Krom (prosentandel daglig referanseinntak)'">Property 'Referanseinntak, Krom (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001413" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Krom (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001414" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Krom (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001415" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Krom (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001416" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Krom (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_magnesium_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001417" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Magnesium (prosentandel daglig referanseinntak)'">Property 'Referanseinntak, Magnesium (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001418" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Magnesium (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001419" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Magnesium (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001420" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Magnesium (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001421" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Magnesium (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_mangan_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001422" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Mangan (prosentandel daglig referanseinntak)'">Property 'Referanseinntak, Mangan (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001423" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Mangan (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001424" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Mangan (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001425" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Mangan (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001426" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Mangan (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_mettet_fett']]">
    <assert id="EHF-QII-G1-R001427" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Mettet fett i prosent pr porsjon av en voksens veiledende daglig inntak'">Property 'Referanseinntak, Mettet fett i prosent pr porsjon av en voksens veiledende daglig inntak' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001428" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Mettet fett i prosent pr porsjon av en voksens veiledende daglig inntak'.</assert>
    <assert id="EHF-QII-G1-R001429" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Mettet fett i prosent pr porsjon av en voksens veiledende daglig inntak' may be used.</assert>
    <assert id="EHF-QII-G1-R001430" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Mettet fett i prosent pr porsjon av en voksens veiledende daglig inntak' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001431" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Mettet fett i prosent pr porsjon av en voksens veiledende daglig inntak' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_molybden_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001432" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Molybden (prosentandel daglig referanseinntak)'">Property 'Referanseinntak, Molybden (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001433" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Molybden (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001434" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Molybden (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001435" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Molybden (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001436" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Molybden (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_protein']]">
    <assert id="EHF-QII-G1-R001437" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Protein i prosent pr porsjon av en voksens veiledende daglig inntak'">Property 'Referanseinntak, Protein i prosent pr porsjon av en voksens veiledende daglig inntak' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001438" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Protein i prosent pr porsjon av en voksens veiledende daglig inntak'.</assert>
    <assert id="EHF-QII-G1-R001439" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Protein i prosent pr porsjon av en voksens veiledende daglig inntak' may be used.</assert>
    <assert id="EHF-QII-G1-R001440" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Protein i prosent pr porsjon av en voksens veiledende daglig inntak' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001441" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Protein i prosent pr porsjon av en voksens veiledende daglig inntak' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_salt']]">
    <assert id="EHF-QII-G1-R001442" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Salt i prosent pr porsjon av en voksens veiledende daglig inntak'">Property 'Referanseinntak, Salt i prosent pr porsjon av en voksens veiledende daglig inntak' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001443" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Salt i prosent pr porsjon av en voksens veiledende daglig inntak'.</assert>
    <assert id="EHF-QII-G1-R001444" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Salt i prosent pr porsjon av en voksens veiledende daglig inntak' may be used.</assert>
    <assert id="EHF-QII-G1-R001445" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Salt i prosent pr porsjon av en voksens veiledende daglig inntak' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001446" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Salt i prosent pr porsjon av en voksens veiledende daglig inntak' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_selen_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001447" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Selen (prosentandel daglig referanseinntak)'">Property 'Referanseinntak, Selen (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001448" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Selen (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001449" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Selen (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001450" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Selen (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001451" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Selen (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_sink_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001452" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Sink (prosentandel daglig referanseinntak)'">Property 'Referanseinntak, Sink (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001453" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Sink (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001454" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Sink (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001455" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Sink (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001456" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Sink (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_sukkerarter']]">
    <assert id="EHF-QII-G1-R001457" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Sukkerarter i prosent pr porsjon av en voksens veiledende daglig inntak'">Property 'Referanseinntak, Sukkerarter i prosent pr porsjon av en voksens veiledende daglig inntak' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001458" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Sukkerarter i prosent pr porsjon av en voksens veiledende daglig inntak'.</assert>
    <assert id="EHF-QII-G1-R001459" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Sukkerarter i prosent pr porsjon av en voksens veiledende daglig inntak' may be used.</assert>
    <assert id="EHF-QII-G1-R001460" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Sukkerarter i prosent pr porsjon av en voksens veiledende daglig inntak' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001461" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Sukkerarter i prosent pr porsjon av en voksens veiledende daglig inntak' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_vitamin_d_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001462" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Vitamin D (prosentandel daglig referanseinntak pr porsjon)'">Property 'Referanseinntak, Vitamin D (prosentandel daglig referanseinntak pr porsjon)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001463" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Vitamin D (prosentandel daglig referanseinntak pr porsjon)'.</assert>
    <assert id="EHF-QII-G1-R001464" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Vitamin D (prosentandel daglig referanseinntak pr porsjon)' may be used.</assert>
    <assert id="EHF-QII-G1-R001465" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Vitamin D (prosentandel daglig referanseinntak pr porsjon)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001466" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Vitamin D (prosentandel daglig referanseinntak pr porsjon)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.protein_gr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001467" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Protein gram pr porsjon'">Property 'Referanseinntak, Protein gram pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001468" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Protein gram pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001469" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Protein gram pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001470" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Protein gram pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001471" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Protein gram pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.riboflavin_mg_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001472" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Riboflavin (mg) pr porsjon'">Property 'Referanseinntak, Riboflavin (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001473" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Riboflavin (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001474" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Riboflavin (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001475" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Riboflavin (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001476" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Riboflavin (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.salt_gr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001477" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Salt gram pr porsjon'">Property 'Referanseinntak, Salt gram pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001478" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Salt gram pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001479" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Salt gram pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001480" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Salt gram pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001481" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Salt gram pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.selen_mikrogr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001482" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Selen (mikrogram) pr porsjon'">Property 'Referanseinntak, Selen (mikrogram) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001483" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Selen (mikrogram) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001484" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Selen (mikrogram) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001485" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Selen (mikrogram) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001486" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Selen (mikrogram) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.sink_mg_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001487" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Sink (mg) pr porsjon'">Property 'Referanseinntak, Sink (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001488" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Sink (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001489" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Sink (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001490" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Sink (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001491" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Sink (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.tiamin_mg_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001492" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Tiamin (mg) pr porsjon'">Property 'Referanseinntak, Tiamin (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001493" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Tiamin (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001494" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Tiamin (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001495" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Tiamin (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001496" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Tiamin (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.vitamin_a_mikrogr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001497" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Vitamin A (mikrogram) pr porsjon'">Property 'Referanseinntak, Vitamin A (mikrogram) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001498" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Vitamin A (mikrogram) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001499" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Vitamin A (mikrogram) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001500" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Vitamin A (mikrogram) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001501" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Vitamin A (mikrogram) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.vitamin_b12_mikrogr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001502" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Vitamin B12 (mikrogram) pr porsjon'">Property 'Referanseinntak, Vitamin B12 (mikrogram) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001503" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Vitamin B12 (mikrogram) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001504" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Vitamin B12 (mikrogram) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001505" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Vitamin B12 (mikrogram) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001506" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Vitamin B12 (mikrogram) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.vitamin_b6_mg_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001507" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Vitamin B6 (mg) pr porsjon'">Property 'Referanseinntak, Vitamin B6 (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001508" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Vitamin B6 (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001509" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Vitamin B6 (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001510" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Vitamin B6 (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001511" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Vitamin B6 (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.vitamin_c_mikrogr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001512" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Vitamin C  (mg) pr porsjon'">Property 'Referanseinntak, Vitamin C  (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001513" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Vitamin C  (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001514" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Vitamin C  (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001515" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Vitamin C  (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001516" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Vitamin C  (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.vitamin_d_mikrogr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001517" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Vitamin D (mikrogram) pr porsjon'">Property 'Referanseinntak, Vitamin D (mikrogram) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001518" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Vitamin D (mikrogram) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001519" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Vitamin D (mikrogram) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001520" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Vitamin D (mikrogram) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001521" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Vitamin D (mikrogram) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.vitamin_k_mikrogr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001522" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Vitamin K (mikrogram)  pr porsjon'">Property 'Referanseinntak, Vitamin K (mikrogram)  pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001523" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Vitamin K (mikrogram)  pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001524" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Vitamin K (mikrogram)  pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001525" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Vitamin K (mikrogram)  pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001526" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Vitamin K (mikrogram)  pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_vitamin_a_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001527" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Vitamin A (prosentandel daglig referanseinntak pr porsjon)'">Property 'Referanseinntak, Vitamin A (prosentandel daglig referanseinntak pr porsjon)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001528" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Vitamin A (prosentandel daglig referanseinntak pr porsjon)'.</assert>
    <assert id="EHF-QII-G1-R001529" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Vitamin A (prosentandel daglig referanseinntak pr porsjon)' may be used.</assert>
    <assert id="EHF-QII-G1-R001530" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Vitamin A (prosentandel daglig referanseinntak pr porsjon)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001531" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Vitamin A (prosentandel daglig referanseinntak pr porsjon)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_vitamin_e_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001532" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Vitamin E (prosentandel daglig referanseinntak pr porsjon)'">Property 'Referanseinntak, Vitamin E (prosentandel daglig referanseinntak pr porsjon)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001533" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Vitamin E (prosentandel daglig referanseinntak pr porsjon)'.</assert>
    <assert id="EHF-QII-G1-R001534" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Vitamin E (prosentandel daglig referanseinntak pr porsjon)' may be used.</assert>
    <assert id="EHF-QII-G1-R001535" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Vitamin E (prosentandel daglig referanseinntak pr porsjon)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001536" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Vitamin E (prosentandel daglig referanseinntak pr porsjon)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_vitamin_k_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001537" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Vitamin K (prosentandel daglig referanseinntak pr porsjon)'">Property 'Referanseinntak, Vitamin K (prosentandel daglig referanseinntak pr porsjon)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001538" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Vitamin K (prosentandel daglig referanseinntak pr porsjon)'.</assert>
    <assert id="EHF-QII-G1-R001539" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Vitamin K (prosentandel daglig referanseinntak pr porsjon)' may be used.</assert>
    <assert id="EHF-QII-G1-R001540" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Vitamin K (prosentandel daglig referanseinntak pr porsjon)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001541" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Vitamin K (prosentandel daglig referanseinntak pr porsjon)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_vitamin_c_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001542" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Vitamin C (prosentandel daglig referanseinntak pr porsjon)'">Property 'Referanseinntak, Vitamin C (prosentandel daglig referanseinntak pr porsjon)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001543" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Vitamin C (prosentandel daglig referanseinntak pr porsjon)'.</assert>
    <assert id="EHF-QII-G1-R001544" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Vitamin C (prosentandel daglig referanseinntak pr porsjon)' may be used.</assert>
    <assert id="EHF-QII-G1-R001545" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Vitamin C (prosentandel daglig referanseinntak pr porsjon)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001546" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Vitamin C (prosentandel daglig referanseinntak pr porsjon)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_tiamin_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001547" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Tiamin (prosentandel daglig referanseinntak pr porsjon)'">Property 'Referanseinntak, Tiamin (prosentandel daglig referanseinntak pr porsjon)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001548" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Tiamin (prosentandel daglig referanseinntak pr porsjon)'.</assert>
    <assert id="EHF-QII-G1-R001549" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Tiamin (prosentandel daglig referanseinntak pr porsjon)' may be used.</assert>
    <assert id="EHF-QII-G1-R001550" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Tiamin (prosentandel daglig referanseinntak pr porsjon)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001551" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Tiamin (prosentandel daglig referanseinntak pr porsjon)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_riboflavin_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001552" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Riboflavin (prosentandel daglig referanseinntak)'">Property 'Referanseinntak, Riboflavin (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001553" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Riboflavin (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001554" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Riboflavin (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001555" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Riboflavin (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001556" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Riboflavin (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_niacin_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001557" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Niacin (prosentandel daglig referanseinntak)'">Property 'Referanseinntak, Niacin (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001558" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Niacin (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001559" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Niacin (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001560" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Niacin (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001561" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Niacin (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_vitamin_b6_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001562" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Vitamin B6 (prosentandel daglig referanseinntak pr porsjon)'">Property 'Referanseinntak, Vitamin B6 (prosentandel daglig referanseinntak pr porsjon)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001563" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Vitamin B6 (prosentandel daglig referanseinntak pr porsjon)'.</assert>
    <assert id="EHF-QII-G1-R001564" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Vitamin B6 (prosentandel daglig referanseinntak pr porsjon)' may be used.</assert>
    <assert id="EHF-QII-G1-R001565" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Vitamin B6 (prosentandel daglig referanseinntak pr porsjon)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001566" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Vitamin B6 (prosentandel daglig referanseinntak pr porsjon)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_folinsyre_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001567" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Folinsyre (prosentandel daglig referanseinntak pr porsjon)'">Property 'Referanseinntak, Folinsyre (prosentandel daglig referanseinntak pr porsjon)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001568" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Folinsyre (prosentandel daglig referanseinntak pr porsjon)'.</assert>
    <assert id="EHF-QII-G1-R001569" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Folinsyre (prosentandel daglig referanseinntak pr porsjon)' may be used.</assert>
    <assert id="EHF-QII-G1-R001570" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Folinsyre (prosentandel daglig referanseinntak pr porsjon)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001571" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Folinsyre (prosentandel daglig referanseinntak pr porsjon)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_vitamin_b12_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001572" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Vitamin B12 (prosentandel daglig referanseinntak pr porsjon)'">Property 'Referanseinntak, Vitamin B12 (prosentandel daglig referanseinntak pr porsjon)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001573" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Vitamin B12 (prosentandel daglig referanseinntak pr porsjon)'.</assert>
    <assert id="EHF-QII-G1-R001574" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Vitamin B12 (prosentandel daglig referanseinntak pr porsjon)' may be used.</assert>
    <assert id="EHF-QII-G1-R001575" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Vitamin B12 (prosentandel daglig referanseinntak pr porsjon)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001576" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Vitamin B12 (prosentandel daglig referanseinntak pr porsjon)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_bitoin_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001577" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Biotin (prosentandel daglig referanseinntak pr porsjon)'">Property 'Referanseinntak, Biotin (prosentandel daglig referanseinntak pr porsjon)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001578" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Biotin (prosentandel daglig referanseinntak pr porsjon)'.</assert>
    <assert id="EHF-QII-G1-R001579" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Biotin (prosentandel daglig referanseinntak pr porsjon)' may be used.</assert>
    <assert id="EHF-QII-G1-R001580" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Biotin (prosentandel daglig referanseinntak pr porsjon)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001581" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Biotin (prosentandel daglig referanseinntak pr porsjon)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.prosentandel_pantotensyre_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001582" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Pantotensyre (prosentandel daglig referanseinntak)'">Property 'Referanseinntak, Pantotensyre (prosentandel daglig referanseinntak)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001583" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Pantotensyre (prosentandel daglig referanseinntak)'.</assert>
    <assert id="EHF-QII-G1-R001584" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Pantotensyre (prosentandel daglig referanseinntak)' may be used.</assert>
    <assert id="EHF-QII-G1-R001585" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Pantotensyre (prosentandel daglig referanseinntak)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001586" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Pantotensyre (prosentandel daglig referanseinntak)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.porsjonsstorrelse_enhetsbeskrivelse']]">
    <assert id="EHF-QII-G1-R001587" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Porsjonsstørrelse enhetsbeskrivelse'">Property 'Referanseinntak, Porsjonsstørrelse enhetsbeskrivelse' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001588" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Porsjonsstørrelse enhetsbeskrivelse'.</assert>
    <assert id="EHF-QII-G1-R001589" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Porsjonsstørrelse enhetsbeskrivelse' may be used.</assert>
    <assert id="EHF-QII-G1-R001590" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Porsjonsstørrelse enhetsbeskrivelse' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001591" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Porsjonsstørrelse enhetsbeskrivelse' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.sukkerarter_gr']]">
    <assert id="EHF-QII-G1-R001592" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Herav sukkerarter gram'">Property 'Referanseinntak, Herav sukkerarter gram' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001593" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Herav sukkerarter gram'.</assert>
    <assert id="EHF-QII-G1-R001594" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Herav sukkerarter gram' may be used.</assert>
    <assert id="EHF-QII-G1-R001595" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Herav sukkerarter gram' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001596" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Herav sukkerarter gram' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.vitamin_e_mg_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001597" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Vitamin E  (mg) pr porsjon'">Property 'Referanseinntak, Vitamin E  (mg) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001598" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Vitamin E  (mg) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001599" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Vitamin E  (mg) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001600" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Vitamin E  (mg) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001601" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Vitamin E  (mg) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:naeringsmidler']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReferanseinntakListe.folinsyre_mikrogr_pr_porsjon']]">
    <assert id="EHF-QII-G1-R001602" flag="fatal" test="normalize-space(cbc:Name) = 'Referanseinntak, Folinsyre (mikrogram) pr porsjon'">Property 'Referanseinntak, Folinsyre (mikrogram) pr porsjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001603" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Referanseinntak, Folinsyre (mikrogram) pr porsjon'.</assert>
    <assert id="EHF-QII-G1-R001604" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Referanseinntak, Folinsyre (mikrogram) pr porsjon' may be used.</assert>
    <assert id="EHF-QII-G1-R001605" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Referanseinntak, Folinsyre (mikrogram) pr porsjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001606" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Referanseinntak, Folinsyre (mikrogram) pr porsjon' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]">
    <assert id="EHF-QII-G1-R001607" flag="fatal" test="cbc:Name">Property 'Name' is mandatory.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']"/>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cbc:Name">
    <assert id="EHF-QII-G1-R001608" flag="fatal" test="normalize-space()">Property 'Name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001609" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cbc:Description">
    <assert id="EHF-QII-G1-R001610" flag="fatal" test="normalize-space()">Property 'Description' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cbc:Keyword">
    <assert id="EHF-QII-G1-R001611" flag="fatal" test="normalize-space()">Property 'Keywords' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cbc:BrandName">
    <assert id="EHF-QII-G1-R001612" flag="fatal" test="normalize-space()">Property 'Brand name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001613" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Brand name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cbc:PackQuantity">
    <assert id="EHF-QII-G1-R001614" flag="fatal" test="normalize-space()">Property 'Packed quantity' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cbc:PackSizeNumeric">
    <assert id="EHF-QII-G1-R001615" flag="fatal" test="normalize-space()">Property 'Consumable unit' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:BuyersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R001616" flag="fatal" test="normalize-space()">Property 'Buyers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:SellersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R001617" flag="fatal" test="normalize-space()">Property 'Sellers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:ManufacturersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R001618" flag="fatal" test="normalize-space()">Property 'Manufacturers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:StandardItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R001619" flag="fatal" test="normalize-space()">Property 'Standard item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:CommodityClassification/cbc:ItemClassificationCode">
    <assert id="EHF-QII-G1-R001620" flag="fatal" test="normalize-space()">Property 'Classification code' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:OriginCountry/cbc:IdentificationCode">
    <assert id="EHF-QII-G1-R001621" flag="fatal" test="normalize-space()">Property 'Origin country' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:ItemInstance/cbc:BestBeforeDate">
    <assert id="EHF-QII-G1-R001622" flag="fatal" test="normalize-space()">Property 'Best before date' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001623" flag="fatal" test="not(normalize-space()) or (normalize-space() castable as xs:date)">Property 'Best before date' value must be a valid date.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:ItemInstance/cac:LotIdentification/cbc:LotNumberID">
    <assert id="EHF-QII-G1-R001624" flag="fatal" test="normalize-space()">Property 'Lot number' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AldersgrenseKode']]">
    <assert id="EHF-QII-G1-R001625" flag="fatal" test="normalize-space(cbc:Name) = 'Aldersgrense'">Property 'Aldersgrense' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001626" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Aldersgrense' may be used.</assert>
    <assert id="EHF-QII-G1-R001627" flag="fatal" test="normalize-space(cbc:Value)">Property 'Aldersgrense' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Beskrivelse']]">
    <assert id="EHF-QII-G1-R001628" flag="fatal" test="normalize-space(cbc:Name) = 'Produktnavn'">Property 'Produktnavn' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001629" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produktnavn' may be used.</assert>
    <assert id="EHF-QII-G1-R001630" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produktnavn' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001631" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Produktnavn' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseEngelsk']]">
    <assert id="EHF-QII-G1-R001632" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse [Engelsk]'">Property 'Beskrivelse [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001633" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R001634" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001635" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Beskrivelse [Engelsk]' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseUmerkedeEnheter']]">
    <assert id="EHF-QII-G1-R001636" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse umerkede enheter'">Property 'Beskrivelse umerkede enheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001637" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse umerkede enheter' may be used.</assert>
    <assert id="EHF-QII-G1-R001638" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse umerkede enheter' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001639" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Beskrivelse umerkede enheter' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseUmerkedeSalgsenheter']]">
    <assert id="EHF-QII-G1-R001640" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse umerkede salgsenheter'">Property 'Beskrivelse umerkede salgsenheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001641" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse umerkede salgsenheter' may be used.</assert>
    <assert id="EHF-QII-G1-R001642" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse umerkede salgsenheter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErMerketMedUtsalgspris']]">
    <assert id="EHF-QII-G1-R001643" flag="fatal" test="normalize-space(cbc:Name) = 'Merket med utsalgspris'">Property 'Merket med utsalgspris' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001644" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Merket med utsalgspris' may be used.</assert>
    <assert id="EHF-QII-G1-R001645" flag="fatal" test="normalize-space(cbc:Value)">Property 'Merket med utsalgspris' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErStorhusholdningsprodukt']]">
    <assert id="EHF-QII-G1-R001646" flag="fatal" test="normalize-space(cbc:Name) = 'Storhusholdningsprodukt'">Property 'Storhusholdningsprodukt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001647" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Storhusholdningsprodukt' may be used.</assert>
    <assert id="EHF-QII-G1-R001648" flag="fatal" test="normalize-space(cbc:Value)">Property 'Storhusholdningsprodukt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Fyllingsgrad']]">
    <assert id="EHF-QII-G1-R001649" flag="fatal" test="normalize-space(cbc:Name) = 'Fyllingsgrad'">Property 'Fyllingsgrad' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001650" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Fyllingsgrad'.</assert>
    <assert id="EHF-QII-G1-R001651" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Fyllingsgrad' may be used.</assert>
    <assert id="EHF-QII-G1-R001652" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Fyllingsgrad' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001653" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Fyllingsgrad' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilDetaljist']]">
    <assert id="EHF-QII-G1-R001654" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til detaljist'">Property 'Holdbarhetsdager til detaljist' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001655" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til detaljist' may be used.</assert>
    <assert id="EHF-QII-G1-R001656" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til detaljist' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilDistributor']]">
    <assert id="EHF-QII-G1-R001657" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til distributør'">Property 'Holdbarhetsdager til distributør' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001658" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til distributør' may be used.</assert>
    <assert id="EHF-QII-G1-R001659" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til distributør' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilProdusent']]">
    <assert id="EHF-QII-G1-R001660" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til produsent'">Property 'Holdbarhetsdager til produsent' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001661" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til produsent' may be used.</assert>
    <assert id="EHF-QII-G1-R001662" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til produsent' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTotalt']]">
    <assert id="EHF-QII-G1-R001663" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager totalt'">Property 'Holdbarhetsdager totalt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001664" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager totalt' may be used.</assert>
    <assert id="EHF-QII-G1-R001665" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager totalt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Informasjonstekst']]">
    <assert id="EHF-QII-G1-R001666" flag="fatal" test="normalize-space(cbc:Name) = 'Informasjonstekst'">Property 'Informasjonstekst' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001667" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Informasjonstekst' may be used.</assert>
    <assert id="EHF-QII-G1-R001668" flag="fatal" test="normalize-space(cbc:Value)">Property 'Informasjonstekst' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001669" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Informasjonstekst' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#InformasjonstekstEngelsk']]">
    <assert id="EHF-QII-G1-R001670" flag="fatal" test="normalize-space(cbc:Name) = 'Informasjonstekst [Engelsk]'">Property 'Informasjonstekst [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001671" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Informasjonstekst [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R001672" flag="fatal" test="normalize-space(cbc:Value)">Property 'Informasjonstekst [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001673" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Informasjonstekst [Engelsk]' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#InneholderMikroplast']]">
    <assert id="EHF-QII-G1-R001674" flag="fatal" test="normalize-space(cbc:Name) = 'Inneholder mikroplast'">Property 'Inneholder mikroplast' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001675" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Inneholder mikroplast' may be used.</assert>
    <assert id="EHF-QII-G1-R001676" flag="fatal" test="normalize-space(cbc:Value)">Property 'Inneholder mikroplast' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MaksimumstemperaturCelcius']]">
    <assert id="EHF-QII-G1-R001677" flag="fatal" test="normalize-space(cbc:Name) = 'Maksimumstemperatur'">Property 'Maksimumstemperatur' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001678" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Maksimumstemperatur'.</assert>
    <assert id="EHF-QII-G1-R001679" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Maksimumstemperatur' may be used.</assert>
    <assert id="EHF-QII-G1-R001680" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Maksimumstemperatur' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001681" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Maksimumstemperatur' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Materiale']]">
    <assert id="EHF-QII-G1-R001682" flag="fatal" test="normalize-space(cbc:Name) = 'Materiale'">Property 'Materiale' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001683" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Materiale' may be used.</assert>
    <assert id="EHF-QII-G1-R001684" flag="fatal" test="normalize-space(cbc:Value)">Property 'Materiale' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001685" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Materiale' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Mengde']]">
    <assert id="EHF-QII-G1-R001686" flag="fatal" test="normalize-space(cbc:Name) = 'Mengde'">Property 'Mengde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001687" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Mengde'.</assert>
    <assert id="EHF-QII-G1-R001688" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Mengde' may be used.</assert>
    <assert id="EHF-QII-G1-R001689" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Mengde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001690" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Mengde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Mengdetypeenhet']]">
    <assert id="EHF-QII-G1-R001691" flag="fatal" test="normalize-space(cbc:Name) = 'Enhet til mengde'">Property 'Enhet til mengde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001692" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Enhet til mengde' may be used.</assert>
    <assert id="EHF-QII-G1-R001693" flag="fatal" test="normalize-space(cbc:Value)">Property 'Enhet til mengde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MerketMedEgenskaper']]">
    <assert id="EHF-QII-G1-R001694" flag="fatal" test="normalize-space(cbc:Name) = 'Er produktet merket med en eller flere egenskaper?'">Property 'Er produktet merket med en eller flere egenskaper?' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001695" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Er produktet merket med en eller flere egenskaper?' may be used.</assert>
    <assert id="EHF-QII-G1-R001696" flag="fatal" test="normalize-space(cbc:Value)">Property 'Er produktet merket med en eller flere egenskaper?' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MinimumstemperaturCelsius']]">
    <assert id="EHF-QII-G1-R001697" flag="fatal" test="normalize-space(cbc:Name) = 'Minimumstemperatur'">Property 'Minimumstemperatur' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001698" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Minimumstemperatur'.</assert>
    <assert id="EHF-QII-G1-R001699" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Minimumstemperatur' may be used.</assert>
    <assert id="EHF-QII-G1-R001700" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Minimumstemperatur' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001701" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Minimumstemperatur' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MVAKode']]">
    <assert id="EHF-QII-G1-R001702" flag="fatal" test="normalize-space(cbc:Name) = 'Mva sats'">Property 'Mva sats' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001703" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Mva sats' may be used.</assert>
    <assert id="EHF-QII-G1-R001704" flag="fatal" test="normalize-space(cbc:Value)">Property 'Mva sats' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Nettovekt']]">
    <assert id="EHF-QII-G1-R001705" flag="fatal" test="normalize-space(cbc:Name) = 'Nettovekt'">Property 'Nettovekt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001706" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Nettovekt'.</assert>
    <assert id="EHF-QII-G1-R001707" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Nettovekt' may be used.</assert>
    <assert id="EHF-QII-G1-R001708" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Nettovekt' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001709" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Nettovekt' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#OpprinnelseOgOpphav']]">
    <assert id="EHF-QII-G1-R001710" flag="fatal" test="normalize-space(cbc:Name) = 'Opprinnelsesland/Opphavssted hovedingrediens(er)'">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001711" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' may be used.</assert>
    <assert id="EHF-QII-G1-R001712" flag="fatal" test="normalize-space(cbc:Value)">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001713" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 200">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' value must have a length of maximum 200 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PAO']]">
    <assert id="EHF-QII-G1-R001714" flag="fatal" test="normalize-space(cbc:Name) = 'Period-after-Opening/Open Jar levetid (mnd)'">Property 'Period-after-Opening/Open Jar levetid (mnd)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001715" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Period-after-Opening/Open Jar levetid (mnd)' may be used.</assert>
    <assert id="EHF-QII-G1-R001716" flag="fatal" test="normalize-space(cbc:Value)">Property 'Period-after-Opening/Open Jar levetid (mnd)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Produksjonsland']]">
    <assert id="EHF-QII-G1-R001717" flag="fatal" test="normalize-space(cbc:Name) = 'Produksjonsland'">Property 'Produksjonsland' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001718" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produksjonsland' may be used.</assert>
    <assert id="EHF-QII-G1-R001719" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produksjonsland' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProduktmerkingEgenskaper']]">
    <assert id="EHF-QII-G1-R001720" flag="fatal" test="normalize-space(cbc:Name) = 'Produktmerking egenskaper'">Property 'Produktmerking egenskaper' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001721" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produktmerking egenskaper' may be used.</assert>
    <assert id="EHF-QII-G1-R001722" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produktmerking egenskaper' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Stablingsfaktor']]">
    <assert id="EHF-QII-G1-R001723" flag="fatal" test="normalize-space(cbc:Name) = 'Stablingsfaktor'">Property 'Stablingsfaktor' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001724" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Stablingsfaktor'.</assert>
    <assert id="EHF-QII-G1-R001725" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Stablingsfaktor' may be used.</assert>
    <assert id="EHF-QII-G1-R001726" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Stablingsfaktor' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001727" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Stablingsfaktor' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Varemerke']]">
    <assert id="EHF-QII-G1-R001728" flag="fatal" test="normalize-space(cbc:Name) = 'Varemerke'">Property 'Varemerke' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001729" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varemerke' may be used.</assert>
    <assert id="EHF-QII-G1-R001730" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varemerke' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001731" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Varemerke' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AttributtverdiID']]">
    <assert id="EHF-QII-G1-R001732" flag="fatal" test="normalize-space(cbc:Name) = 'Varegruppe attributter'">Property 'Varegruppe attributter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001733" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varegruppe attributter' may be used.</assert>
    <assert id="EHF-QII-G1-R001734" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varegruppe attributter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PakningID']]">
    <assert id="EHF-QII-G1-R001735" flag="fatal" test="normalize-space(cbc:Name) = 'Sertifiseringer'">Property 'Sertifiseringer' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001736" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Sertifiseringer' may be used.</assert>
    <assert id="EHF-QII-G1-R001737" flag="fatal" test="normalize-space(cbc:Value)">Property 'Sertifiseringer' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#VaregruppeID']]">
    <assert id="EHF-QII-G1-R001738" flag="fatal" test="normalize-space(cbc:Name) = 'Varegruppe'">Property 'Varegruppe' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001739" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varegruppe' may be used.</assert>
    <assert id="EHF-QII-G1-R001740" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varegruppe' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Antall']]">
    <assert id="EHF-QII-G1-R001741" flag="fatal" test="normalize-space(cbc:Name) = 'Antall'">Property 'Antall' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001742" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall' may be used.</assert>
    <assert id="EHF-QII-G1-R001743" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#KreverEnergimerking']]">
    <assert id="EHF-QII-G1-R001744" flag="fatal" test="normalize-space(cbc:Name) = 'Krever energimerking'">Property 'Krever energimerking' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001745" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Krever energimerking' may be used.</assert>
    <assert id="EHF-QII-G1-R001746" flag="fatal" test="normalize-space(cbc:Value)">Property 'Krever energimerking' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LinkTilEnergimerke']]">
    <assert id="EHF-QII-G1-R001747" flag="fatal" test="normalize-space(cbc:Name) = 'Link til energimerke'">Property 'Link til energimerke' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001748" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Link til energimerke' may be used.</assert>
    <assert id="EHF-QII-G1-R001749" flag="fatal" test="normalize-space(cbc:Value)">Property 'Link til energimerke' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001750" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 1000">Property 'Link til energimerke' value must have a length of maximum 1000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LinkTilProduktDatablad']]">
    <assert id="EHF-QII-G1-R001751" flag="fatal" test="normalize-space(cbc:Name) = 'Link til produktdatablad'">Property 'Link til produktdatablad' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001752" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Link til produktdatablad' may be used.</assert>
    <assert id="EHF-QII-G1-R001753" flag="fatal" test="normalize-space(cbc:Value)">Property 'Link til produktdatablad' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001754" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 1000">Property 'Link til produktdatablad' value must have a length of maximum 1000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallAvPant']]">
    <assert id="EHF-QII-G1-R001755" flag="fatal" test="normalize-space(cbc:Name) = 'Antall av pant'">Property 'Antall av pant' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001756" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall av pant' may be used.</assert>
    <assert id="EHF-QII-G1-R001757" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall av pant' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriBredden']]">
    <assert id="EHF-QII-G1-R001758" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i bredde'">Property 'Antall basispakninger i bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001759" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R001760" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i bredde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriDybden']]">
    <assert id="EHF-QII-G1-R001761" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i dybde'">Property 'Antall basispakninger i dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001762" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R001763" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i dybde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriHoyden']]">
    <assert id="EHF-QII-G1-R001764" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i høyde'">Property 'Antall basispakninger i høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001765" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R001766" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i høyde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallLag']]">
    <assert id="EHF-QII-G1-R001767" flag="fatal" test="normalize-space(cbc:Name) = 'Antall lag'">Property 'Antall lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001768" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall lag' may be used.</assert>
    <assert id="EHF-QII-G1-R001769" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall lag' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallPrLag']]">
    <assert id="EHF-QII-G1-R001770" flag="fatal" test="normalize-space(cbc:Name) = 'Antall pr lag'">Property 'Antall pr lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001771" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall pr lag' may be used.</assert>
    <assert id="EHF-QII-G1-R001772" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall pr lag' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AvvikendePakkemonster']]">
    <assert id="EHF-QII-G1-R001773" flag="fatal" test="normalize-space(cbc:Name) = 'Avvikende pakkemønster'">Property 'Avvikende pakkemønster' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001774" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Avvikende pakkemønster' may be used.</assert>
    <assert id="EHF-QII-G1-R001775" flag="fatal" test="normalize-space(cbc:Value)">Property 'Avvikende pakkemønster' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Bredde']]">
    <assert id="EHF-QII-G1-R001776" flag="fatal" test="normalize-space(cbc:Name) = 'Bredde'">Property 'Bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001777" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Bredde'.</assert>
    <assert id="EHF-QII-G1-R001778" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R001779" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Bredde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001780" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Bredde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Bruttovekt']]">
    <assert id="EHF-QII-G1-R001781" flag="fatal" test="normalize-space(cbc:Name) = 'Bruttovekt'">Property 'Bruttovekt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001782" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Bruttovekt'.</assert>
    <assert id="EHF-QII-G1-R001783" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Bruttovekt' may be used.</assert>
    <assert id="EHF-QII-G1-R001784" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Bruttovekt' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001785" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Bruttovekt' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Dybde']]">
    <assert id="EHF-QII-G1-R001786" flag="fatal" test="normalize-space(cbc:Name) = 'Dybde'">Property 'Dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001787" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Dybde'.</assert>
    <assert id="EHF-QII-G1-R001788" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R001789" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Dybde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001790" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Dybde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Egenskaper']]">
    <assert id="EHF-QII-G1-R001791" flag="fatal" test="normalize-space(cbc:Name) = 'Egenskaper'">Property 'Egenskaper' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001792" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Egenskaper' may be used.</assert>
    <assert id="EHF-QII-G1-R001793" flag="fatal" test="normalize-space(cbc:Value)">Property 'Egenskaper' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001794" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Egenskaper' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EgenskaperEngelsk']]">
    <assert id="EHF-QII-G1-R001795" flag="fatal" test="normalize-space(cbc:Name) = 'Egenskaper [Engelsk]'">Property 'Egenskaper [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001796" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Egenskaper [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R001797" flag="fatal" test="normalize-space(cbc:Value)">Property 'Egenskaper [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001798" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Egenskaper [Engelsk]' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Emballasjekode']]">
    <assert id="EHF-QII-G1-R001799" flag="fatal" test="normalize-space(cbc:Name) = 'Emballasje'">Property 'Emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001800" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R001801" flag="fatal" test="normalize-space(cbc:Value)">Property 'Emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErForbrukerpakning']]">
    <assert id="EHF-QII-G1-R001802" flag="fatal" test="normalize-space(cbc:Name) = 'ErForbrukerpakning'">Property 'ErForbrukerpakning' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001803" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'ErForbrukerpakning' may be used.</assert>
    <assert id="EHF-QII-G1-R001804" flag="fatal" test="normalize-space(cbc:Value)">Property 'ErForbrukerpakning' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#GS1Databaarer']]">
    <assert id="EHF-QII-G1-R001805" flag="fatal" test="normalize-space(cbc:Name) = 'GS1 Databær'">Property 'GS1 Databær' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001806" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'GS1 Databær' may be used.</assert>
    <assert id="EHF-QII-G1-R001807" flag="fatal" test="normalize-space(cbc:Value)">Property 'GS1 Databær' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Hoyde']]">
    <assert id="EHF-QII-G1-R001808" flag="fatal" test="normalize-space(cbc:Name) = 'Høyde'">Property 'Høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001809" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Høyde'.</assert>
    <assert id="EHF-QII-G1-R001810" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R001811" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Høyde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001812" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Høyde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoydePrLag']]">
    <assert id="EHF-QII-G1-R001813" flag="fatal" test="normalize-space(cbc:Name) = 'Høyde pr lag'">Property 'Høyde pr lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001814" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Høyde pr lag'.</assert>
    <assert id="EHF-QII-G1-R001815" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Høyde pr lag' may be used.</assert>
    <assert id="EHF-QII-G1-R001816" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Høyde pr lag' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001817" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Høyde pr lag' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LastbaererKode']]">
    <assert id="EHF-QII-G1-R001818" flag="fatal" test="normalize-space(cbc:Name) = 'Lastbærer'">Property 'Lastbærer' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001819" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Lastbærer' may be used.</assert>
    <assert id="EHF-QII-G1-R001820" flag="fatal" test="normalize-space(cbc:Value)">Property 'Lastbærer' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Markedsnavn']]">
    <assert id="EHF-QII-G1-R001821" flag="fatal" test="normalize-space(cbc:Name) = 'Fullstendig produktnavn'">Property 'Fullstendig produktnavn' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001822" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Fullstendig produktnavn' may be used.</assert>
    <assert id="EHF-QII-G1-R001823" flag="fatal" test="normalize-space(cbc:Value)">Property 'Fullstendig produktnavn' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001824" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Fullstendig produktnavn' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MarkedsnavnEngelsk']]">
    <assert id="EHF-QII-G1-R001825" flag="fatal" test="normalize-space(cbc:Name) = 'Fullstendig produktnavn [Engelsk]'">Property 'Fullstendig produktnavn [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001826" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Fullstendig produktnavn [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R001827" flag="fatal" test="normalize-space(cbc:Value)">Property 'Fullstendig produktnavn [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001828" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Fullstendig produktnavn [Engelsk]' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MaxTopplast']]">
    <assert id="EHF-QII-G1-R001829" flag="fatal" test="normalize-space(cbc:Name) = 'Max topplast'">Property 'Max topplast' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001830" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Max topplast'.</assert>
    <assert id="EHF-QII-G1-R001831" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Max topplast' may be used.</assert>
    <assert id="EHF-QII-G1-R001832" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Max topplast' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001833" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Max topplast' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PantGTIN']]">
    <assert id="EHF-QII-G1-R001834" flag="fatal" test="normalize-space(cbc:Name) = 'Pant GTIN'">Property 'Pant GTIN' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001835" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Pant GTIN' may be used.</assert>
    <assert id="EHF-QII-G1-R001836" flag="fatal" test="normalize-space(cbc:Value)">Property 'Pant GTIN' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PEGhullBredde']]">
    <assert id="EHF-QII-G1-R001837" flag="fatal" test="normalize-space(cbc:Name) = 'PEG-hullets bredde'">Property 'PEG-hullets bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001838" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'PEG-hullets bredde'.</assert>
    <assert id="EHF-QII-G1-R001839" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'PEG-hullets bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R001840" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'PEG-hullets bredde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001841" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'PEG-hullets bredde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PEGhullX']]">
    <assert id="EHF-QII-G1-R001842" flag="fatal" test="normalize-space(cbc:Name) = 'PEG-hull X'">Property 'PEG-hull X' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001843" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'PEG-hull X'.</assert>
    <assert id="EHF-QII-G1-R001844" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'PEG-hull X' may be used.</assert>
    <assert id="EHF-QII-G1-R001845" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'PEG-hull X' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001846" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'PEG-hull X' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PEGhullY']]">
    <assert id="EHF-QII-G1-R001847" flag="fatal" test="normalize-space(cbc:Name) = 'PEG-hull Y'">Property 'PEG-hull Y' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001848" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'PEG-hull Y'.</assert>
    <assert id="EHF-QII-G1-R001849" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'PEG-hull Y' may be used.</assert>
    <assert id="EHF-QII-G1-R001850" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'PEG-hull Y' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001851" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'PEG-hull Y' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ResirkulerbarEmballasje']]">
    <assert id="EHF-QII-G1-R001852" flag="fatal" test="normalize-space(cbc:Name) = 'Resirkulerbar emballasje'">Property 'Resirkulerbar emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001853" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Resirkulerbar emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R001854" flag="fatal" test="normalize-space(cbc:Value)">Property 'Resirkulerbar emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReturnerbarEmballasje']]">
    <assert id="EHF-QII-G1-R001855" flag="fatal" test="normalize-space(cbc:Name) = 'Returnerbar emballasje'">Property 'Returnerbar emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001856" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Returnerbar emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R001857" flag="fatal" test="normalize-space(cbc:Value)">Property 'Returnerbar emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SistKontrollmaalt']]">
    <assert id="EHF-QII-G1-R001858" flag="fatal" test="normalize-space(cbc:Name) = 'Sist kontrollmålt'">Property 'Sist kontrollmålt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001859" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Sist kontrollmålt' may be used.</assert>
    <assert id="EHF-QII-G1-R001860" flag="fatal" test="normalize-space(cbc:Value)">Property 'Sist kontrollmålt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceAvvikerFraLogistikkMaal']]">
    <assert id="EHF-QII-G1-R001861" flag="fatal" test="normalize-space(cbc:Name) = 'Avviker logistikkmål fra hyllemål'">Property 'Avviker logistikkmål fra hyllemål' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001862" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Avviker logistikkmål fra hyllemål' may be used.</assert>
    <assert id="EHF-QII-G1-R001863" flag="fatal" test="normalize-space(cbc:Value)">Property 'Avviker logistikkmål fra hyllemål' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceBredde']]">
    <assert id="EHF-QII-G1-R001864" flag="fatal" test="normalize-space(cbc:Name) = 'Space bredde'">Property 'Space bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001865" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space bredde'.</assert>
    <assert id="EHF-QII-G1-R001866" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R001867" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space bredde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001868" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space bredde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceDybde']]">
    <assert id="EHF-QII-G1-R001869" flag="fatal" test="normalize-space(cbc:Name) = 'Space dybde'">Property 'Space dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001870" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space dybde'.</assert>
    <assert id="EHF-QII-G1-R001871" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R001872" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space dybde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001873" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space dybde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceHoyde']]">
    <assert id="EHF-QII-G1-R001874" flag="fatal" test="normalize-space(cbc:Name) = 'Space høyde'">Property 'Space høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001875" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space høyde'.</assert>
    <assert id="EHF-QII-G1-R001876" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R001877" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space høyde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001878" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space høyde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#TotaltAntall']]">
    <assert id="EHF-QII-G1-R001879" flag="fatal" test="normalize-space(cbc:Name) = 'Totalt antall'">Property 'Totalt antall' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001880" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Totalt antall' may be used.</assert>
    <assert id="EHF-QII-G1-R001881" flag="fatal" test="normalize-space(cbc:Value)">Property 'Totalt antall' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PantEPDnr']]">
    <assert id="EHF-QII-G1-R001882" flag="fatal" test="normalize-space(cbc:Name) = 'Pant EPDnr'">Property 'Pant EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001883" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Pant EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R001884" flag="fatal" test="normalize-space(cbc:Value)">Property 'Pant EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EPDnr']]">
    <assert id="EHF-QII-G1-R001885" flag="fatal" test="normalize-space(cbc:Name) = 'EPDnr'">Property 'EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001886" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R001887" flag="fatal" test="normalize-space(cbc:Value)">Property 'EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErstattetAvProduktID']]">
    <assert id="EHF-QII-G1-R001888" flag="fatal" test="normalize-space(cbc:Name) = 'Erstattet av EPDnr'">Property 'Erstattet av EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001889" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Erstattet av EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R001890" flag="fatal" test="normalize-space(cbc:Value)">Property 'Erstattet av EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LeverandorVarenr']]">
    <assert id="EHF-QII-G1-R001891" flag="fatal" test="normalize-space(cbc:Name) = 'Leverandør varenr'">Property 'Leverandør varenr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001892" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Leverandør varenr' may be used.</assert>
    <assert id="EHF-QII-G1-R001893" flag="fatal" test="normalize-space(cbc:Value)">Property 'Leverandør varenr' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001894" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Leverandør varenr' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MottakerTilgang']]">
    <assert id="EHF-QII-G1-R001895" flag="fatal" test="normalize-space(cbc:Name) = 'Mottaker tilgang'">Property 'Mottaker tilgang' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001896" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Mottaker tilgang' may be used.</assert>
    <assert id="EHF-QII-G1-R001897" flag="fatal" test="normalize-space(cbc:Value)">Property 'Mottaker tilgang' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001898" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Mottaker tilgang' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProdusentVarenr']]">
    <assert id="EHF-QII-G1-R001899" flag="fatal" test="normalize-space(cbc:Name) = 'Produsent varenr'">Property 'Produsent varenr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001900" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produsent varenr' may be used.</assert>
    <assert id="EHF-QII-G1-R001901" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produsent varenr' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001902" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Produsent varenr' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#TilgjengeligFraDato']]">
    <assert id="EHF-QII-G1-R001903" flag="fatal" test="normalize-space(cbc:Name) = 'Tilgjengelig fra dato'">Property 'Tilgjengelig fra dato' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001904" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Tilgjengelig fra dato' may be used.</assert>
    <assert id="EHF-QII-G1-R001905" flag="fatal" test="normalize-space(cbc:Value)">Property 'Tilgjengelig fra dato' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProduktID']]">
    <assert id="EHF-QII-G1-R001906" flag="fatal" test="normalize-space(cbc:Name) = 'Hentesteder'">Property 'Hentesteder' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001907" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Hentesteder' may be used.</assert>
    <assert id="EHF-QII-G1-R001908" flag="fatal" test="normalize-space(cbc:Value)">Property 'Hentesteder' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErBestillbar']]">
    <assert id="EHF-QII-G1-R001909" flag="fatal" test="normalize-space(cbc:Name) = 'Bestillbar'">Property 'Bestillbar' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001910" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Bestillbar' may be used.</assert>
    <assert id="EHF-QII-G1-R001911" flag="fatal" test="normalize-space(cbc:Value)">Property 'Bestillbar' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErBegrensetMengde']]">
    <assert id="EHF-QII-G1-R001912" flag="fatal" test="normalize-space(cbc:Name) = 'Begrenset mengde'">Property 'Begrenset mengde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001913" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Begrenset mengde' may be used.</assert>
    <assert id="EHF-QII-G1-R001914" flag="fatal" test="normalize-space(cbc:Value)">Property 'Begrenset mengde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErFarligGods']]">
    <assert id="EHF-QII-G1-R001915" flag="fatal" test="normalize-space(cbc:Name) = 'Farlig gods'">Property 'Farlig gods' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001916" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Farlig gods' may be used.</assert>
    <assert id="EHF-QII-G1-R001917" flag="fatal" test="normalize-space(cbc:Value)">Property 'Farlig gods' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErListe1StofferEksplosiver']]">
    <assert id="EHF-QII-G1-R001918" flag="fatal" test="normalize-space(cbc:Name) = 'Liste 1 stoffer eksplosiver'">Property 'Liste 1 stoffer eksplosiver' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001919" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Liste 1 stoffer eksplosiver' may be used.</assert>
    <assert id="EHF-QII-G1-R001920" flag="fatal" test="normalize-space(cbc:Value)">Property 'Liste 1 stoffer eksplosiver' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErListe2StofferEksplosiver']]">
    <assert id="EHF-QII-G1-R001921" flag="fatal" test="normalize-space(cbc:Name) = 'Liste 2 stoffer eksplosiver'">Property 'Liste 2 stoffer eksplosiver' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001922" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Liste 2 stoffer eksplosiver' may be used.</assert>
    <assert id="EHF-QII-G1-R001923" flag="fatal" test="normalize-space(cbc:Value)">Property 'Liste 2 stoffer eksplosiver' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErMerketMedHsetning']]">
    <assert id="EHF-QII-G1-R001924" flag="fatal" test="normalize-space(cbc:Name) = 'Er merker med h-setning'">Property 'Er merker med h-setning' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001925" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Er merker med h-setning' may be used.</assert>
    <assert id="EHF-QII-G1-R001926" flag="fatal" test="normalize-space(cbc:Value)">Property 'Er merker med h-setning' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErMiljoskadelig']]">
    <assert id="EHF-QII-G1-R001927" flag="fatal" test="normalize-space(cbc:Name) = 'Miljøskadelig'">Property 'Miljøskadelig' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001928" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Miljøskadelig' may be used.</assert>
    <assert id="EHF-QII-G1-R001929" flag="fatal" test="normalize-space(cbc:Value)">Property 'Miljøskadelig' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErUnntattMengde']]">
    <assert id="EHF-QII-G1-R001930" flag="fatal" test="normalize-space(cbc:Name) = 'Er produkt unntatt mengde'">Property 'Er produkt unntatt mengde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001931" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Er produkt unntatt mengde' may be used.</assert>
    <assert id="EHF-QII-G1-R001932" flag="fatal" test="normalize-space(cbc:Value)">Property 'Er produkt unntatt mengde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErUtgangsstofferForEksplosiver']]">
    <assert id="EHF-QII-G1-R001933" flag="fatal" test="normalize-space(cbc:Name) = 'Utgangsstoffer for eksplosiver'">Property 'Utgangsstoffer for eksplosiver' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001934" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Utgangsstoffer for eksplosiver' may be used.</assert>
    <assert id="EHF-QII-G1-R001935" flag="fatal" test="normalize-space(cbc:Value)">Property 'Utgangsstoffer for eksplosiver' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HarBruksbegrensninger']]">
    <assert id="EHF-QII-G1-R001936" flag="fatal" test="normalize-space(cbc:Name) = 'Har produktet noen bruksbegrensninger?'">Property 'Har produktet noen bruksbegrensninger?' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001937" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Har produktet noen bruksbegrensninger?' may be used.</assert>
    <assert id="EHF-QII-G1-R001938" flag="fatal" test="normalize-space(cbc:Value)">Property 'Har produktet noen bruksbegrensninger?' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#KreverSamsvarserklaering']]">
    <assert id="EHF-QII-G1-R001939" flag="fatal" test="normalize-space(cbc:Name) = 'Krever samsvarserklæring'">Property 'Krever samsvarserklæring' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001940" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Krever samsvarserklæring' may be used.</assert>
    <assert id="EHF-QII-G1-R001941" flag="fatal" test="normalize-space(cbc:Value)">Property 'Krever samsvarserklæring' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#KreverSikkerhetsdatablad']]">
    <assert id="EHF-QII-G1-R001942" flag="fatal" test="normalize-space(cbc:Name) = 'Krever sikkerhetsdatablad'">Property 'Krever sikkerhetsdatablad' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001943" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Krever sikkerhetsdatablad' may be used.</assert>
    <assert id="EHF-QII-G1-R001944" flag="fatal" test="normalize-space(cbc:Value)">Property 'Krever sikkerhetsdatablad' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LinkTilSamsvarserklaering']]">
    <assert id="EHF-QII-G1-R001945" flag="fatal" test="normalize-space(cbc:Name) = 'Link til samsvarserklæring'">Property 'Link til samsvarserklæring' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001946" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Link til samsvarserklæring' may be used.</assert>
    <assert id="EHF-QII-G1-R001947" flag="fatal" test="normalize-space(cbc:Value)">Property 'Link til samsvarserklæring' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001948" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 1000">Property 'Link til samsvarserklæring' value must have a length of maximum 1000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LinkTilSikkerhetsdatablad']]">
    <assert id="EHF-QII-G1-R001949" flag="fatal" test="normalize-space(cbc:Name) = 'Link til sikkerhetsdatablad'">Property 'Link til sikkerhetsdatablad' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001950" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Link til sikkerhetsdatablad' may be used.</assert>
    <assert id="EHF-QII-G1-R001951" flag="fatal" test="normalize-space(cbc:Value)">Property 'Link til sikkerhetsdatablad' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001952" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 1000">Property 'Link til sikkerhetsdatablad' value must have a length of maximum 1000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SamsvarseklaringGyldigTilDato']]">
    <assert id="EHF-QII-G1-R001953" flag="fatal" test="normalize-space(cbc:Name) = 'Samsvarserklærings gyldighetsdato Til'">Property 'Samsvarserklærings gyldighetsdato Til' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001954" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Samsvarserklærings gyldighetsdato Til' may be used.</assert>
    <assert id="EHF-QII-G1-R001955" flag="fatal" test="normalize-space(cbc:Value)">Property 'Samsvarserklærings gyldighetsdato Til' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SikkerhetOgFarligGodsEmballasjeKode']]">
    <assert id="EHF-QII-G1-R001956" flag="fatal" test="normalize-space(cbc:Name) = 'Emballasje (sikkerhet/farlig gods)'">Property 'Emballasje (sikkerhet/farlig gods)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001957" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Emballasje (sikkerhet/farlig gods)' may be used.</assert>
    <assert id="EHF-QII-G1-R001958" flag="fatal" test="normalize-space(cbc:Value)">Property 'Emballasje (sikkerhet/farlig gods)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#UNnr']]">
    <assert id="EHF-QII-G1-R001959" flag="fatal" test="normalize-space(cbc:Name) = 'UNnr'">Property 'UNnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001960" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'UNnr' may be used.</assert>
    <assert id="EHF-QII-G1-R001961" flag="fatal" test="normalize-space(cbc:Value)">Property 'UNnr' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001962" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 10">Property 'UNnr' value must have a length of maximum 10 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallUmerkedeEnheter']]">
    <assert id="EHF-QII-G1-R001963" flag="fatal" test="normalize-space(cbc:Name) = 'Antall umerkede enheter'">Property 'Antall umerkede enheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001964" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall umerkede enheter' may be used.</assert>
    <assert id="EHF-QII-G1-R001965" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall umerkede enheter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Ingredienser']]">
    <assert id="EHF-QII-G1-R001966" flag="fatal" test="normalize-space(cbc:Name) = 'Ingredienser'">Property 'Ingredienser' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001967" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Ingredienser' may be used.</assert>
    <assert id="EHF-QII-G1-R001968" flag="fatal" test="normalize-space(cbc:Value)">Property 'Ingredienser' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001969" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2560">Property 'Ingredienser' value must have a length of maximum 2560 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Umerketvariantbeskrivelse']]">
    <assert id="EHF-QII-G1-R001970" flag="fatal" test="normalize-space(cbc:Name) = 'Umerketvariantbeskrivelse'">Property 'Umerketvariantbeskrivelse' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001971" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Umerketvariantbeskrivelse' may be used.</assert>
    <assert id="EHF-QII-G1-R001972" flag="fatal" test="normalize-space(cbc:Value)">Property 'Umerketvariantbeskrivelse' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001973" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Umerketvariantbeskrivelse' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:nonfood']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Umerketvariantnr']]">
    <assert id="EHF-QII-G1-R001974" flag="fatal" test="normalize-space(cbc:Name) = 'Umerketvariantnr'">Property 'Umerketvariantnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001975" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Umerketvariantnr' may be used.</assert>
    <assert id="EHF-QII-G1-R001976" flag="fatal" test="normalize-space(cbc:Value)">Property 'Umerketvariantnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]">
    <assert id="EHF-QII-G1-R001977" flag="fatal" test="cbc:Name">Property 'Name' is mandatory.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']"/>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cbc:Name">
    <assert id="EHF-QII-G1-R001978" flag="fatal" test="normalize-space()">Property 'Name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001979" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cbc:Description">
    <assert id="EHF-QII-G1-R001980" flag="fatal" test="normalize-space()">Property 'Description' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cbc:Keyword">
    <assert id="EHF-QII-G1-R001981" flag="fatal" test="normalize-space()">Property 'Keywords' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cbc:BrandName">
    <assert id="EHF-QII-G1-R001982" flag="fatal" test="normalize-space()">Property 'Brand name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001983" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Brand name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cbc:PackQuantity">
    <assert id="EHF-QII-G1-R001984" flag="fatal" test="normalize-space()">Property 'Packed quantity' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cbc:PackSizeNumeric">
    <assert id="EHF-QII-G1-R001985" flag="fatal" test="normalize-space()">Property 'Consumable unit' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:BuyersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R001986" flag="fatal" test="normalize-space()">Property 'Buyers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:SellersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R001987" flag="fatal" test="normalize-space()">Property 'Sellers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:ManufacturersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R001988" flag="fatal" test="normalize-space()">Property 'Manufacturers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:StandardItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R001989" flag="fatal" test="normalize-space()">Property 'Standard item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:CommodityClassification/cbc:ItemClassificationCode">
    <assert id="EHF-QII-G1-R001990" flag="fatal" test="normalize-space()">Property 'Classification code' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:OriginCountry/cbc:IdentificationCode">
    <assert id="EHF-QII-G1-R001991" flag="fatal" test="normalize-space()">Property 'Origin country' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:ItemInstance/cbc:BestBeforeDate">
    <assert id="EHF-QII-G1-R001992" flag="fatal" test="normalize-space()">Property 'Best before date' can not be empty.</assert>
    <assert id="EHF-QII-G1-R001993" flag="fatal" test="not(normalize-space()) or (normalize-space() castable as xs:date)">Property 'Best before date' value must be a valid date.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:ItemInstance/cac:LotIdentification/cbc:LotNumberID">
    <assert id="EHF-QII-G1-R001994" flag="fatal" test="normalize-space()">Property 'Lot number' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AldersgrenseKode']]">
    <assert id="EHF-QII-G1-R001995" flag="fatal" test="normalize-space(cbc:Name) = 'Aldersgrense'">Property 'Aldersgrense' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001996" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Aldersgrense' may be used.</assert>
    <assert id="EHF-QII-G1-R001997" flag="fatal" test="normalize-space(cbc:Value)">Property 'Aldersgrense' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Alkoholprosent']]">
    <assert id="EHF-QII-G1-R001998" flag="fatal" test="normalize-space(cbc:Name) = 'Alkoholprosent'">Property 'Alkoholprosent' has wrong name.</assert>
    <assert id="EHF-QII-G1-R001999" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Alkoholprosent'.</assert>
    <assert id="EHF-QII-G1-R002000" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Alkoholprosent' may be used.</assert>
    <assert id="EHF-QII-G1-R002001" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Alkoholprosent' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002002" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Alkoholprosent' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AlkoholRapporteringsgruppeKode']]">
    <assert id="EHF-QII-G1-R002003" flag="fatal" test="normalize-space(cbc:Name) = 'Alkohol rapporteringsgruppe'">Property 'Alkohol rapporteringsgruppe' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002004" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Alkohol rapporteringsgruppe' may be used.</assert>
    <assert id="EHF-QII-G1-R002005" flag="fatal" test="normalize-space(cbc:Value)">Property 'Alkohol rapporteringsgruppe' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.blotdyr']]">
    <assert id="EHF-QII-G1-R002006" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Bløtdyr (allergen)'">Property 'Allergener, Bløtdyr (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002007" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Bløtdyr (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002008" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Bløtdyr (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.egg']]">
    <assert id="EHF-QII-G1-R002009" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Egg (allergen)'">Property 'Allergener, Egg (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002010" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Egg (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002011" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Egg (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.fisk']]">
    <assert id="EHF-QII-G1-R002012" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Fisk (allergen)'">Property 'Allergener, Fisk (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002013" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Fisk (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002014" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Fisk (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_bygg_gluten']]">
    <assert id="EHF-QII-G1-R002015" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Bygg gluten (allergen)'">Property 'Allergener, Bygg gluten (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002016" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Bygg gluten (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002017" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Bygg gluten (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_havre_gluten']]">
    <assert id="EHF-QII-G1-R002018" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Havre gluten (allergen)'">Property 'Allergener, Havre gluten (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002019" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Havre gluten (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002020" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Havre gluten (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_hvete_gluten']]">
    <assert id="EHF-QII-G1-R002021" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Hvete gluten (allergen)'">Property 'Allergener, Hvete gluten (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002022" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Hvete gluten (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002023" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Hvete gluten (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_rug_gluten']]">
    <assert id="EHF-QII-G1-R002024" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Rug gluten (allergen)'">Property 'Allergener, Rug gluten (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002025" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Rug gluten (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002026" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Rug gluten (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.lupin']]">
    <assert id="EHF-QII-G1-R002027" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Lupiner (allergen)'">Property 'Allergener, Lupiner (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002028" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Lupiner (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002029" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Lupiner (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.melk']]">
    <assert id="EHF-QII-G1-R002030" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Melk (allergen)'">Property 'Allergener, Melk (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002031" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Melk (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002032" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Melk (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter']]">
    <assert id="EHF-QII-G1-R002033" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Nøtter (allergen)'">Property 'Allergener, Nøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002034" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Nøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002035" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Nøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_hasselnotter']]">
    <assert id="EHF-QII-G1-R002036" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Hasselnøtter (allergen)'">Property 'Allergener, Hasselnøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002037" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Hasselnøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002038" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Hasselnøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_kasjunotter']]">
    <assert id="EHF-QII-G1-R002039" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Kasjunøtter (allergen)'">Property 'Allergener, Kasjunøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002040" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Kasjunøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002041" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Kasjunøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_macademianotter']]">
    <assert id="EHF-QII-G1-R002042" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Macademiannøtter (allergen)'">Property 'Allergener, Macademiannøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002043" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Macademiannøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002044" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Macademiannøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_mandler']]">
    <assert id="EHF-QII-G1-R002045" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Mandler (allergen)'">Property 'Allergener, Mandler (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002046" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Mandler (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002047" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Mandler (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_paranotter']]">
    <assert id="EHF-QII-G1-R002048" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Paranøtter (allergen)'">Property 'Allergener, Paranøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002049" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Paranøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002050" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Paranøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_peanotter']]">
    <assert id="EHF-QII-G1-R002051" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Peanøtter (allergen)'">Property 'Allergener, Peanøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002052" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Peanøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002053" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Peanøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_pekannotter']]">
    <assert id="EHF-QII-G1-R002054" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Pekannøtter (allergen)'">Property 'Allergener, Pekannøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002055" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Pekannøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002056" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Pekannøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_pistasienotter']]">
    <assert id="EHF-QII-G1-R002057" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Pistasienøtter (allergen)'">Property 'Allergener, Pistasienøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002058" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Pistasienøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002059" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Pistasienøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_valnotter']]">
    <assert id="EHF-QII-G1-R002060" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Valnøtter (allergen)'">Property 'Allergener, Valnøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002061" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Valnøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002062" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Valnøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.selleri']]">
    <assert id="EHF-QII-G1-R002063" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Selleri (allergen)'">Property 'Allergener, Selleri (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002064" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Selleri (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002065" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Selleri (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.sennep']]">
    <assert id="EHF-QII-G1-R002066" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Sennep (allergen)'">Property 'Allergener, Sennep (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002067" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Sennep (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002068" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Sennep (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.sesamfro']]">
    <assert id="EHF-QII-G1-R002069" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Sesamfrø (allergen)'">Property 'Allergener, Sesamfrø (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002070" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Sesamfrø (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002071" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Sesamfrø (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.skalldyr']]">
    <assert id="EHF-QII-G1-R002072" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Skalldyr (allergen)'">Property 'Allergener, Skalldyr (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002073" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Skalldyr (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002074" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Skalldyr (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.soya']]">
    <assert id="EHF-QII-G1-R002075" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Soya (allergen)'">Property 'Allergener, Soya (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002076" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Soya (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002077" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Soya (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_spelt_gluten']]">
    <assert id="EHF-QII-G1-R002078" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Spelt gluten (allergen)'">Property 'Allergener, Spelt gluten (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002079" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Spelt gluten (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002080" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Spelt gluten (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_khorasanhvete_gluten']]">
    <assert id="EHF-QII-G1-R002081" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Khorasanhvete gluten (allergen)'">Property 'Allergener, Khorasanhvete gluten (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002082" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Khorasanhvete gluten (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002083" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Khorasanhvete gluten (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.svoveldioksid_sulfitter']]">
    <assert id="EHF-QII-G1-R002084" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Svoveldioksid eller sulfitter (allergen)'">Property 'Allergener, Svoveldioksid eller sulfitter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002085" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Svoveldioksid eller sulfitter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002086" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Svoveldioksid eller sulfitter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.gluten']]">
    <assert id="EHF-QII-G1-R002087" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Gluten (allergen)'">Property 'Allergener, Gluten (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002088" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Gluten (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R002089" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Gluten (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Beskrivelse']]">
    <assert id="EHF-QII-G1-R002090" flag="fatal" test="normalize-space(cbc:Name) = 'Produktnavn'">Property 'Produktnavn' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002091" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produktnavn' may be used.</assert>
    <assert id="EHF-QII-G1-R002092" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produktnavn' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002093" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Produktnavn' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseEngelsk']]">
    <assert id="EHF-QII-G1-R002094" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse [Engelsk]'">Property 'Beskrivelse [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002095" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R002096" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002097" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Beskrivelse [Engelsk]' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseUmerkedeEnheter']]">
    <assert id="EHF-QII-G1-R002098" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse umerkede enheter'">Property 'Beskrivelse umerkede enheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002099" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse umerkede enheter' may be used.</assert>
    <assert id="EHF-QII-G1-R002100" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse umerkede enheter' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002101" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Beskrivelse umerkede enheter' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseUmerkedeSalgsenheter']]">
    <assert id="EHF-QII-G1-R002102" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse umerkede salgsenheter'">Property 'Beskrivelse umerkede salgsenheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002103" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse umerkede salgsenheter' may be used.</assert>
    <assert id="EHF-QII-G1-R002104" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse umerkede salgsenheter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EnhetsprisbetegnelseKode']]">
    <assert id="EHF-QII-G1-R002105" flag="fatal" test="normalize-space(cbc:Name) = 'Enhetsprisbetegnelse'">Property 'Enhetsprisbetegnelse' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002106" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Enhetsprisbetegnelse' may be used.</assert>
    <assert id="EHF-QII-G1-R002107" flag="fatal" test="normalize-space(cbc:Value)">Property 'Enhetsprisbetegnelse' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Enhetsprisfaktor']]">
    <assert id="EHF-QII-G1-R002108" flag="fatal" test="normalize-space(cbc:Name) = 'Enhetsprisfaktor'">Property 'Enhetsprisfaktor' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002109" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Enhetsprisfaktor'.</assert>
    <assert id="EHF-QII-G1-R002110" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Enhetsprisfaktor' may be used.</assert>
    <assert id="EHF-QII-G1-R002111" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Enhetsprisfaktor' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002112" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Enhetsprisfaktor' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EnhetspristypeKode']]">
    <assert id="EHF-QII-G1-R002113" flag="fatal" test="normalize-space(cbc:Name) = 'Enhetspris sammenligningsgrunnlag'">Property 'Enhetspris sammenligningsgrunnlag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002114" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Enhetspris sammenligningsgrunnlag' may be used.</assert>
    <assert id="EHF-QII-G1-R002115" flag="fatal" test="normalize-space(cbc:Value)">Property 'Enhetspris sammenligningsgrunnlag' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErMerketMedUtsalgspris']]">
    <assert id="EHF-QII-G1-R002116" flag="fatal" test="normalize-space(cbc:Name) = 'Merket med utsalgspris'">Property 'Merket med utsalgspris' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002117" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Merket med utsalgspris' may be used.</assert>
    <assert id="EHF-QII-G1-R002118" flag="fatal" test="normalize-space(cbc:Value)">Property 'Merket med utsalgspris' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErStorhusholdningsprodukt']]">
    <assert id="EHF-QII-G1-R002119" flag="fatal" test="normalize-space(cbc:Name) = 'Storhusholdningsprodukt'">Property 'Storhusholdningsprodukt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002120" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Storhusholdningsprodukt' may be used.</assert>
    <assert id="EHF-QII-G1-R002121" flag="fatal" test="normalize-space(cbc:Value)">Property 'Storhusholdningsprodukt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Fyllingsgrad']]">
    <assert id="EHF-QII-G1-R002122" flag="fatal" test="normalize-space(cbc:Name) = 'Fyllingsgrad'">Property 'Fyllingsgrad' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002123" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Fyllingsgrad'.</assert>
    <assert id="EHF-QII-G1-R002124" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Fyllingsgrad' may be used.</assert>
    <assert id="EHF-QII-G1-R002125" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Fyllingsgrad' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002126" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Fyllingsgrad' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilDetaljist']]">
    <assert id="EHF-QII-G1-R002127" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til detaljist'">Property 'Holdbarhetsdager til detaljist' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002128" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til detaljist' may be used.</assert>
    <assert id="EHF-QII-G1-R002129" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til detaljist' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilDistributor']]">
    <assert id="EHF-QII-G1-R002130" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til distributør'">Property 'Holdbarhetsdager til distributør' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002131" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til distributør' may be used.</assert>
    <assert id="EHF-QII-G1-R002132" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til distributør' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilProdusent']]">
    <assert id="EHF-QII-G1-R002133" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til produsent'">Property 'Holdbarhetsdager til produsent' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002134" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til produsent' may be used.</assert>
    <assert id="EHF-QII-G1-R002135" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til produsent' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTotalt']]">
    <assert id="EHF-QII-G1-R002136" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager totalt'">Property 'Holdbarhetsdager totalt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002137" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager totalt' may be used.</assert>
    <assert id="EHF-QII-G1-R002138" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager totalt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Informasjonstekst']]">
    <assert id="EHF-QII-G1-R002139" flag="fatal" test="normalize-space(cbc:Name) = 'Informasjonstekst'">Property 'Informasjonstekst' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002140" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Informasjonstekst' may be used.</assert>
    <assert id="EHF-QII-G1-R002141" flag="fatal" test="normalize-space(cbc:Value)">Property 'Informasjonstekst' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002142" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Informasjonstekst' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#InformasjonstekstEngelsk']]">
    <assert id="EHF-QII-G1-R002143" flag="fatal" test="normalize-space(cbc:Name) = 'Informasjonstekst [Engelsk]'">Property 'Informasjonstekst [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002144" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Informasjonstekst [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R002145" flag="fatal" test="normalize-space(cbc:Value)">Property 'Informasjonstekst [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002146" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Informasjonstekst [Engelsk]' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Legitimasjonskrav']]">
    <assert id="EHF-QII-G1-R002147" flag="fatal" test="normalize-space(cbc:Name) = 'Legitimasjonskrav'">Property 'Legitimasjonskrav' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002148" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Legitimasjonskrav' may be used.</assert>
    <assert id="EHF-QII-G1-R002149" flag="fatal" test="normalize-space(cbc:Value)">Property 'Legitimasjonskrav' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MaksimumstemperaturCelcius']]">
    <assert id="EHF-QII-G1-R002150" flag="fatal" test="normalize-space(cbc:Name) = 'Maksimumstemperatur'">Property 'Maksimumstemperatur' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002151" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Maksimumstemperatur'.</assert>
    <assert id="EHF-QII-G1-R002152" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Maksimumstemperatur' may be used.</assert>
    <assert id="EHF-QII-G1-R002153" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Maksimumstemperatur' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002154" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Maksimumstemperatur' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Mengde']]">
    <assert id="EHF-QII-G1-R002155" flag="fatal" test="normalize-space(cbc:Name) = 'Mengde'">Property 'Mengde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002156" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Mengde'.</assert>
    <assert id="EHF-QII-G1-R002157" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Mengde' may be used.</assert>
    <assert id="EHF-QII-G1-R002158" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Mengde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002159" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Mengde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Mengdetypeenhet']]">
    <assert id="EHF-QII-G1-R002160" flag="fatal" test="normalize-space(cbc:Name) = 'Enhet til mengde'">Property 'Enhet til mengde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002161" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Enhet til mengde' may be used.</assert>
    <assert id="EHF-QII-G1-R002162" flag="fatal" test="normalize-space(cbc:Value)">Property 'Enhet til mengde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MerketMedEgenskaper']]">
    <assert id="EHF-QII-G1-R002163" flag="fatal" test="normalize-space(cbc:Name) = 'Er produktet merket med en eller flere egenskaper?'">Property 'Er produktet merket med en eller flere egenskaper?' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002164" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Er produktet merket med en eller flere egenskaper?' may be used.</assert>
    <assert id="EHF-QII-G1-R002165" flag="fatal" test="normalize-space(cbc:Value)">Property 'Er produktet merket med en eller flere egenskaper?' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MinimumstemperaturCelsius']]">
    <assert id="EHF-QII-G1-R002166" flag="fatal" test="normalize-space(cbc:Name) = 'Minimumstemperatur'">Property 'Minimumstemperatur' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002167" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Minimumstemperatur'.</assert>
    <assert id="EHF-QII-G1-R002168" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Minimumstemperatur' may be used.</assert>
    <assert id="EHF-QII-G1-R002169" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Minimumstemperatur' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002170" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Minimumstemperatur' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MVAKode']]">
    <assert id="EHF-QII-G1-R002171" flag="fatal" test="normalize-space(cbc:Name) = 'Mva sats'">Property 'Mva sats' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002172" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Mva sats' may be used.</assert>
    <assert id="EHF-QII-G1-R002173" flag="fatal" test="normalize-space(cbc:Value)">Property 'Mva sats' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Nettovekt']]">
    <assert id="EHF-QII-G1-R002174" flag="fatal" test="normalize-space(cbc:Name) = 'Nettovekt'">Property 'Nettovekt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002175" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Nettovekt'.</assert>
    <assert id="EHF-QII-G1-R002176" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Nettovekt' may be used.</assert>
    <assert id="EHF-QII-G1-R002177" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Nettovekt' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002178" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Nettovekt' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#OpprinnelseOgOpphav']]">
    <assert id="EHF-QII-G1-R002179" flag="fatal" test="normalize-space(cbc:Name) = 'Opprinnelsesland/Opphavssted hovedingrediens(er)'">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002180" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' may be used.</assert>
    <assert id="EHF-QII-G1-R002181" flag="fatal" test="normalize-space(cbc:Value)">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002182" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 200">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' value must have a length of maximum 200 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Produksjonsland']]">
    <assert id="EHF-QII-G1-R002183" flag="fatal" test="normalize-space(cbc:Name) = 'Produksjonsland'">Property 'Produksjonsland' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002184" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produksjonsland' may be used.</assert>
    <assert id="EHF-QII-G1-R002185" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produksjonsland' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProduktmerkingEgenskaper']]">
    <assert id="EHF-QII-G1-R002186" flag="fatal" test="normalize-space(cbc:Name) = 'Produktmerking egenskaper'">Property 'Produktmerking egenskaper' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002187" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produktmerking egenskaper' may be used.</assert>
    <assert id="EHF-QII-G1-R002188" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produktmerking egenskaper' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Stablingsfaktor']]">
    <assert id="EHF-QII-G1-R002189" flag="fatal" test="normalize-space(cbc:Name) = 'Stablingsfaktor'">Property 'Stablingsfaktor' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002190" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Stablingsfaktor'.</assert>
    <assert id="EHF-QII-G1-R002191" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Stablingsfaktor' may be used.</assert>
    <assert id="EHF-QII-G1-R002192" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Stablingsfaktor' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002193" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Stablingsfaktor' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Varemerke']]">
    <assert id="EHF-QII-G1-R002194" flag="fatal" test="normalize-space(cbc:Name) = 'Varemerke'">Property 'Varemerke' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002195" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varemerke' may be used.</assert>
    <assert id="EHF-QII-G1-R002196" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varemerke' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002197" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Varemerke' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AttributtverdiID']]">
    <assert id="EHF-QII-G1-R002198" flag="fatal" test="normalize-space(cbc:Name) = 'Varegruppe attributter'">Property 'Varegruppe attributter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002199" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varegruppe attributter' may be used.</assert>
    <assert id="EHF-QII-G1-R002200" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varegruppe attributter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PakningID']]">
    <assert id="EHF-QII-G1-R002201" flag="fatal" test="normalize-space(cbc:Name) = 'Sertifiseringer'">Property 'Sertifiseringer' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002202" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Sertifiseringer' may be used.</assert>
    <assert id="EHF-QII-G1-R002203" flag="fatal" test="normalize-space(cbc:Value)">Property 'Sertifiseringer' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#VaregruppeID']]">
    <assert id="EHF-QII-G1-R002204" flag="fatal" test="normalize-space(cbc:Name) = 'Varegruppe'">Property 'Varegruppe' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002205" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varegruppe' may be used.</assert>
    <assert id="EHF-QII-G1-R002206" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varegruppe' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Antall']]">
    <assert id="EHF-QII-G1-R002207" flag="fatal" test="normalize-space(cbc:Name) = 'Antall'">Property 'Antall' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002208" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall' may be used.</assert>
    <assert id="EHF-QII-G1-R002209" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallAvPant']]">
    <assert id="EHF-QII-G1-R002210" flag="fatal" test="normalize-space(cbc:Name) = 'Antall av pant'">Property 'Antall av pant' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002211" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall av pant' may be used.</assert>
    <assert id="EHF-QII-G1-R002212" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall av pant' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriBredden']]">
    <assert id="EHF-QII-G1-R002213" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i bredde'">Property 'Antall basispakninger i bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002214" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R002215" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i bredde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriDybden']]">
    <assert id="EHF-QII-G1-R002216" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i dybde'">Property 'Antall basispakninger i dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002217" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R002218" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i dybde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriHoyden']]">
    <assert id="EHF-QII-G1-R002219" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i høyde'">Property 'Antall basispakninger i høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002220" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R002221" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i høyde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallLag']]">
    <assert id="EHF-QII-G1-R002222" flag="fatal" test="normalize-space(cbc:Name) = 'Antall lag'">Property 'Antall lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002223" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall lag' may be used.</assert>
    <assert id="EHF-QII-G1-R002224" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall lag' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallPrLag']]">
    <assert id="EHF-QII-G1-R002225" flag="fatal" test="normalize-space(cbc:Name) = 'Antall pr lag'">Property 'Antall pr lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002226" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall pr lag' may be used.</assert>
    <assert id="EHF-QII-G1-R002227" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall pr lag' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AvvikendePakkemonster']]">
    <assert id="EHF-QII-G1-R002228" flag="fatal" test="normalize-space(cbc:Name) = 'Avvikende pakkemønster'">Property 'Avvikende pakkemønster' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002229" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Avvikende pakkemønster' may be used.</assert>
    <assert id="EHF-QII-G1-R002230" flag="fatal" test="normalize-space(cbc:Value)">Property 'Avvikende pakkemønster' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Bredde']]">
    <assert id="EHF-QII-G1-R002231" flag="fatal" test="normalize-space(cbc:Name) = 'Bredde'">Property 'Bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002232" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Bredde'.</assert>
    <assert id="EHF-QII-G1-R002233" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R002234" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Bredde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002235" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Bredde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Bruttovekt']]">
    <assert id="EHF-QII-G1-R002236" flag="fatal" test="normalize-space(cbc:Name) = 'Bruttovekt'">Property 'Bruttovekt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002237" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Bruttovekt'.</assert>
    <assert id="EHF-QII-G1-R002238" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Bruttovekt' may be used.</assert>
    <assert id="EHF-QII-G1-R002239" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Bruttovekt' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002240" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Bruttovekt' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Dybde']]">
    <assert id="EHF-QII-G1-R002241" flag="fatal" test="normalize-space(cbc:Name) = 'Dybde'">Property 'Dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002242" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Dybde'.</assert>
    <assert id="EHF-QII-G1-R002243" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R002244" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Dybde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002245" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Dybde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Egenskaper']]">
    <assert id="EHF-QII-G1-R002246" flag="fatal" test="normalize-space(cbc:Name) = 'Egenskaper'">Property 'Egenskaper' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002247" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Egenskaper' may be used.</assert>
    <assert id="EHF-QII-G1-R002248" flag="fatal" test="normalize-space(cbc:Value)">Property 'Egenskaper' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002249" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Egenskaper' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EgenskaperEngelsk']]">
    <assert id="EHF-QII-G1-R002250" flag="fatal" test="normalize-space(cbc:Name) = 'Egenskaper [Engelsk]'">Property 'Egenskaper [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002251" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Egenskaper [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R002252" flag="fatal" test="normalize-space(cbc:Value)">Property 'Egenskaper [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002253" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Egenskaper [Engelsk]' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Emballasjekode']]">
    <assert id="EHF-QII-G1-R002254" flag="fatal" test="normalize-space(cbc:Name) = 'Emballasje'">Property 'Emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002255" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R002256" flag="fatal" test="normalize-space(cbc:Value)">Property 'Emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErForbrukerpakning']]">
    <assert id="EHF-QII-G1-R002257" flag="fatal" test="normalize-space(cbc:Name) = 'ErForbrukerpakning'">Property 'ErForbrukerpakning' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002258" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'ErForbrukerpakning' may be used.</assert>
    <assert id="EHF-QII-G1-R002259" flag="fatal" test="normalize-space(cbc:Value)">Property 'ErForbrukerpakning' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#GS1Databaarer']]">
    <assert id="EHF-QII-G1-R002260" flag="fatal" test="normalize-space(cbc:Name) = 'GS1 Databær'">Property 'GS1 Databær' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002261" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'GS1 Databær' may be used.</assert>
    <assert id="EHF-QII-G1-R002262" flag="fatal" test="normalize-space(cbc:Value)">Property 'GS1 Databær' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Hoyde']]">
    <assert id="EHF-QII-G1-R002263" flag="fatal" test="normalize-space(cbc:Name) = 'Høyde'">Property 'Høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002264" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Høyde'.</assert>
    <assert id="EHF-QII-G1-R002265" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R002266" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Høyde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002267" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Høyde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoydePrLag']]">
    <assert id="EHF-QII-G1-R002268" flag="fatal" test="normalize-space(cbc:Name) = 'Høyde pr lag'">Property 'Høyde pr lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002269" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Høyde pr lag'.</assert>
    <assert id="EHF-QII-G1-R002270" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Høyde pr lag' may be used.</assert>
    <assert id="EHF-QII-G1-R002271" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Høyde pr lag' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002272" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Høyde pr lag' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LastbaererKode']]">
    <assert id="EHF-QII-G1-R002273" flag="fatal" test="normalize-space(cbc:Name) = 'Lastbærer'">Property 'Lastbærer' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002274" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Lastbærer' may be used.</assert>
    <assert id="EHF-QII-G1-R002275" flag="fatal" test="normalize-space(cbc:Value)">Property 'Lastbærer' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Markedsnavn']]">
    <assert id="EHF-QII-G1-R002276" flag="fatal" test="normalize-space(cbc:Name) = 'Fullstendig produktnavn'">Property 'Fullstendig produktnavn' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002277" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Fullstendig produktnavn' may be used.</assert>
    <assert id="EHF-QII-G1-R002278" flag="fatal" test="normalize-space(cbc:Value)">Property 'Fullstendig produktnavn' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002279" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Fullstendig produktnavn' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MarkedsnavnEngelsk']]">
    <assert id="EHF-QII-G1-R002280" flag="fatal" test="normalize-space(cbc:Name) = 'Fullstendig produktnavn [Engelsk]'">Property 'Fullstendig produktnavn [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002281" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Fullstendig produktnavn [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R002282" flag="fatal" test="normalize-space(cbc:Value)">Property 'Fullstendig produktnavn [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002283" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Fullstendig produktnavn [Engelsk]' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MaxTopplast']]">
    <assert id="EHF-QII-G1-R002284" flag="fatal" test="normalize-space(cbc:Name) = 'Max topplast'">Property 'Max topplast' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002285" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Max topplast'.</assert>
    <assert id="EHF-QII-G1-R002286" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Max topplast' may be used.</assert>
    <assert id="EHF-QII-G1-R002287" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Max topplast' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002288" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Max topplast' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PantGTIN']]">
    <assert id="EHF-QII-G1-R002289" flag="fatal" test="normalize-space(cbc:Name) = 'Pant GTIN'">Property 'Pant GTIN' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002290" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Pant GTIN' may be used.</assert>
    <assert id="EHF-QII-G1-R002291" flag="fatal" test="normalize-space(cbc:Value)">Property 'Pant GTIN' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ResirkulerbarEmballasje']]">
    <assert id="EHF-QII-G1-R002292" flag="fatal" test="normalize-space(cbc:Name) = 'Resirkulerbar emballasje'">Property 'Resirkulerbar emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002293" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Resirkulerbar emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R002294" flag="fatal" test="normalize-space(cbc:Value)">Property 'Resirkulerbar emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReturnerbarEmballasje']]">
    <assert id="EHF-QII-G1-R002295" flag="fatal" test="normalize-space(cbc:Name) = 'Returnerbar emballasje'">Property 'Returnerbar emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002296" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Returnerbar emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R002297" flag="fatal" test="normalize-space(cbc:Value)">Property 'Returnerbar emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SistKontrollmaalt']]">
    <assert id="EHF-QII-G1-R002298" flag="fatal" test="normalize-space(cbc:Name) = 'Sist kontrollmålt'">Property 'Sist kontrollmålt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002299" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Sist kontrollmålt' may be used.</assert>
    <assert id="EHF-QII-G1-R002300" flag="fatal" test="normalize-space(cbc:Value)">Property 'Sist kontrollmålt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceAvvikerFraLogistikkMaal']]">
    <assert id="EHF-QII-G1-R002301" flag="fatal" test="normalize-space(cbc:Name) = 'Avviker logistikkmål fra hyllemål'">Property 'Avviker logistikkmål fra hyllemål' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002302" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Avviker logistikkmål fra hyllemål' may be used.</assert>
    <assert id="EHF-QII-G1-R002303" flag="fatal" test="normalize-space(cbc:Value)">Property 'Avviker logistikkmål fra hyllemål' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceBredde']]">
    <assert id="EHF-QII-G1-R002304" flag="fatal" test="normalize-space(cbc:Name) = 'Space bredde'">Property 'Space bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002305" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space bredde'.</assert>
    <assert id="EHF-QII-G1-R002306" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R002307" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space bredde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002308" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space bredde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceDybde']]">
    <assert id="EHF-QII-G1-R002309" flag="fatal" test="normalize-space(cbc:Name) = 'Space dybde'">Property 'Space dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002310" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space dybde'.</assert>
    <assert id="EHF-QII-G1-R002311" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R002312" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space dybde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002313" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space dybde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceHoyde']]">
    <assert id="EHF-QII-G1-R002314" flag="fatal" test="normalize-space(cbc:Name) = 'Space høyde'">Property 'Space høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002315" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space høyde'.</assert>
    <assert id="EHF-QII-G1-R002316" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R002317" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space høyde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002318" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space høyde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#TotaltAntall']]">
    <assert id="EHF-QII-G1-R002319" flag="fatal" test="normalize-space(cbc:Name) = 'Totalt antall'">Property 'Totalt antall' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002320" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Totalt antall' may be used.</assert>
    <assert id="EHF-QII-G1-R002321" flag="fatal" test="normalize-space(cbc:Value)">Property 'Totalt antall' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PantEPDnr']]">
    <assert id="EHF-QII-G1-R002322" flag="fatal" test="normalize-space(cbc:Name) = 'Pant EPDnr'">Property 'Pant EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002323" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Pant EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R002324" flag="fatal" test="normalize-space(cbc:Value)">Property 'Pant EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EPDnr']]">
    <assert id="EHF-QII-G1-R002325" flag="fatal" test="normalize-space(cbc:Name) = 'EPDnr'">Property 'EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002326" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R002327" flag="fatal" test="normalize-space(cbc:Value)">Property 'EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErstattetAvProduktID']]">
    <assert id="EHF-QII-G1-R002328" flag="fatal" test="normalize-space(cbc:Name) = 'Erstattet av EPDnr'">Property 'Erstattet av EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002329" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Erstattet av EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R002330" flag="fatal" test="normalize-space(cbc:Value)">Property 'Erstattet av EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LeverandorVarenr']]">
    <assert id="EHF-QII-G1-R002331" flag="fatal" test="normalize-space(cbc:Name) = 'Leverandør varenr'">Property 'Leverandør varenr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002332" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Leverandør varenr' may be used.</assert>
    <assert id="EHF-QII-G1-R002333" flag="fatal" test="normalize-space(cbc:Value)">Property 'Leverandør varenr' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002334" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Leverandør varenr' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MottakerTilgang']]">
    <assert id="EHF-QII-G1-R002335" flag="fatal" test="normalize-space(cbc:Name) = 'Mottaker tilgang'">Property 'Mottaker tilgang' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002336" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Mottaker tilgang' may be used.</assert>
    <assert id="EHF-QII-G1-R002337" flag="fatal" test="normalize-space(cbc:Value)">Property 'Mottaker tilgang' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002338" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Mottaker tilgang' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProdusentVarenr']]">
    <assert id="EHF-QII-G1-R002339" flag="fatal" test="normalize-space(cbc:Name) = 'Produsent varenr'">Property 'Produsent varenr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002340" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produsent varenr' may be used.</assert>
    <assert id="EHF-QII-G1-R002341" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produsent varenr' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002342" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Produsent varenr' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#TilgjengeligFraDato']]">
    <assert id="EHF-QII-G1-R002343" flag="fatal" test="normalize-space(cbc:Name) = 'Tilgjengelig fra dato'">Property 'Tilgjengelig fra dato' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002344" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Tilgjengelig fra dato' may be used.</assert>
    <assert id="EHF-QII-G1-R002345" flag="fatal" test="normalize-space(cbc:Value)">Property 'Tilgjengelig fra dato' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProduktID']]">
    <assert id="EHF-QII-G1-R002346" flag="fatal" test="normalize-space(cbc:Name) = 'Hentesteder'">Property 'Hentesteder' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002347" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Hentesteder' may be used.</assert>
    <assert id="EHF-QII-G1-R002348" flag="fatal" test="normalize-space(cbc:Value)">Property 'Hentesteder' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErBestillbar']]">
    <assert id="EHF-QII-G1-R002349" flag="fatal" test="normalize-space(cbc:Name) = 'Bestillbar'">Property 'Bestillbar' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002350" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Bestillbar' may be used.</assert>
    <assert id="EHF-QII-G1-R002351" flag="fatal" test="normalize-space(cbc:Value)">Property 'Bestillbar' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergierklaring']]">
    <assert id="EHF-QII-G1-R002352" flag="fatal" test="normalize-space(cbc:Name) = 'Allergierklæring'">Property 'Allergierklæring' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002353" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergierklæring' may be used.</assert>
    <assert id="EHF-QII-G1-R002354" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergierklæring' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002355" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2560">Property 'Allergierklæring' value must have a length of maximum 2560 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallUmerkedeEnheter']]">
    <assert id="EHF-QII-G1-R002356" flag="fatal" test="normalize-space(cbc:Name) = 'Antall umerkede enheter'">Property 'Antall umerkede enheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002357" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall umerkede enheter' may be used.</assert>
    <assert id="EHF-QII-G1-R002358" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall umerkede enheter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErnaringsmessigePastander']]">
    <assert id="EHF-QII-G1-R002359" flag="fatal" test="normalize-space(cbc:Name) = 'Ernæringsmessige påstander'">Property 'Ernæringsmessige påstander' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002360" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Ernæringsmessige påstander' may be used.</assert>
    <assert id="EHF-QII-G1-R002361" flag="fatal" test="normalize-space(cbc:Value)">Property 'Ernæringsmessige påstander' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002362" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2560">Property 'Ernæringsmessige påstander' value must have a length of maximum 2560 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Ingredienser']]">
    <assert id="EHF-QII-G1-R002363" flag="fatal" test="normalize-space(cbc:Name) = 'Ingredienser'">Property 'Ingredienser' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002364" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Ingredienser' may be used.</assert>
    <assert id="EHF-QII-G1-R002365" flag="fatal" test="normalize-space(cbc:Value)">Property 'Ingredienser' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002366" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2560">Property 'Ingredienser' value must have a length of maximum 2560 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Umerketvariantbeskrivelse']]">
    <assert id="EHF-QII-G1-R002367" flag="fatal" test="normalize-space(cbc:Name) = 'Umerketvariantbeskrivelse'">Property 'Umerketvariantbeskrivelse' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002368" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Umerketvariantbeskrivelse' may be used.</assert>
    <assert id="EHF-QII-G1-R002369" flag="fatal" test="normalize-space(cbc:Value)">Property 'Umerketvariantbeskrivelse' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002370" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Umerketvariantbeskrivelse' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Umerketvariantnr']]">
    <assert id="EHF-QII-G1-R002371" flag="fatal" test="normalize-space(cbc:Name) = 'Umerketvariantnr'">Property 'Umerketvariantnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002372" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Umerketvariantnr' may be used.</assert>
    <assert id="EHF-QII-G1-R002373" flag="fatal" test="normalize-space(cbc:Value)">Property 'Umerketvariantnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.energi_kcal_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R002374" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Energi kcal pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Energi kcal pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002375" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Energi kcal pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002376" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Energi kcal pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002377" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Energi kcal pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002378" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Energi kcal pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.energi_kj_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R002379" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Energi kj pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Energi kj pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002380" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Energi kj pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002381" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Energi kj pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002382" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Energi kj pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002383" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Energi kj pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.fett_totalt_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R002384" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Fett (totalt) pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Fett (totalt) pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002385" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Fett (totalt) pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002386" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Fett (totalt) pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002387" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Fett (totalt) pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002388" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Fett (totalt) pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.karbohydrater_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R002389" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Karbohydrater pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Karbohydrater pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002390" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Karbohydrater pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002391" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Karbohydrater pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002392" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Karbohydrater pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002393" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Karbohydrater pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.mettede_fettsyrer_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R002394" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002395" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002396" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002397" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002398" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.protein_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R002399" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Protein pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Protein pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002400" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Protein pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002401" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Protein pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002402" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Protein pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002403" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Protein pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.salt_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R002404" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Salt pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Salt pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002405" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Salt pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002406" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Salt pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002407" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Salt pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002408" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Salt pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.sukkerarter_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R002409" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Sukkerarter pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Sukkerarter pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002410" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Sukkerarter pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002411" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Sukkerarter pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002412" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Sukkerarter pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002413" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Sukkerarter pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.bitoin_mikrogr']]">
    <assert id="EHF-QII-G1-R002414" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Biotin (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Biotin (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002415" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Biotin (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002416" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Biotin (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002417" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Biotin (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002418" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Biotin (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.fluorid_mg']]">
    <assert id="EHF-QII-G1-R002419" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Fluorid (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Fluorid (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002420" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Fluorid (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002421" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Fluorid (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002422" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Fluorid (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002423" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Fluorid (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.fosfor_mg']]">
    <assert id="EHF-QII-G1-R002424" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Fosfor (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Fosfor (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002425" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Fosfor (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002426" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Fosfor (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002427" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Fosfor (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002428" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Fosfor (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.jern_mg']]">
    <assert id="EHF-QII-G1-R002429" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Jern (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Jern (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002430" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Jern (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002431" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Jern (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002432" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Jern (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002433" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Jern (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.jod_mikrogr']]">
    <assert id="EHF-QII-G1-R002434" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Jod (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Jod (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002435" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Jod (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002436" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Jod (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002437" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Jod (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002438" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Jod (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.kalium_mg']]">
    <assert id="EHF-QII-G1-R002439" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kalium (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Kalium (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002440" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kalium (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002441" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kalium (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002442" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kalium (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002443" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kalium (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.kalsium_mg']]">
    <assert id="EHF-QII-G1-R002444" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kalsium (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Kalsium (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002445" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kalsium (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002446" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kalsium (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002447" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kalsium (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002448" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kalsium (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.klorid_mg']]">
    <assert id="EHF-QII-G1-R002449" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Klorid (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Klorid (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002450" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Klorid (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002451" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Klorid (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002452" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Klorid (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002453" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Klorid (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.kobber_mg']]">
    <assert id="EHF-QII-G1-R002454" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kobber (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Kobber (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002455" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kobber (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002456" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kobber (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002457" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kobber (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002458" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kobber (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.krom_mikrogr']]">
    <assert id="EHF-QII-G1-R002459" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Krom (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Krom (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002460" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Krom (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002461" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Krom (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002462" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Krom (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002463" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Krom (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.magnesium_mg']]">
    <assert id="EHF-QII-G1-R002464" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Magnesium (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Magnesium (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002465" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Magnesium (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002466" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Magnesium (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002467" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Magnesium (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002468" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Magnesium (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.mangan_mg']]">
    <assert id="EHF-QII-G1-R002469" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Mangan (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Mangan (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002470" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Mangan (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002471" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Mangan (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002472" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Mangan (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002473" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Mangan (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.molybden_mikrogr']]">
    <assert id="EHF-QII-G1-R002474" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Molybden (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Molybden (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002475" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Molybden (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002476" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Molybden (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002477" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Molybden (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002478" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Molybden (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.niacin_mg']]">
    <assert id="EHF-QII-G1-R002479" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Niacin (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Niacin (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002480" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Niacin (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002481" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Niacin (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002482" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Niacin (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002483" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Niacin (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.pantotensyre_mg']]">
    <assert id="EHF-QII-G1-R002484" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Pantotensyre (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Pantotensyre (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002485" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Pantotensyre (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002486" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Pantotensyre (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002487" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Pantotensyre (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002488" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Pantotensyre (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_bitoin']]">
    <assert id="EHF-QII-G1-R002489" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002490" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002491" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002492" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002493" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_fluorid']]">
    <assert id="EHF-QII-G1-R002494" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002495" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002496" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002497" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002498" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_folinsyre']]">
    <assert id="EHF-QII-G1-R002499" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002500" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002501" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002502" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002503" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_fosfor']]">
    <assert id="EHF-QII-G1-R002504" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002505" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002506" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002507" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002508" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_jern']]">
    <assert id="EHF-QII-G1-R002509" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Jern (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Jern (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002510" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Jern (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002511" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Jern (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002512" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Jern (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002513" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Jern (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_jod']]">
    <assert id="EHF-QII-G1-R002514" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Jod (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Jod (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002515" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Jod (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002516" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Jod (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002517" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Jod (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002518" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Jod (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_kalium']]">
    <assert id="EHF-QII-G1-R002519" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002520" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002521" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002522" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002523" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_kalsium']]">
    <assert id="EHF-QII-G1-R002524" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002525" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002526" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002527" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002528" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_klorid']]">
    <assert id="EHF-QII-G1-R002529" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002530" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002531" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002532" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002533" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_kobber']]">
    <assert id="EHF-QII-G1-R002534" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002535" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002536" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002537" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002538" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_krom']]">
    <assert id="EHF-QII-G1-R002539" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Krom (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Krom (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002540" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Krom (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002541" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Krom (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002542" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Krom (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002543" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Krom (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_magnesium']]">
    <assert id="EHF-QII-G1-R002544" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002545" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002546" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002547" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002548" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_mangan']]">
    <assert id="EHF-QII-G1-R002549" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002550" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002551" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002552" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002553" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_molybden']]">
    <assert id="EHF-QII-G1-R002554" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002555" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002556" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002557" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002558" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_niacin']]">
    <assert id="EHF-QII-G1-R002559" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002560" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002561" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002562" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002563" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_pantotensyre']]">
    <assert id="EHF-QII-G1-R002564" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002565" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002566" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002567" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002568" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_riboflavin']]">
    <assert id="EHF-QII-G1-R002569" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002570" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002571" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002572" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002573" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_selen']]">
    <assert id="EHF-QII-G1-R002574" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Selen (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Selen (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002575" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Selen (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002576" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Selen (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002577" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Selen (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002578" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Selen (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_sink']]">
    <assert id="EHF-QII-G1-R002579" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Sink (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Sink (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002580" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Sink (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002581" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Sink (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002582" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Sink (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002583" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Sink (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_tiamin']]">
    <assert id="EHF-QII-G1-R002584" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002585" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002586" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002587" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002588" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_a']]">
    <assert id="EHF-QII-G1-R002589" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002590" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002591" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002592" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002593" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_b12']]">
    <assert id="EHF-QII-G1-R002594" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002595" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002596" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002597" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002598" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_b6']]">
    <assert id="EHF-QII-G1-R002599" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002600" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002601" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002602" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002603" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_c']]">
    <assert id="EHF-QII-G1-R002604" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002605" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002606" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002607" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002608" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_d']]">
    <assert id="EHF-QII-G1-R002609" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002610" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002611" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002612" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002613" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_e']]">
    <assert id="EHF-QII-G1-R002614" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002615" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002616" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002617" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002618" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_k']]">
    <assert id="EHF-QII-G1-R002619" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002620" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002621" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002622" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002623" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.riboflavin_mg']]">
    <assert id="EHF-QII-G1-R002624" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Riboflavin (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Riboflavin (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002625" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Riboflavin (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002626" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Riboflavin (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002627" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Riboflavin (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002628" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Riboflavin (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.selen_mikrogr']]">
    <assert id="EHF-QII-G1-R002629" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Selen (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Selen (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002630" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Selen (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002631" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Selen (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002632" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Selen (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002633" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Selen (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.sink_mg']]">
    <assert id="EHF-QII-G1-R002634" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Sink (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Sink (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002635" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Sink (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002636" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Sink (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002637" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Sink (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002638" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Sink (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.tiamin_mg']]">
    <assert id="EHF-QII-G1-R002639" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Tiamin (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Tiamin (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002640" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Tiamin (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002641" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Tiamin (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002642" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Tiamin (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002643" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Tiamin (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_a_mikrogr']]">
    <assert id="EHF-QII-G1-R002644" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin A (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Vitamin A (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002645" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin A (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002646" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin A (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002647" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin A (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002648" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin A (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_b12_mikrogr']]">
    <assert id="EHF-QII-G1-R002649" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002650" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002651" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002652" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002653" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_b6_mg']]">
    <assert id="EHF-QII-G1-R002654" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin B6 (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Vitamin B6 (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002655" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin B6 (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002656" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin B6 (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002657" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin B6 (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002658" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin B6 (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_c_mikrogr']]">
    <assert id="EHF-QII-G1-R002659" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin C  (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Vitamin C  (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002660" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin C  (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002661" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin C  (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002662" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin C  (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002663" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin C  (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_d_mikrogr']]">
    <assert id="EHF-QII-G1-R002664" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin D (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Vitamin D (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002665" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin D (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002666" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin D (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002667" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin D (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002668" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin D (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_e_mg']]">
    <assert id="EHF-QII-G1-R002669" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin E  (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Vitamin E  (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002670" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin E  (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002671" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin E  (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002672" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin E  (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002673" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin E  (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_k_mikrogr']]">
    <assert id="EHF-QII-G1-R002674" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin K (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Vitamin K (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002675" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin K (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002676" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin K (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002677" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin K (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002678" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin K (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.enummettede_fettsyrer_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R002679" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002680" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002681" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002682" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002683" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.flerumettede_fettsyrer_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R002684" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002685" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002686" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002687" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002688" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.polyoler_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R002689" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Polyoler pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Polyoler pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002690" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Polyoler pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002691" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Polyoler pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002692" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Polyoler pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002693" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Polyoler pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.stivelse_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R002694" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Stivelse pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Stivelse pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002695" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Stivelse pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002696" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Stivelse pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002697" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Stivelse pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002698" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Stivelse pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.kostfibre_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R002699" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kostfiber pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Kostfiber pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002700" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kostfiber pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002701" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kostfiber pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002702" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kostfiber pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002703" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kostfiber pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:ol_og_alkoholholdig_drikke']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.folinsyre_mikrogr']]">
    <assert id="EHF-QII-G1-R002704" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Folinsyre (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Folinsyre (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002705" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Folinsyre (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R002706" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Folinsyre (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R002707" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Folinsyre (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002708" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Folinsyre (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]">
    <assert id="EHF-QII-G1-R002709" flag="fatal" test="cbc:Name">Property 'Name' is mandatory.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']"/>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cbc:Name">
    <assert id="EHF-QII-G1-R002710" flag="fatal" test="normalize-space()">Property 'Name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002711" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cbc:Description">
    <assert id="EHF-QII-G1-R002712" flag="fatal" test="normalize-space()">Property 'Description' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cbc:Keyword">
    <assert id="EHF-QII-G1-R002713" flag="fatal" test="normalize-space()">Property 'Keywords' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cbc:BrandName">
    <assert id="EHF-QII-G1-R002714" flag="fatal" test="normalize-space()">Property 'Brand name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002715" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Brand name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cbc:PackQuantity">
    <assert id="EHF-QII-G1-R002716" flag="fatal" test="normalize-space()">Property 'Packed quantity' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cbc:PackSizeNumeric">
    <assert id="EHF-QII-G1-R002717" flag="fatal" test="normalize-space()">Property 'Consumable unit' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:BuyersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R002718" flag="fatal" test="normalize-space()">Property 'Buyers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:SellersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R002719" flag="fatal" test="normalize-space()">Property 'Sellers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:ManufacturersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R002720" flag="fatal" test="normalize-space()">Property 'Manufacturers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:StandardItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R002721" flag="fatal" test="normalize-space()">Property 'Standard item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:CommodityClassification/cbc:ItemClassificationCode">
    <assert id="EHF-QII-G1-R002722" flag="fatal" test="normalize-space()">Property 'Classification code' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:OriginCountry/cbc:IdentificationCode">
    <assert id="EHF-QII-G1-R002723" flag="fatal" test="normalize-space()">Property 'Origin country' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:ItemInstance/cbc:BestBeforeDate">
    <assert id="EHF-QII-G1-R002724" flag="fatal" test="normalize-space()">Property 'Best before date' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002725" flag="fatal" test="not(normalize-space()) or (normalize-space() castable as xs:date)">Property 'Best before date' value must be a valid date.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:ItemInstance/cac:LotIdentification/cbc:LotNumberID">
    <assert id="EHF-QII-G1-R002726" flag="fatal" test="normalize-space()">Property 'Lot number' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AldersgrenseKode']]">
    <assert id="EHF-QII-G1-R002727" flag="fatal" test="normalize-space(cbc:Name) = 'Aldersgrense'">Property 'Aldersgrense' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002728" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Aldersgrense' may be used.</assert>
    <assert id="EHF-QII-G1-R002729" flag="fatal" test="normalize-space(cbc:Value)">Property 'Aldersgrense' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Beskrivelse']]">
    <assert id="EHF-QII-G1-R002730" flag="fatal" test="normalize-space(cbc:Name) = 'Produktnavn'">Property 'Produktnavn' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002731" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produktnavn' may be used.</assert>
    <assert id="EHF-QII-G1-R002732" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produktnavn' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002733" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Produktnavn' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseEngelsk']]">
    <assert id="EHF-QII-G1-R002734" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse [Engelsk]'">Property 'Beskrivelse [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002735" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R002736" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002737" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Beskrivelse [Engelsk]' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseUmerkedeEnheter']]">
    <assert id="EHF-QII-G1-R002738" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse umerkede enheter'">Property 'Beskrivelse umerkede enheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002739" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse umerkede enheter' may be used.</assert>
    <assert id="EHF-QII-G1-R002740" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse umerkede enheter' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002741" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Beskrivelse umerkede enheter' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseUmerkedeSalgsenheter']]">
    <assert id="EHF-QII-G1-R002742" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse umerkede salgsenheter'">Property 'Beskrivelse umerkede salgsenheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002743" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse umerkede salgsenheter' may be used.</assert>
    <assert id="EHF-QII-G1-R002744" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse umerkede salgsenheter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErMerketMedUtsalgspris']]">
    <assert id="EHF-QII-G1-R002745" flag="fatal" test="normalize-space(cbc:Name) = 'Merket med utsalgspris'">Property 'Merket med utsalgspris' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002746" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Merket med utsalgspris' may be used.</assert>
    <assert id="EHF-QII-G1-R002747" flag="fatal" test="normalize-space(cbc:Value)">Property 'Merket med utsalgspris' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErStorhusholdningsprodukt']]">
    <assert id="EHF-QII-G1-R002748" flag="fatal" test="normalize-space(cbc:Name) = 'Storhusholdningsprodukt'">Property 'Storhusholdningsprodukt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002749" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Storhusholdningsprodukt' may be used.</assert>
    <assert id="EHF-QII-G1-R002750" flag="fatal" test="normalize-space(cbc:Value)">Property 'Storhusholdningsprodukt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Fyllingsgrad']]">
    <assert id="EHF-QII-G1-R002751" flag="fatal" test="normalize-space(cbc:Name) = 'Fyllingsgrad'">Property 'Fyllingsgrad' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002752" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Fyllingsgrad'.</assert>
    <assert id="EHF-QII-G1-R002753" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Fyllingsgrad' may be used.</assert>
    <assert id="EHF-QII-G1-R002754" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Fyllingsgrad' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002755" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Fyllingsgrad' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilDetaljist']]">
    <assert id="EHF-QII-G1-R002756" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til detaljist'">Property 'Holdbarhetsdager til detaljist' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002757" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til detaljist' may be used.</assert>
    <assert id="EHF-QII-G1-R002758" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til detaljist' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilDistributor']]">
    <assert id="EHF-QII-G1-R002759" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til distributør'">Property 'Holdbarhetsdager til distributør' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002760" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til distributør' may be used.</assert>
    <assert id="EHF-QII-G1-R002761" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til distributør' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilProdusent']]">
    <assert id="EHF-QII-G1-R002762" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til produsent'">Property 'Holdbarhetsdager til produsent' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002763" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til produsent' may be used.</assert>
    <assert id="EHF-QII-G1-R002764" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til produsent' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTotalt']]">
    <assert id="EHF-QII-G1-R002765" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager totalt'">Property 'Holdbarhetsdager totalt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002766" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager totalt' may be used.</assert>
    <assert id="EHF-QII-G1-R002767" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager totalt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Informasjonstekst']]">
    <assert id="EHF-QII-G1-R002768" flag="fatal" test="normalize-space(cbc:Name) = 'Informasjonstekst'">Property 'Informasjonstekst' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002769" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Informasjonstekst' may be used.</assert>
    <assert id="EHF-QII-G1-R002770" flag="fatal" test="normalize-space(cbc:Value)">Property 'Informasjonstekst' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002771" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Informasjonstekst' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#InformasjonstekstEngelsk']]">
    <assert id="EHF-QII-G1-R002772" flag="fatal" test="normalize-space(cbc:Name) = 'Informasjonstekst [Engelsk]'">Property 'Informasjonstekst [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002773" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Informasjonstekst [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R002774" flag="fatal" test="normalize-space(cbc:Value)">Property 'Informasjonstekst [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002775" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Informasjonstekst [Engelsk]' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Legitimasjonskrav']]">
    <assert id="EHF-QII-G1-R002776" flag="fatal" test="normalize-space(cbc:Name) = 'Legitimasjonskrav'">Property 'Legitimasjonskrav' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002777" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Legitimasjonskrav' may be used.</assert>
    <assert id="EHF-QII-G1-R002778" flag="fatal" test="normalize-space(cbc:Value)">Property 'Legitimasjonskrav' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MaksimumstemperaturCelcius']]">
    <assert id="EHF-QII-G1-R002779" flag="fatal" test="normalize-space(cbc:Name) = 'Maksimumstemperatur'">Property 'Maksimumstemperatur' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002780" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Maksimumstemperatur'.</assert>
    <assert id="EHF-QII-G1-R002781" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Maksimumstemperatur' may be used.</assert>
    <assert id="EHF-QII-G1-R002782" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Maksimumstemperatur' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002783" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Maksimumstemperatur' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Mengde']]">
    <assert id="EHF-QII-G1-R002784" flag="fatal" test="normalize-space(cbc:Name) = 'Mengde'">Property 'Mengde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002785" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Mengde'.</assert>
    <assert id="EHF-QII-G1-R002786" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Mengde' may be used.</assert>
    <assert id="EHF-QII-G1-R002787" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Mengde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002788" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Mengde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Mengdetypeenhet']]">
    <assert id="EHF-QII-G1-R002789" flag="fatal" test="normalize-space(cbc:Name) = 'Enhet til mengde'">Property 'Enhet til mengde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002790" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Enhet til mengde' may be used.</assert>
    <assert id="EHF-QII-G1-R002791" flag="fatal" test="normalize-space(cbc:Value)">Property 'Enhet til mengde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MerketMedEgenskaper']]">
    <assert id="EHF-QII-G1-R002792" flag="fatal" test="normalize-space(cbc:Name) = 'Er produktet merket med en eller flere egenskaper?'">Property 'Er produktet merket med en eller flere egenskaper?' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002793" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Er produktet merket med en eller flere egenskaper?' may be used.</assert>
    <assert id="EHF-QII-G1-R002794" flag="fatal" test="normalize-space(cbc:Value)">Property 'Er produktet merket med en eller flere egenskaper?' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MinimumstemperaturCelsius']]">
    <assert id="EHF-QII-G1-R002795" flag="fatal" test="normalize-space(cbc:Name) = 'Minimumstemperatur'">Property 'Minimumstemperatur' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002796" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Minimumstemperatur'.</assert>
    <assert id="EHF-QII-G1-R002797" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Minimumstemperatur' may be used.</assert>
    <assert id="EHF-QII-G1-R002798" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Minimumstemperatur' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002799" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Minimumstemperatur' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MVAKode']]">
    <assert id="EHF-QII-G1-R002800" flag="fatal" test="normalize-space(cbc:Name) = 'Mva sats'">Property 'Mva sats' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002801" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Mva sats' may be used.</assert>
    <assert id="EHF-QII-G1-R002802" flag="fatal" test="normalize-space(cbc:Value)">Property 'Mva sats' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Nettovekt']]">
    <assert id="EHF-QII-G1-R002803" flag="fatal" test="normalize-space(cbc:Name) = 'Nettovekt'">Property 'Nettovekt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002804" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Nettovekt'.</assert>
    <assert id="EHF-QII-G1-R002805" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Nettovekt' may be used.</assert>
    <assert id="EHF-QII-G1-R002806" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Nettovekt' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002807" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Nettovekt' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#OpprinnelseOgOpphav']]">
    <assert id="EHF-QII-G1-R002808" flag="fatal" test="normalize-space(cbc:Name) = 'Opprinnelsesland/Opphavssted hovedingrediens(er)'">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002809" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' may be used.</assert>
    <assert id="EHF-QII-G1-R002810" flag="fatal" test="normalize-space(cbc:Value)">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002811" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 200">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' value must have a length of maximum 200 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Produksjonsland']]">
    <assert id="EHF-QII-G1-R002812" flag="fatal" test="normalize-space(cbc:Name) = 'Produksjonsland'">Property 'Produksjonsland' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002813" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produksjonsland' may be used.</assert>
    <assert id="EHF-QII-G1-R002814" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produksjonsland' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProduktmerkingEgenskaper']]">
    <assert id="EHF-QII-G1-R002815" flag="fatal" test="normalize-space(cbc:Name) = 'Produktmerking egenskaper'">Property 'Produktmerking egenskaper' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002816" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produktmerking egenskaper' may be used.</assert>
    <assert id="EHF-QII-G1-R002817" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produktmerking egenskaper' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Stablingsfaktor']]">
    <assert id="EHF-QII-G1-R002818" flag="fatal" test="normalize-space(cbc:Name) = 'Stablingsfaktor'">Property 'Stablingsfaktor' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002819" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Stablingsfaktor'.</assert>
    <assert id="EHF-QII-G1-R002820" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Stablingsfaktor' may be used.</assert>
    <assert id="EHF-QII-G1-R002821" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Stablingsfaktor' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002822" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Stablingsfaktor' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Varemerke']]">
    <assert id="EHF-QII-G1-R002823" flag="fatal" test="normalize-space(cbc:Name) = 'Varemerke'">Property 'Varemerke' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002824" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varemerke' may be used.</assert>
    <assert id="EHF-QII-G1-R002825" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varemerke' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002826" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Varemerke' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AttributtverdiID']]">
    <assert id="EHF-QII-G1-R002827" flag="fatal" test="normalize-space(cbc:Name) = 'Varegruppe attributter'">Property 'Varegruppe attributter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002828" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varegruppe attributter' may be used.</assert>
    <assert id="EHF-QII-G1-R002829" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varegruppe attributter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PakningID']]">
    <assert id="EHF-QII-G1-R002830" flag="fatal" test="normalize-space(cbc:Name) = 'Sertifiseringer'">Property 'Sertifiseringer' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002831" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Sertifiseringer' may be used.</assert>
    <assert id="EHF-QII-G1-R002832" flag="fatal" test="normalize-space(cbc:Value)">Property 'Sertifiseringer' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#VaregruppeID']]">
    <assert id="EHF-QII-G1-R002833" flag="fatal" test="normalize-space(cbc:Name) = 'Varegruppe'">Property 'Varegruppe' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002834" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varegruppe' may be used.</assert>
    <assert id="EHF-QII-G1-R002835" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varegruppe' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Antall']]">
    <assert id="EHF-QII-G1-R002836" flag="fatal" test="normalize-space(cbc:Name) = 'Antall'">Property 'Antall' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002837" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall' may be used.</assert>
    <assert id="EHF-QII-G1-R002838" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallAvPant']]">
    <assert id="EHF-QII-G1-R002839" flag="fatal" test="normalize-space(cbc:Name) = 'Antall av pant'">Property 'Antall av pant' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002840" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall av pant' may be used.</assert>
    <assert id="EHF-QII-G1-R002841" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall av pant' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriBredden']]">
    <assert id="EHF-QII-G1-R002842" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i bredde'">Property 'Antall basispakninger i bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002843" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R002844" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i bredde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriDybden']]">
    <assert id="EHF-QII-G1-R002845" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i dybde'">Property 'Antall basispakninger i dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002846" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R002847" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i dybde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriHoyden']]">
    <assert id="EHF-QII-G1-R002848" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i høyde'">Property 'Antall basispakninger i høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002849" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R002850" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i høyde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallLag']]">
    <assert id="EHF-QII-G1-R002851" flag="fatal" test="normalize-space(cbc:Name) = 'Antall lag'">Property 'Antall lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002852" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall lag' may be used.</assert>
    <assert id="EHF-QII-G1-R002853" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall lag' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallPrLag']]">
    <assert id="EHF-QII-G1-R002854" flag="fatal" test="normalize-space(cbc:Name) = 'Antall pr lag'">Property 'Antall pr lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002855" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall pr lag' may be used.</assert>
    <assert id="EHF-QII-G1-R002856" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall pr lag' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AvvikendePakkemonster']]">
    <assert id="EHF-QII-G1-R002857" flag="fatal" test="normalize-space(cbc:Name) = 'Avvikende pakkemønster'">Property 'Avvikende pakkemønster' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002858" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Avvikende pakkemønster' may be used.</assert>
    <assert id="EHF-QII-G1-R002859" flag="fatal" test="normalize-space(cbc:Value)">Property 'Avvikende pakkemønster' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Bredde']]">
    <assert id="EHF-QII-G1-R002860" flag="fatal" test="normalize-space(cbc:Name) = 'Bredde'">Property 'Bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002861" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Bredde'.</assert>
    <assert id="EHF-QII-G1-R002862" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R002863" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Bredde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002864" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Bredde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Bruttovekt']]">
    <assert id="EHF-QII-G1-R002865" flag="fatal" test="normalize-space(cbc:Name) = 'Bruttovekt'">Property 'Bruttovekt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002866" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Bruttovekt'.</assert>
    <assert id="EHF-QII-G1-R002867" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Bruttovekt' may be used.</assert>
    <assert id="EHF-QII-G1-R002868" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Bruttovekt' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002869" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Bruttovekt' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Dybde']]">
    <assert id="EHF-QII-G1-R002870" flag="fatal" test="normalize-space(cbc:Name) = 'Dybde'">Property 'Dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002871" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Dybde'.</assert>
    <assert id="EHF-QII-G1-R002872" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R002873" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Dybde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002874" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Dybde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Egenskaper']]">
    <assert id="EHF-QII-G1-R002875" flag="fatal" test="normalize-space(cbc:Name) = 'Egenskaper'">Property 'Egenskaper' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002876" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Egenskaper' may be used.</assert>
    <assert id="EHF-QII-G1-R002877" flag="fatal" test="normalize-space(cbc:Value)">Property 'Egenskaper' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002878" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Egenskaper' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EgenskaperEngelsk']]">
    <assert id="EHF-QII-G1-R002879" flag="fatal" test="normalize-space(cbc:Name) = 'Egenskaper [Engelsk]'">Property 'Egenskaper [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002880" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Egenskaper [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R002881" flag="fatal" test="normalize-space(cbc:Value)">Property 'Egenskaper [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002882" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Egenskaper [Engelsk]' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Emballasjekode']]">
    <assert id="EHF-QII-G1-R002883" flag="fatal" test="normalize-space(cbc:Name) = 'Emballasje'">Property 'Emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002884" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R002885" flag="fatal" test="normalize-space(cbc:Value)">Property 'Emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErForbrukerpakning']]">
    <assert id="EHF-QII-G1-R002886" flag="fatal" test="normalize-space(cbc:Name) = 'ErForbrukerpakning'">Property 'ErForbrukerpakning' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002887" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'ErForbrukerpakning' may be used.</assert>
    <assert id="EHF-QII-G1-R002888" flag="fatal" test="normalize-space(cbc:Value)">Property 'ErForbrukerpakning' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#GS1Databaarer']]">
    <assert id="EHF-QII-G1-R002889" flag="fatal" test="normalize-space(cbc:Name) = 'GS1 Databær'">Property 'GS1 Databær' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002890" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'GS1 Databær' may be used.</assert>
    <assert id="EHF-QII-G1-R002891" flag="fatal" test="normalize-space(cbc:Value)">Property 'GS1 Databær' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Hoyde']]">
    <assert id="EHF-QII-G1-R002892" flag="fatal" test="normalize-space(cbc:Name) = 'Høyde'">Property 'Høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002893" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Høyde'.</assert>
    <assert id="EHF-QII-G1-R002894" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R002895" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Høyde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002896" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Høyde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoydePrLag']]">
    <assert id="EHF-QII-G1-R002897" flag="fatal" test="normalize-space(cbc:Name) = 'Høyde pr lag'">Property 'Høyde pr lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002898" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Høyde pr lag'.</assert>
    <assert id="EHF-QII-G1-R002899" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Høyde pr lag' may be used.</assert>
    <assert id="EHF-QII-G1-R002900" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Høyde pr lag' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002901" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Høyde pr lag' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LastbaererKode']]">
    <assert id="EHF-QII-G1-R002902" flag="fatal" test="normalize-space(cbc:Name) = 'Lastbærer'">Property 'Lastbærer' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002903" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Lastbærer' may be used.</assert>
    <assert id="EHF-QII-G1-R002904" flag="fatal" test="normalize-space(cbc:Value)">Property 'Lastbærer' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Markedsnavn']]">
    <assert id="EHF-QII-G1-R002905" flag="fatal" test="normalize-space(cbc:Name) = 'Fullstendig produktnavn'">Property 'Fullstendig produktnavn' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002906" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Fullstendig produktnavn' may be used.</assert>
    <assert id="EHF-QII-G1-R002907" flag="fatal" test="normalize-space(cbc:Value)">Property 'Fullstendig produktnavn' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002908" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Fullstendig produktnavn' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MarkedsnavnEngelsk']]">
    <assert id="EHF-QII-G1-R002909" flag="fatal" test="normalize-space(cbc:Name) = 'Fullstendig produktnavn [Engelsk]'">Property 'Fullstendig produktnavn [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002910" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Fullstendig produktnavn [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R002911" flag="fatal" test="normalize-space(cbc:Value)">Property 'Fullstendig produktnavn [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002912" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Fullstendig produktnavn [Engelsk]' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MaxTopplast']]">
    <assert id="EHF-QII-G1-R002913" flag="fatal" test="normalize-space(cbc:Name) = 'Max topplast'">Property 'Max topplast' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002914" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Max topplast'.</assert>
    <assert id="EHF-QII-G1-R002915" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Max topplast' may be used.</assert>
    <assert id="EHF-QII-G1-R002916" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Max topplast' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002917" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Max topplast' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PantGTIN']]">
    <assert id="EHF-QII-G1-R002918" flag="fatal" test="normalize-space(cbc:Name) = 'Pant GTIN'">Property 'Pant GTIN' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002919" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Pant GTIN' may be used.</assert>
    <assert id="EHF-QII-G1-R002920" flag="fatal" test="normalize-space(cbc:Value)">Property 'Pant GTIN' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ResirkulerbarEmballasje']]">
    <assert id="EHF-QII-G1-R002921" flag="fatal" test="normalize-space(cbc:Name) = 'Resirkulerbar emballasje'">Property 'Resirkulerbar emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002922" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Resirkulerbar emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R002923" flag="fatal" test="normalize-space(cbc:Value)">Property 'Resirkulerbar emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReturnerbarEmballasje']]">
    <assert id="EHF-QII-G1-R002924" flag="fatal" test="normalize-space(cbc:Name) = 'Returnerbar emballasje'">Property 'Returnerbar emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002925" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Returnerbar emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R002926" flag="fatal" test="normalize-space(cbc:Value)">Property 'Returnerbar emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SistKontrollmaalt']]">
    <assert id="EHF-QII-G1-R002927" flag="fatal" test="normalize-space(cbc:Name) = 'Sist kontrollmålt'">Property 'Sist kontrollmålt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002928" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Sist kontrollmålt' may be used.</assert>
    <assert id="EHF-QII-G1-R002929" flag="fatal" test="normalize-space(cbc:Value)">Property 'Sist kontrollmålt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceAvvikerFraLogistikkMaal']]">
    <assert id="EHF-QII-G1-R002930" flag="fatal" test="normalize-space(cbc:Name) = 'Avviker logistikkmål fra hyllemål'">Property 'Avviker logistikkmål fra hyllemål' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002931" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Avviker logistikkmål fra hyllemål' may be used.</assert>
    <assert id="EHF-QII-G1-R002932" flag="fatal" test="normalize-space(cbc:Value)">Property 'Avviker logistikkmål fra hyllemål' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceBredde']]">
    <assert id="EHF-QII-G1-R002933" flag="fatal" test="normalize-space(cbc:Name) = 'Space bredde'">Property 'Space bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002934" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space bredde'.</assert>
    <assert id="EHF-QII-G1-R002935" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R002936" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space bredde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002937" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space bredde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceDybde']]">
    <assert id="EHF-QII-G1-R002938" flag="fatal" test="normalize-space(cbc:Name) = 'Space dybde'">Property 'Space dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002939" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space dybde'.</assert>
    <assert id="EHF-QII-G1-R002940" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R002941" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space dybde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002942" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space dybde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceHoyde']]">
    <assert id="EHF-QII-G1-R002943" flag="fatal" test="normalize-space(cbc:Name) = 'Space høyde'">Property 'Space høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002944" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space høyde'.</assert>
    <assert id="EHF-QII-G1-R002945" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R002946" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space høyde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002947" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space høyde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#TotaltAntall']]">
    <assert id="EHF-QII-G1-R002948" flag="fatal" test="normalize-space(cbc:Name) = 'Totalt antall'">Property 'Totalt antall' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002949" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Totalt antall' may be used.</assert>
    <assert id="EHF-QII-G1-R002950" flag="fatal" test="normalize-space(cbc:Value)">Property 'Totalt antall' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PantEPDnr']]">
    <assert id="EHF-QII-G1-R002951" flag="fatal" test="normalize-space(cbc:Name) = 'Pant EPDnr'">Property 'Pant EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002952" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Pant EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R002953" flag="fatal" test="normalize-space(cbc:Value)">Property 'Pant EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EPDnr']]">
    <assert id="EHF-QII-G1-R002954" flag="fatal" test="normalize-space(cbc:Name) = 'EPDnr'">Property 'EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002955" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R002956" flag="fatal" test="normalize-space(cbc:Value)">Property 'EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErstattetAvProduktID']]">
    <assert id="EHF-QII-G1-R002957" flag="fatal" test="normalize-space(cbc:Name) = 'Erstattet av EPDnr'">Property 'Erstattet av EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002958" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Erstattet av EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R002959" flag="fatal" test="normalize-space(cbc:Value)">Property 'Erstattet av EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LeverandorVarenr']]">
    <assert id="EHF-QII-G1-R002960" flag="fatal" test="normalize-space(cbc:Name) = 'Leverandør varenr'">Property 'Leverandør varenr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002961" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Leverandør varenr' may be used.</assert>
    <assert id="EHF-QII-G1-R002962" flag="fatal" test="normalize-space(cbc:Value)">Property 'Leverandør varenr' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002963" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Leverandør varenr' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MottakerTilgang']]">
    <assert id="EHF-QII-G1-R002964" flag="fatal" test="normalize-space(cbc:Name) = 'Mottaker tilgang'">Property 'Mottaker tilgang' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002965" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Mottaker tilgang' may be used.</assert>
    <assert id="EHF-QII-G1-R002966" flag="fatal" test="normalize-space(cbc:Value)">Property 'Mottaker tilgang' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002967" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Mottaker tilgang' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProdusentVarenr']]">
    <assert id="EHF-QII-G1-R002968" flag="fatal" test="normalize-space(cbc:Name) = 'Produsent varenr'">Property 'Produsent varenr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002969" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produsent varenr' may be used.</assert>
    <assert id="EHF-QII-G1-R002970" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produsent varenr' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002971" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Produsent varenr' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#TilgjengeligFraDato']]">
    <assert id="EHF-QII-G1-R002972" flag="fatal" test="normalize-space(cbc:Name) = 'Tilgjengelig fra dato'">Property 'Tilgjengelig fra dato' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002973" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Tilgjengelig fra dato' may be used.</assert>
    <assert id="EHF-QII-G1-R002974" flag="fatal" test="normalize-space(cbc:Value)">Property 'Tilgjengelig fra dato' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProduktID']]">
    <assert id="EHF-QII-G1-R002975" flag="fatal" test="normalize-space(cbc:Name) = 'Hentesteder'">Property 'Hentesteder' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002976" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Hentesteder' may be used.</assert>
    <assert id="EHF-QII-G1-R002977" flag="fatal" test="normalize-space(cbc:Value)">Property 'Hentesteder' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErBestillbar']]">
    <assert id="EHF-QII-G1-R002978" flag="fatal" test="normalize-space(cbc:Name) = 'Bestillbar'">Property 'Bestillbar' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002979" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Bestillbar' may be used.</assert>
    <assert id="EHF-QII-G1-R002980" flag="fatal" test="normalize-space(cbc:Value)">Property 'Bestillbar' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallUmerkedeEnheter']]">
    <assert id="EHF-QII-G1-R002981" flag="fatal" test="normalize-space(cbc:Name) = 'Antall umerkede enheter'">Property 'Antall umerkede enheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002982" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall umerkede enheter' may be used.</assert>
    <assert id="EHF-QII-G1-R002983" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall umerkede enheter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Umerketvariantbeskrivelse']]">
    <assert id="EHF-QII-G1-R002984" flag="fatal" test="normalize-space(cbc:Name) = 'Umerketvariantbeskrivelse'">Property 'Umerketvariantbeskrivelse' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002985" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Umerketvariantbeskrivelse' may be used.</assert>
    <assert id="EHF-QII-G1-R002986" flag="fatal" test="normalize-space(cbc:Value)">Property 'Umerketvariantbeskrivelse' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002987" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Umerketvariantbeskrivelse' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:tobakk']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Umerketvariantnr']]">
    <assert id="EHF-QII-G1-R002988" flag="fatal" test="normalize-space(cbc:Name) = 'Umerketvariantnr'">Property 'Umerketvariantnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R002989" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Umerketvariantnr' may be used.</assert>
    <assert id="EHF-QII-G1-R002990" flag="fatal" test="normalize-space(cbc:Value)">Property 'Umerketvariantnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]">
    <assert id="EHF-QII-G1-R002991" flag="fatal" test="cbc:Name">Property 'Name' is mandatory.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']"/>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cbc:Name">
    <assert id="EHF-QII-G1-R002992" flag="fatal" test="normalize-space()">Property 'Name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002993" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cbc:Description">
    <assert id="EHF-QII-G1-R002994" flag="fatal" test="normalize-space()">Property 'Description' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cbc:Keyword">
    <assert id="EHF-QII-G1-R002995" flag="fatal" test="normalize-space()">Property 'Keywords' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cbc:BrandName">
    <assert id="EHF-QII-G1-R002996" flag="fatal" test="normalize-space()">Property 'Brand name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R002997" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Brand name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cbc:PackQuantity">
    <assert id="EHF-QII-G1-R002998" flag="fatal" test="normalize-space()">Property 'Packed quantity' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cbc:PackSizeNumeric">
    <assert id="EHF-QII-G1-R002999" flag="fatal" test="normalize-space()">Property 'Consumable unit' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:BuyersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R003000" flag="fatal" test="normalize-space()">Property 'Buyers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:SellersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R003001" flag="fatal" test="normalize-space()">Property 'Sellers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:ManufacturersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R003002" flag="fatal" test="normalize-space()">Property 'Manufacturers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:StandardItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R003003" flag="fatal" test="normalize-space()">Property 'Standard item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:CommodityClassification/cbc:ItemClassificationCode">
    <assert id="EHF-QII-G1-R003004" flag="fatal" test="normalize-space()">Property 'Classification code' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:OriginCountry/cbc:IdentificationCode">
    <assert id="EHF-QII-G1-R003005" flag="fatal" test="normalize-space()">Property 'Origin country' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:ItemInstance/cbc:BestBeforeDate">
    <assert id="EHF-QII-G1-R003006" flag="fatal" test="normalize-space()">Property 'Best before date' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003007" flag="fatal" test="not(normalize-space()) or (normalize-space() castable as xs:date)">Property 'Best before date' value must be a valid date.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:ItemInstance/cac:LotIdentification/cbc:LotNumberID">
    <assert id="EHF-QII-G1-R003008" flag="fatal" test="normalize-space()">Property 'Lot number' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AldersgrenseKode']]">
    <assert id="EHF-QII-G1-R003009" flag="fatal" test="normalize-space(cbc:Name) = 'Aldersgrense'">Property 'Aldersgrense' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003010" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Aldersgrense' may be used.</assert>
    <assert id="EHF-QII-G1-R003011" flag="fatal" test="normalize-space(cbc:Value)">Property 'Aldersgrense' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Alkoholprosent']]">
    <assert id="EHF-QII-G1-R003012" flag="fatal" test="normalize-space(cbc:Name) = 'Alkoholprosent'">Property 'Alkoholprosent' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003013" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Alkoholprosent'.</assert>
    <assert id="EHF-QII-G1-R003014" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Alkoholprosent' may be used.</assert>
    <assert id="EHF-QII-G1-R003015" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Alkoholprosent' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003016" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Alkoholprosent' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AlkoholRapporteringsgruppeKode']]">
    <assert id="EHF-QII-G1-R003017" flag="fatal" test="normalize-space(cbc:Name) = 'Alkohol rapporteringsgruppe'">Property 'Alkohol rapporteringsgruppe' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003018" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Alkohol rapporteringsgruppe' may be used.</assert>
    <assert id="EHF-QII-G1-R003019" flag="fatal" test="normalize-space(cbc:Value)">Property 'Alkohol rapporteringsgruppe' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.blotdyr']]">
    <assert id="EHF-QII-G1-R003020" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Bløtdyr (allergen)'">Property 'Allergener, Bløtdyr (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003021" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Bløtdyr (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003022" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Bløtdyr (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.egg']]">
    <assert id="EHF-QII-G1-R003023" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Egg (allergen)'">Property 'Allergener, Egg (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003024" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Egg (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003025" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Egg (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.fisk']]">
    <assert id="EHF-QII-G1-R003026" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Fisk (allergen)'">Property 'Allergener, Fisk (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003027" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Fisk (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003028" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Fisk (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_bygg_gluten']]">
    <assert id="EHF-QII-G1-R003029" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Bygg gluten (allergen)'">Property 'Allergener, Bygg gluten (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003030" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Bygg gluten (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003031" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Bygg gluten (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_havre_gluten']]">
    <assert id="EHF-QII-G1-R003032" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Havre gluten (allergen)'">Property 'Allergener, Havre gluten (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003033" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Havre gluten (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003034" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Havre gluten (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_hvete_gluten']]">
    <assert id="EHF-QII-G1-R003035" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Hvete gluten (allergen)'">Property 'Allergener, Hvete gluten (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003036" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Hvete gluten (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003037" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Hvete gluten (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_rug_gluten']]">
    <assert id="EHF-QII-G1-R003038" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Rug gluten (allergen)'">Property 'Allergener, Rug gluten (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003039" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Rug gluten (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003040" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Rug gluten (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.lupin']]">
    <assert id="EHF-QII-G1-R003041" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Lupiner (allergen)'">Property 'Allergener, Lupiner (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003042" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Lupiner (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003043" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Lupiner (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.melk']]">
    <assert id="EHF-QII-G1-R003044" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Melk (allergen)'">Property 'Allergener, Melk (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003045" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Melk (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003046" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Melk (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter']]">
    <assert id="EHF-QII-G1-R003047" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Nøtter (allergen)'">Property 'Allergener, Nøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003048" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Nøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003049" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Nøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_hasselnotter']]">
    <assert id="EHF-QII-G1-R003050" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Hasselnøtter (allergen)'">Property 'Allergener, Hasselnøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003051" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Hasselnøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003052" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Hasselnøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_kasjunotter']]">
    <assert id="EHF-QII-G1-R003053" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Kasjunøtter (allergen)'">Property 'Allergener, Kasjunøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003054" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Kasjunøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003055" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Kasjunøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_macademianotter']]">
    <assert id="EHF-QII-G1-R003056" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Macademiannøtter (allergen)'">Property 'Allergener, Macademiannøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003057" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Macademiannøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003058" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Macademiannøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_mandler']]">
    <assert id="EHF-QII-G1-R003059" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Mandler (allergen)'">Property 'Allergener, Mandler (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003060" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Mandler (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003061" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Mandler (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_paranotter']]">
    <assert id="EHF-QII-G1-R003062" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Paranøtter (allergen)'">Property 'Allergener, Paranøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003063" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Paranøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003064" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Paranøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_peanotter']]">
    <assert id="EHF-QII-G1-R003065" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Peanøtter (allergen)'">Property 'Allergener, Peanøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003066" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Peanøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003067" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Peanøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_pekannotter']]">
    <assert id="EHF-QII-G1-R003068" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Pekannøtter (allergen)'">Property 'Allergener, Pekannøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003069" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Pekannøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003070" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Pekannøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_pistasienotter']]">
    <assert id="EHF-QII-G1-R003071" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Pistasienøtter (allergen)'">Property 'Allergener, Pistasienøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003072" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Pistasienøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003073" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Pistasienøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.notter_valnotter']]">
    <assert id="EHF-QII-G1-R003074" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Valnøtter (allergen)'">Property 'Allergener, Valnøtter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003075" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Valnøtter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003076" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Valnøtter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.selleri']]">
    <assert id="EHF-QII-G1-R003077" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Selleri (allergen)'">Property 'Allergener, Selleri (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003078" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Selleri (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003079" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Selleri (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.sennep']]">
    <assert id="EHF-QII-G1-R003080" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Sennep (allergen)'">Property 'Allergener, Sennep (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003081" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Sennep (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003082" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Sennep (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.sesamfro']]">
    <assert id="EHF-QII-G1-R003083" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Sesamfrø (allergen)'">Property 'Allergener, Sesamfrø (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003084" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Sesamfrø (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003085" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Sesamfrø (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.skalldyr']]">
    <assert id="EHF-QII-G1-R003086" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Skalldyr (allergen)'">Property 'Allergener, Skalldyr (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003087" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Skalldyr (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003088" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Skalldyr (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.soya']]">
    <assert id="EHF-QII-G1-R003089" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Soya (allergen)'">Property 'Allergener, Soya (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003090" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Soya (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003091" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Soya (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_spelt_gluten']]">
    <assert id="EHF-QII-G1-R003092" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Spelt gluten (allergen)'">Property 'Allergener, Spelt gluten (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003093" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Spelt gluten (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003094" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Spelt gluten (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.kornslag_khorasanhvete_gluten']]">
    <assert id="EHF-QII-G1-R003095" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Khorasanhvete gluten (allergen)'">Property 'Allergener, Khorasanhvete gluten (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003096" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Khorasanhvete gluten (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003097" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Khorasanhvete gluten (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.svoveldioksid_sulfitter']]">
    <assert id="EHF-QII-G1-R003098" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Svoveldioksid eller sulfitter (allergen)'">Property 'Allergener, Svoveldioksid eller sulfitter (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003099" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Svoveldioksid eller sulfitter (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003100" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Svoveldioksid eller sulfitter (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergener.gluten']]">
    <assert id="EHF-QII-G1-R003101" flag="fatal" test="normalize-space(cbc:Name) = 'Allergener, Gluten (allergen)'">Property 'Allergener, Gluten (allergen)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003102" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergener, Gluten (allergen)' may be used.</assert>
    <assert id="EHF-QII-G1-R003103" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergener, Gluten (allergen)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Beskrivelse']]">
    <assert id="EHF-QII-G1-R003104" flag="fatal" test="normalize-space(cbc:Name) = 'Produktnavn'">Property 'Produktnavn' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003105" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produktnavn' may be used.</assert>
    <assert id="EHF-QII-G1-R003106" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produktnavn' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003107" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Produktnavn' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseEngelsk']]">
    <assert id="EHF-QII-G1-R003108" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse [Engelsk]'">Property 'Beskrivelse [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003109" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R003110" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003111" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Beskrivelse [Engelsk]' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseUmerkedeEnheter']]">
    <assert id="EHF-QII-G1-R003112" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse umerkede enheter'">Property 'Beskrivelse umerkede enheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003113" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse umerkede enheter' may be used.</assert>
    <assert id="EHF-QII-G1-R003114" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse umerkede enheter' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003115" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Beskrivelse umerkede enheter' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#BeskrivelseUmerkedeSalgsenheter']]">
    <assert id="EHF-QII-G1-R003116" flag="fatal" test="normalize-space(cbc:Name) = 'Beskrivelse umerkede salgsenheter'">Property 'Beskrivelse umerkede salgsenheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003117" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Beskrivelse umerkede salgsenheter' may be used.</assert>
    <assert id="EHF-QII-G1-R003118" flag="fatal" test="normalize-space(cbc:Value)">Property 'Beskrivelse umerkede salgsenheter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErMerketMedUtsalgspris']]">
    <assert id="EHF-QII-G1-R003119" flag="fatal" test="normalize-space(cbc:Name) = 'Merket med utsalgspris'">Property 'Merket med utsalgspris' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003120" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Merket med utsalgspris' may be used.</assert>
    <assert id="EHF-QII-G1-R003121" flag="fatal" test="normalize-space(cbc:Value)">Property 'Merket med utsalgspris' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErStorhusholdningsprodukt']]">
    <assert id="EHF-QII-G1-R003122" flag="fatal" test="normalize-space(cbc:Name) = 'Storhusholdningsprodukt'">Property 'Storhusholdningsprodukt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003123" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Storhusholdningsprodukt' may be used.</assert>
    <assert id="EHF-QII-G1-R003124" flag="fatal" test="normalize-space(cbc:Value)">Property 'Storhusholdningsprodukt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Fyllingsgrad']]">
    <assert id="EHF-QII-G1-R003125" flag="fatal" test="normalize-space(cbc:Name) = 'Fyllingsgrad'">Property 'Fyllingsgrad' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003126" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Fyllingsgrad'.</assert>
    <assert id="EHF-QII-G1-R003127" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Fyllingsgrad' may be used.</assert>
    <assert id="EHF-QII-G1-R003128" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Fyllingsgrad' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003129" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Fyllingsgrad' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilDetaljist']]">
    <assert id="EHF-QII-G1-R003130" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til detaljist'">Property 'Holdbarhetsdager til detaljist' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003131" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til detaljist' may be used.</assert>
    <assert id="EHF-QII-G1-R003132" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til detaljist' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilDistributor']]">
    <assert id="EHF-QII-G1-R003133" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til distributør'">Property 'Holdbarhetsdager til distributør' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003134" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til distributør' may be used.</assert>
    <assert id="EHF-QII-G1-R003135" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til distributør' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTilProdusent']]">
    <assert id="EHF-QII-G1-R003136" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager til produsent'">Property 'Holdbarhetsdager til produsent' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003137" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager til produsent' may be used.</assert>
    <assert id="EHF-QII-G1-R003138" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager til produsent' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoldbarhetsdagerTotalt']]">
    <assert id="EHF-QII-G1-R003139" flag="fatal" test="normalize-space(cbc:Name) = 'Holdbarhetsdager totalt'">Property 'Holdbarhetsdager totalt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003140" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Holdbarhetsdager totalt' may be used.</assert>
    <assert id="EHF-QII-G1-R003141" flag="fatal" test="normalize-space(cbc:Value)">Property 'Holdbarhetsdager totalt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Informasjonstekst']]">
    <assert id="EHF-QII-G1-R003142" flag="fatal" test="normalize-space(cbc:Name) = 'Informasjonstekst'">Property 'Informasjonstekst' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003143" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Informasjonstekst' may be used.</assert>
    <assert id="EHF-QII-G1-R003144" flag="fatal" test="normalize-space(cbc:Value)">Property 'Informasjonstekst' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003145" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Informasjonstekst' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#InformasjonstekstEngelsk']]">
    <assert id="EHF-QII-G1-R003146" flag="fatal" test="normalize-space(cbc:Name) = 'Informasjonstekst [Engelsk]'">Property 'Informasjonstekst [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003147" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Informasjonstekst [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R003148" flag="fatal" test="normalize-space(cbc:Value)">Property 'Informasjonstekst [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003149" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2000">Property 'Informasjonstekst [Engelsk]' value must have a length of maximum 2000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Legitimasjonskrav']]">
    <assert id="EHF-QII-G1-R003150" flag="fatal" test="normalize-space(cbc:Name) = 'Legitimasjonskrav'">Property 'Legitimasjonskrav' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003151" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Legitimasjonskrav' may be used.</assert>
    <assert id="EHF-QII-G1-R003152" flag="fatal" test="normalize-space(cbc:Value)">Property 'Legitimasjonskrav' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MaksimumstemperaturCelcius']]">
    <assert id="EHF-QII-G1-R003153" flag="fatal" test="normalize-space(cbc:Name) = 'Maksimumstemperatur'">Property 'Maksimumstemperatur' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003154" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Maksimumstemperatur'.</assert>
    <assert id="EHF-QII-G1-R003155" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Maksimumstemperatur' may be used.</assert>
    <assert id="EHF-QII-G1-R003156" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Maksimumstemperatur' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003157" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Maksimumstemperatur' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Mengde']]">
    <assert id="EHF-QII-G1-R003158" flag="fatal" test="normalize-space(cbc:Name) = 'Mengde'">Property 'Mengde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003159" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Mengde'.</assert>
    <assert id="EHF-QII-G1-R003160" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Mengde' may be used.</assert>
    <assert id="EHF-QII-G1-R003161" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Mengde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003162" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Mengde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Mengdetypeenhet']]">
    <assert id="EHF-QII-G1-R003163" flag="fatal" test="normalize-space(cbc:Name) = 'Enhet til mengde'">Property 'Enhet til mengde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003164" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Enhet til mengde' may be used.</assert>
    <assert id="EHF-QII-G1-R003165" flag="fatal" test="normalize-space(cbc:Value)">Property 'Enhet til mengde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MerketMedEgenskaper']]">
    <assert id="EHF-QII-G1-R003166" flag="fatal" test="normalize-space(cbc:Name) = 'Er produktet merket med en eller flere egenskaper?'">Property 'Er produktet merket med en eller flere egenskaper?' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003167" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Er produktet merket med en eller flere egenskaper?' may be used.</assert>
    <assert id="EHF-QII-G1-R003168" flag="fatal" test="normalize-space(cbc:Value)">Property 'Er produktet merket med en eller flere egenskaper?' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MinimumstemperaturCelsius']]">
    <assert id="EHF-QII-G1-R003169" flag="fatal" test="normalize-space(cbc:Name) = 'Minimumstemperatur'">Property 'Minimumstemperatur' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003170" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Minimumstemperatur'.</assert>
    <assert id="EHF-QII-G1-R003171" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Minimumstemperatur' may be used.</assert>
    <assert id="EHF-QII-G1-R003172" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Minimumstemperatur' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003173" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Minimumstemperatur' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MVAKode']]">
    <assert id="EHF-QII-G1-R003174" flag="fatal" test="normalize-space(cbc:Name) = 'Mva sats'">Property 'Mva sats' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003175" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Mva sats' may be used.</assert>
    <assert id="EHF-QII-G1-R003176" flag="fatal" test="normalize-space(cbc:Value)">Property 'Mva sats' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Nettovekt']]">
    <assert id="EHF-QII-G1-R003177" flag="fatal" test="normalize-space(cbc:Name) = 'Nettovekt'">Property 'Nettovekt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003178" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Nettovekt'.</assert>
    <assert id="EHF-QII-G1-R003179" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Nettovekt' may be used.</assert>
    <assert id="EHF-QII-G1-R003180" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Nettovekt' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003181" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Nettovekt' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#OpprinnelseOgOpphav']]">
    <assert id="EHF-QII-G1-R003182" flag="fatal" test="normalize-space(cbc:Name) = 'Opprinnelsesland/Opphavssted hovedingrediens(er)'">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003183" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' may be used.</assert>
    <assert id="EHF-QII-G1-R003184" flag="fatal" test="normalize-space(cbc:Value)">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003185" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 200">Property 'Opprinnelsesland/Opphavssted hovedingrediens(er)' value must have a length of maximum 200 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Produksjonsland']]">
    <assert id="EHF-QII-G1-R003186" flag="fatal" test="normalize-space(cbc:Name) = 'Produksjonsland'">Property 'Produksjonsland' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003187" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produksjonsland' may be used.</assert>
    <assert id="EHF-QII-G1-R003188" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produksjonsland' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProduktmerkingEgenskaper']]">
    <assert id="EHF-QII-G1-R003189" flag="fatal" test="normalize-space(cbc:Name) = 'Produktmerking egenskaper'">Property 'Produktmerking egenskaper' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003190" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produktmerking egenskaper' may be used.</assert>
    <assert id="EHF-QII-G1-R003191" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produktmerking egenskaper' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Stablingsfaktor']]">
    <assert id="EHF-QII-G1-R003192" flag="fatal" test="normalize-space(cbc:Name) = 'Stablingsfaktor'">Property 'Stablingsfaktor' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003193" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Stablingsfaktor'.</assert>
    <assert id="EHF-QII-G1-R003194" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Stablingsfaktor' may be used.</assert>
    <assert id="EHF-QII-G1-R003195" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Stablingsfaktor' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003196" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Stablingsfaktor' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Varemerke']]">
    <assert id="EHF-QII-G1-R003197" flag="fatal" test="normalize-space(cbc:Name) = 'Varemerke'">Property 'Varemerke' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003198" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varemerke' may be used.</assert>
    <assert id="EHF-QII-G1-R003199" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varemerke' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003200" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Varemerke' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AttributtverdiID']]">
    <assert id="EHF-QII-G1-R003201" flag="fatal" test="normalize-space(cbc:Name) = 'Varegruppe attributter'">Property 'Varegruppe attributter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003202" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varegruppe attributter' may be used.</assert>
    <assert id="EHF-QII-G1-R003203" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varegruppe attributter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PakningID']]">
    <assert id="EHF-QII-G1-R003204" flag="fatal" test="normalize-space(cbc:Name) = 'Sertifiseringer'">Property 'Sertifiseringer' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003205" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Sertifiseringer' may be used.</assert>
    <assert id="EHF-QII-G1-R003206" flag="fatal" test="normalize-space(cbc:Value)">Property 'Sertifiseringer' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#VaregruppeID']]">
    <assert id="EHF-QII-G1-R003207" flag="fatal" test="normalize-space(cbc:Name) = 'Varegruppe'">Property 'Varegruppe' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003208" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Varegruppe' may be used.</assert>
    <assert id="EHF-QII-G1-R003209" flag="fatal" test="normalize-space(cbc:Value)">Property 'Varegruppe' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Antall']]">
    <assert id="EHF-QII-G1-R003210" flag="fatal" test="normalize-space(cbc:Name) = 'Antall'">Property 'Antall' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003211" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall' may be used.</assert>
    <assert id="EHF-QII-G1-R003212" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallAvPant']]">
    <assert id="EHF-QII-G1-R003213" flag="fatal" test="normalize-space(cbc:Name) = 'Antall av pant'">Property 'Antall av pant' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003214" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall av pant' may be used.</assert>
    <assert id="EHF-QII-G1-R003215" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall av pant' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriBredden']]">
    <assert id="EHF-QII-G1-R003216" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i bredde'">Property 'Antall basispakninger i bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003217" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R003218" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i bredde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriDybden']]">
    <assert id="EHF-QII-G1-R003219" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i dybde'">Property 'Antall basispakninger i dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003220" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R003221" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i dybde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallBasispakningeriHoyden']]">
    <assert id="EHF-QII-G1-R003222" flag="fatal" test="normalize-space(cbc:Name) = 'Antall basispakninger i høyde'">Property 'Antall basispakninger i høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003223" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall basispakninger i høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R003224" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall basispakninger i høyde' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallLag']]">
    <assert id="EHF-QII-G1-R003225" flag="fatal" test="normalize-space(cbc:Name) = 'Antall lag'">Property 'Antall lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003226" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall lag' may be used.</assert>
    <assert id="EHF-QII-G1-R003227" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall lag' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallPrLag']]">
    <assert id="EHF-QII-G1-R003228" flag="fatal" test="normalize-space(cbc:Name) = 'Antall pr lag'">Property 'Antall pr lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003229" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall pr lag' may be used.</assert>
    <assert id="EHF-QII-G1-R003230" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall pr lag' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AvvikendePakkemonster']]">
    <assert id="EHF-QII-G1-R003231" flag="fatal" test="normalize-space(cbc:Name) = 'Avvikende pakkemønster'">Property 'Avvikende pakkemønster' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003232" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Avvikende pakkemønster' may be used.</assert>
    <assert id="EHF-QII-G1-R003233" flag="fatal" test="normalize-space(cbc:Value)">Property 'Avvikende pakkemønster' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Bredde']]">
    <assert id="EHF-QII-G1-R003234" flag="fatal" test="normalize-space(cbc:Name) = 'Bredde'">Property 'Bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003235" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Bredde'.</assert>
    <assert id="EHF-QII-G1-R003236" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R003237" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Bredde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003238" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Bredde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Bruttovekt']]">
    <assert id="EHF-QII-G1-R003239" flag="fatal" test="normalize-space(cbc:Name) = 'Bruttovekt'">Property 'Bruttovekt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003240" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Bruttovekt'.</assert>
    <assert id="EHF-QII-G1-R003241" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Bruttovekt' may be used.</assert>
    <assert id="EHF-QII-G1-R003242" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Bruttovekt' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003243" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Bruttovekt' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Dybde']]">
    <assert id="EHF-QII-G1-R003244" flag="fatal" test="normalize-space(cbc:Name) = 'Dybde'">Property 'Dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003245" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Dybde'.</assert>
    <assert id="EHF-QII-G1-R003246" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R003247" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Dybde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003248" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Dybde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Egenskaper']]">
    <assert id="EHF-QII-G1-R003249" flag="fatal" test="normalize-space(cbc:Name) = 'Egenskaper'">Property 'Egenskaper' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003250" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Egenskaper' may be used.</assert>
    <assert id="EHF-QII-G1-R003251" flag="fatal" test="normalize-space(cbc:Value)">Property 'Egenskaper' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003252" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Egenskaper' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EgenskaperEngelsk']]">
    <assert id="EHF-QII-G1-R003253" flag="fatal" test="normalize-space(cbc:Name) = 'Egenskaper [Engelsk]'">Property 'Egenskaper [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003254" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Egenskaper [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R003255" flag="fatal" test="normalize-space(cbc:Value)">Property 'Egenskaper [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003256" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 30">Property 'Egenskaper [Engelsk]' value must have a length of maximum 30 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Emballasjekode']]">
    <assert id="EHF-QII-G1-R003257" flag="fatal" test="normalize-space(cbc:Name) = 'Emballasje'">Property 'Emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003258" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R003259" flag="fatal" test="normalize-space(cbc:Value)">Property 'Emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErForbrukerpakning']]">
    <assert id="EHF-QII-G1-R003260" flag="fatal" test="normalize-space(cbc:Name) = 'ErForbrukerpakning'">Property 'ErForbrukerpakning' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003261" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'ErForbrukerpakning' may be used.</assert>
    <assert id="EHF-QII-G1-R003262" flag="fatal" test="normalize-space(cbc:Value)">Property 'ErForbrukerpakning' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#GS1Databaarer']]">
    <assert id="EHF-QII-G1-R003263" flag="fatal" test="normalize-space(cbc:Name) = 'GS1 Databær'">Property 'GS1 Databær' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003264" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'GS1 Databær' may be used.</assert>
    <assert id="EHF-QII-G1-R003265" flag="fatal" test="normalize-space(cbc:Value)">Property 'GS1 Databær' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Hoyde']]">
    <assert id="EHF-QII-G1-R003266" flag="fatal" test="normalize-space(cbc:Name) = 'Høyde'">Property 'Høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003267" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Høyde'.</assert>
    <assert id="EHF-QII-G1-R003268" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R003269" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Høyde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003270" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Høyde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#HoydePrLag']]">
    <assert id="EHF-QII-G1-R003271" flag="fatal" test="normalize-space(cbc:Name) = 'Høyde pr lag'">Property 'Høyde pr lag' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003272" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Høyde pr lag'.</assert>
    <assert id="EHF-QII-G1-R003273" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Høyde pr lag' may be used.</assert>
    <assert id="EHF-QII-G1-R003274" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Høyde pr lag' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003275" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Høyde pr lag' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LastbaererKode']]">
    <assert id="EHF-QII-G1-R003276" flag="fatal" test="normalize-space(cbc:Name) = 'Lastbærer'">Property 'Lastbærer' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003277" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Lastbærer' may be used.</assert>
    <assert id="EHF-QII-G1-R003278" flag="fatal" test="normalize-space(cbc:Value)">Property 'Lastbærer' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Markedsnavn']]">
    <assert id="EHF-QII-G1-R003279" flag="fatal" test="normalize-space(cbc:Name) = 'Fullstendig produktnavn'">Property 'Fullstendig produktnavn' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003280" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Fullstendig produktnavn' may be used.</assert>
    <assert id="EHF-QII-G1-R003281" flag="fatal" test="normalize-space(cbc:Value)">Property 'Fullstendig produktnavn' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003282" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Fullstendig produktnavn' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MarkedsnavnEngelsk']]">
    <assert id="EHF-QII-G1-R003283" flag="fatal" test="normalize-space(cbc:Name) = 'Fullstendig produktnavn [Engelsk]'">Property 'Fullstendig produktnavn [Engelsk]' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003284" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Fullstendig produktnavn [Engelsk]' may be used.</assert>
    <assert id="EHF-QII-G1-R003285" flag="fatal" test="normalize-space(cbc:Value)">Property 'Fullstendig produktnavn [Engelsk]' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003286" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Fullstendig produktnavn [Engelsk]' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MaxTopplast']]">
    <assert id="EHF-QII-G1-R003287" flag="fatal" test="normalize-space(cbc:Name) = 'Max topplast'">Property 'Max topplast' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003288" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Max topplast'.</assert>
    <assert id="EHF-QII-G1-R003289" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Max topplast' may be used.</assert>
    <assert id="EHF-QII-G1-R003290" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Max topplast' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003291" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Max topplast' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PantGTIN']]">
    <assert id="EHF-QII-G1-R003292" flag="fatal" test="normalize-space(cbc:Name) = 'Pant GTIN'">Property 'Pant GTIN' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003293" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Pant GTIN' may be used.</assert>
    <assert id="EHF-QII-G1-R003294" flag="fatal" test="normalize-space(cbc:Value)">Property 'Pant GTIN' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ResirkulerbarEmballasje']]">
    <assert id="EHF-QII-G1-R003295" flag="fatal" test="normalize-space(cbc:Name) = 'Resirkulerbar emballasje'">Property 'Resirkulerbar emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003296" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Resirkulerbar emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R003297" flag="fatal" test="normalize-space(cbc:Value)">Property 'Resirkulerbar emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ReturnerbarEmballasje']]">
    <assert id="EHF-QII-G1-R003298" flag="fatal" test="normalize-space(cbc:Name) = 'Returnerbar emballasje'">Property 'Returnerbar emballasje' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003299" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Returnerbar emballasje' may be used.</assert>
    <assert id="EHF-QII-G1-R003300" flag="fatal" test="normalize-space(cbc:Value)">Property 'Returnerbar emballasje' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SistKontrollmaalt']]">
    <assert id="EHF-QII-G1-R003301" flag="fatal" test="normalize-space(cbc:Name) = 'Sist kontrollmålt'">Property 'Sist kontrollmålt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003302" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Sist kontrollmålt' may be used.</assert>
    <assert id="EHF-QII-G1-R003303" flag="fatal" test="normalize-space(cbc:Value)">Property 'Sist kontrollmålt' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceAvvikerFraLogistikkMaal']]">
    <assert id="EHF-QII-G1-R003304" flag="fatal" test="normalize-space(cbc:Name) = 'Avviker logistikkmål fra hyllemål'">Property 'Avviker logistikkmål fra hyllemål' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003305" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Avviker logistikkmål fra hyllemål' may be used.</assert>
    <assert id="EHF-QII-G1-R003306" flag="fatal" test="normalize-space(cbc:Value)">Property 'Avviker logistikkmål fra hyllemål' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceBredde']]">
    <assert id="EHF-QII-G1-R003307" flag="fatal" test="normalize-space(cbc:Name) = 'Space bredde'">Property 'Space bredde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003308" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space bredde'.</assert>
    <assert id="EHF-QII-G1-R003309" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space bredde' may be used.</assert>
    <assert id="EHF-QII-G1-R003310" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space bredde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003311" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space bredde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceDybde']]">
    <assert id="EHF-QII-G1-R003312" flag="fatal" test="normalize-space(cbc:Name) = 'Space dybde'">Property 'Space dybde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003313" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space dybde'.</assert>
    <assert id="EHF-QII-G1-R003314" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space dybde' may be used.</assert>
    <assert id="EHF-QII-G1-R003315" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space dybde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003316" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space dybde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#SpaceHoyde']]">
    <assert id="EHF-QII-G1-R003317" flag="fatal" test="normalize-space(cbc:Name) = 'Space høyde'">Property 'Space høyde' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003318" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Space høyde'.</assert>
    <assert id="EHF-QII-G1-R003319" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Space høyde' may be used.</assert>
    <assert id="EHF-QII-G1-R003320" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Space høyde' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003321" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Space høyde' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#TotaltAntall']]">
    <assert id="EHF-QII-G1-R003322" flag="fatal" test="normalize-space(cbc:Name) = 'Totalt antall'">Property 'Totalt antall' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003323" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Totalt antall' may be used.</assert>
    <assert id="EHF-QII-G1-R003324" flag="fatal" test="normalize-space(cbc:Value)">Property 'Totalt antall' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PantEPDnr']]">
    <assert id="EHF-QII-G1-R003325" flag="fatal" test="normalize-space(cbc:Name) = 'Pant EPDnr'">Property 'Pant EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003326" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Pant EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R003327" flag="fatal" test="normalize-space(cbc:Value)">Property 'Pant EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#EPDnr']]">
    <assert id="EHF-QII-G1-R003328" flag="fatal" test="normalize-space(cbc:Name) = 'EPDnr'">Property 'EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003329" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R003330" flag="fatal" test="normalize-space(cbc:Value)">Property 'EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErstattetAvProduktID']]">
    <assert id="EHF-QII-G1-R003331" flag="fatal" test="normalize-space(cbc:Name) = 'Erstattet av EPDnr'">Property 'Erstattet av EPDnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003332" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Erstattet av EPDnr' may be used.</assert>
    <assert id="EHF-QII-G1-R003333" flag="fatal" test="normalize-space(cbc:Value)">Property 'Erstattet av EPDnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#LeverandorVarenr']]">
    <assert id="EHF-QII-G1-R003334" flag="fatal" test="normalize-space(cbc:Name) = 'Leverandør varenr'">Property 'Leverandør varenr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003335" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Leverandør varenr' may be used.</assert>
    <assert id="EHF-QII-G1-R003336" flag="fatal" test="normalize-space(cbc:Value)">Property 'Leverandør varenr' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003337" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Leverandør varenr' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#MottakerTilgang']]">
    <assert id="EHF-QII-G1-R003338" flag="fatal" test="normalize-space(cbc:Name) = 'Mottaker tilgang'">Property 'Mottaker tilgang' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003339" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Mottaker tilgang' may be used.</assert>
    <assert id="EHF-QII-G1-R003340" flag="fatal" test="normalize-space(cbc:Value)">Property 'Mottaker tilgang' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003341" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Mottaker tilgang' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProdusentVarenr']]">
    <assert id="EHF-QII-G1-R003342" flag="fatal" test="normalize-space(cbc:Name) = 'Produsent varenr'">Property 'Produsent varenr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003343" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produsent varenr' may be used.</assert>
    <assert id="EHF-QII-G1-R003344" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produsent varenr' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003345" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 50">Property 'Produsent varenr' value must have a length of maximum 50 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#TilgjengeligFraDato']]">
    <assert id="EHF-QII-G1-R003346" flag="fatal" test="normalize-space(cbc:Name) = 'Tilgjengelig fra dato'">Property 'Tilgjengelig fra dato' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003347" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Tilgjengelig fra dato' may be used.</assert>
    <assert id="EHF-QII-G1-R003348" flag="fatal" test="normalize-space(cbc:Value)">Property 'Tilgjengelig fra dato' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ProduktID']]">
    <assert id="EHF-QII-G1-R003349" flag="fatal" test="normalize-space(cbc:Name) = 'Hentesteder'">Property 'Hentesteder' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003350" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Hentesteder' may be used.</assert>
    <assert id="EHF-QII-G1-R003351" flag="fatal" test="normalize-space(cbc:Value)">Property 'Hentesteder' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErBestillbar']]">
    <assert id="EHF-QII-G1-R003352" flag="fatal" test="normalize-space(cbc:Name) = 'Bestillbar'">Property 'Bestillbar' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003353" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Bestillbar' may be used.</assert>
    <assert id="EHF-QII-G1-R003354" flag="fatal" test="normalize-space(cbc:Value)">Property 'Bestillbar' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Allergierklaring']]">
    <assert id="EHF-QII-G1-R003355" flag="fatal" test="normalize-space(cbc:Name) = 'Allergierklæring'">Property 'Allergierklæring' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003356" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Allergierklæring' may be used.</assert>
    <assert id="EHF-QII-G1-R003357" flag="fatal" test="normalize-space(cbc:Value)">Property 'Allergierklæring' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003358" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2560">Property 'Allergierklæring' value must have a length of maximum 2560 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#AntallUmerkedeEnheter']]">
    <assert id="EHF-QII-G1-R003359" flag="fatal" test="normalize-space(cbc:Name) = 'Antall umerkede enheter'">Property 'Antall umerkede enheter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003360" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Antall umerkede enheter' may be used.</assert>
    <assert id="EHF-QII-G1-R003361" flag="fatal" test="normalize-space(cbc:Value)">Property 'Antall umerkede enheter' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#ErnaringsmessigePastander']]">
    <assert id="EHF-QII-G1-R003362" flag="fatal" test="normalize-space(cbc:Name) = 'Ernæringsmessige påstander'">Property 'Ernæringsmessige påstander' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003363" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Ernæringsmessige påstander' may be used.</assert>
    <assert id="EHF-QII-G1-R003364" flag="fatal" test="normalize-space(cbc:Value)">Property 'Ernæringsmessige påstander' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003365" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2560">Property 'Ernæringsmessige påstander' value must have a length of maximum 2560 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Ingredienser']]">
    <assert id="EHF-QII-G1-R003366" flag="fatal" test="normalize-space(cbc:Name) = 'Ingredienser'">Property 'Ingredienser' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003367" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Ingredienser' may be used.</assert>
    <assert id="EHF-QII-G1-R003368" flag="fatal" test="normalize-space(cbc:Value)">Property 'Ingredienser' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003369" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 2560">Property 'Ingredienser' value must have a length of maximum 2560 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Umerketvariantbeskrivelse']]">
    <assert id="EHF-QII-G1-R003370" flag="fatal" test="normalize-space(cbc:Name) = 'Umerketvariantbeskrivelse'">Property 'Umerketvariantbeskrivelse' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003371" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Umerketvariantbeskrivelse' may be used.</assert>
    <assert id="EHF-QII-G1-R003372" flag="fatal" test="normalize-space(cbc:Value)">Property 'Umerketvariantbeskrivelse' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003373" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 250">Property 'Umerketvariantbeskrivelse' value must have a length of maximum 250 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Umerketvariantnr']]">
    <assert id="EHF-QII-G1-R003374" flag="fatal" test="normalize-space(cbc:Name) = 'Umerketvariantnr'">Property 'Umerketvariantnr' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003375" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Umerketvariantnr' may be used.</assert>
    <assert id="EHF-QII-G1-R003376" flag="fatal" test="normalize-space(cbc:Value)">Property 'Umerketvariantnr' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Aargang']]">
    <assert id="EHF-QII-G1-R003377" flag="fatal" test="normalize-space(cbc:Name) = 'Årgang'">Property 'Årgang' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003378" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Årgang' may be used.</assert>
    <assert id="EHF-QII-G1-R003379" flag="fatal" test="normalize-space(cbc:Value)">Property 'Årgang' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Apellasjon']]">
    <assert id="EHF-QII-G1-R003380" flag="fatal" test="normalize-space(cbc:Name) = 'Apellasjon'">Property 'Apellasjon' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003381" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Apellasjon' may be used.</assert>
    <assert id="EHF-QII-G1-R003382" flag="fatal" test="normalize-space(cbc:Value)">Property 'Apellasjon' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003383" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 200">Property 'Apellasjon' value must have a length of maximum 200 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Farge']]">
    <assert id="EHF-QII-G1-R003384" flag="fatal" test="normalize-space(cbc:Name) = 'Farge'">Property 'Farge' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003385" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Farge' may be used.</assert>
    <assert id="EHF-QII-G1-R003386" flag="fatal" test="normalize-space(cbc:Value)">Property 'Farge' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003387" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 1000">Property 'Farge' value must have a length of maximum 1000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#GramSukkerPrLiter']]">
    <assert id="EHF-QII-G1-R003388" flag="fatal" test="normalize-space(cbc:Name) = 'Gram sukker pr liter'">Property 'Gram sukker pr liter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003389" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Gram sukker pr liter'.</assert>
    <assert id="EHF-QII-G1-R003390" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Gram sukker pr liter' may be used.</assert>
    <assert id="EHF-QII-G1-R003391" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Gram sukker pr liter' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003392" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Gram sukker pr liter' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#GramSyrePrLiter']]">
    <assert id="EHF-QII-G1-R003393" flag="fatal" test="normalize-space(cbc:Name) = 'Gram syrepr liter'">Property 'Gram syrepr liter' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003394" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Gram syrepr liter'.</assert>
    <assert id="EHF-QII-G1-R003395" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Gram syrepr liter' may be used.</assert>
    <assert id="EHF-QII-G1-R003396" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Gram syrepr liter' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003397" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Gram syrepr liter' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Karakteristikk']]">
    <assert id="EHF-QII-G1-R003398" flag="fatal" test="normalize-space(cbc:Name) = 'Karakteristikk'">Property 'Karakteristikk' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003399" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Karakteristikk' may be used.</assert>
    <assert id="EHF-QII-G1-R003400" flag="fatal" test="normalize-space(cbc:Value)">Property 'Karakteristikk' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003401" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 1000">Property 'Karakteristikk' value must have a length of maximum 1000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Kvalitetsbetegnelse']]">
    <assert id="EHF-QII-G1-R003402" flag="fatal" test="normalize-space(cbc:Name) = 'Kvalitetsbetegnelse'">Property 'Kvalitetsbetegnelse' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003403" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Kvalitetsbetegnelse' may be used.</assert>
    <assert id="EHF-QII-G1-R003404" flag="fatal" test="normalize-space(cbc:Value)">Property 'Kvalitetsbetegnelse' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003405" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 200">Property 'Kvalitetsbetegnelse' value must have a length of maximum 200 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Lukt']]">
    <assert id="EHF-QII-G1-R003406" flag="fatal" test="normalize-space(cbc:Name) = 'Lukt'">Property 'Lukt' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003407" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Lukt' may be used.</assert>
    <assert id="EHF-QII-G1-R003408" flag="fatal" test="normalize-space(cbc:Value)">Property 'Lukt' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003409" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 1000">Property 'Lukt' value must have a length of maximum 1000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Metode']]">
    <assert id="EHF-QII-G1-R003410" flag="fatal" test="normalize-space(cbc:Name) = 'Metode'">Property 'Metode' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003411" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Metode' may be used.</assert>
    <assert id="EHF-QII-G1-R003412" flag="fatal" test="normalize-space(cbc:Value)">Property 'Metode' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003413" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 1000">Property 'Metode' value must have a length of maximum 1000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#PasserTil']]">
    <assert id="EHF-QII-G1-R003414" flag="fatal" test="normalize-space(cbc:Name) = 'Passer til'">Property 'Passer til' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003415" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Passer til' may be used.</assert>
    <assert id="EHF-QII-G1-R003416" flag="fatal" test="normalize-space(cbc:Value)">Property 'Passer til' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003417" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 1000">Property 'Passer til' value must have a length of maximum 1000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Polnummer']]">
    <assert id="EHF-QII-G1-R003418" flag="fatal" test="normalize-space(cbc:Name) = 'Vinpolnummer'">Property 'Vinpolnummer' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003419" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Vinpolnummer' may be used.</assert>
    <assert id="EHF-QII-G1-R003420" flag="fatal" test="normalize-space(cbc:Value)">Property 'Vinpolnummer' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003421" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 20">Property 'Vinpolnummer' value must have a length of maximum 20 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Produsentnavn']]">
    <assert id="EHF-QII-G1-R003422" flag="fatal" test="normalize-space(cbc:Name) = 'Produsentnavn'">Property 'Produsentnavn' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003423" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Produsentnavn' may be used.</assert>
    <assert id="EHF-QII-G1-R003424" flag="fatal" test="normalize-space(cbc:Value)">Property 'Produsentnavn' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003425" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 100">Property 'Produsentnavn' value must have a length of maximum 100 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Raastoff']]">
    <assert id="EHF-QII-G1-R003426" flag="fatal" test="normalize-space(cbc:Name) = 'Råstoff'">Property 'Råstoff' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003427" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Råstoff' may be used.</assert>
    <assert id="EHF-QII-G1-R003428" flag="fatal" test="normalize-space(cbc:Value)">Property 'Råstoff' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003429" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 1000">Property 'Råstoff' value must have a length of maximum 1000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Smak']]">
    <assert id="EHF-QII-G1-R003430" flag="fatal" test="normalize-space(cbc:Name) = 'Smak'">Property 'Smak' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003431" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Smak' may be used.</assert>
    <assert id="EHF-QII-G1-R003432" flag="fatal" test="normalize-space(cbc:Value)">Property 'Smak' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003433" flag="fatal" test="not(normalize-space(cbc:Value)) or string-length(normalize-space(cbc:Value)) &lt;= 1000">Property 'Smak' value must have a length of maximum 1000 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#Vinkartongantall']]">
    <assert id="EHF-QII-G1-R003434" flag="fatal" test="normalize-space(cbc:Name) = 'Vinkartong antall'">Property 'Vinkartong antall' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003435" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Vinkartong antall' may be used.</assert>
    <assert id="EHF-QII-G1-R003436" flag="fatal" test="normalize-space(cbc:Value)">Property 'Vinkartong antall' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#VinSpritEmballasjetypeKode']]">
    <assert id="EHF-QII-G1-R003437" flag="fatal" test="normalize-space(cbc:Name) = 'Emballasje (vin/sprit)'">Property 'Emballasje (vin/sprit)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003438" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Emballasje (vin/sprit)' may be used.</assert>
    <assert id="EHF-QII-G1-R003439" flag="fatal" test="normalize-space(cbc:Value)">Property 'Emballasje (vin/sprit)' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#VinSpritKorktypeKode']]">
    <assert id="EHF-QII-G1-R003440" flag="fatal" test="normalize-space(cbc:Name) = 'Korktype'">Property 'Korktype' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003441" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Korktype' may be used.</assert>
    <assert id="EHF-QII-G1-R003442" flag="fatal" test="normalize-space(cbc:Value)">Property 'Korktype' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#VinSpritLagringsgradKode']]">
    <assert id="EHF-QII-G1-R003443" flag="fatal" test="normalize-space(cbc:Name) = 'Lagringsgrad'">Property 'Lagringsgrad' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003444" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:Value[1])">Only allowed elements for property 'Lagringsgrad' may be used.</assert>
    <assert id="EHF-QII-G1-R003445" flag="fatal" test="normalize-space(cbc:Value)">Property 'Lagringsgrad' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.energi_kcal_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R003446" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Energi kcal pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Energi kcal pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003447" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Energi kcal pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003448" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Energi kcal pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003449" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Energi kcal pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003450" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Energi kcal pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.energi_kj_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R003451" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Energi kj pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Energi kj pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003452" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Energi kj pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003453" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Energi kj pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003454" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Energi kj pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003455" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Energi kj pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.fett_totalt_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R003456" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Fett (totalt) pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Fett (totalt) pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003457" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Fett (totalt) pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003458" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Fett (totalt) pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003459" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Fett (totalt) pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003460" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Fett (totalt) pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.karbohydrater_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R003461" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Karbohydrater pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Karbohydrater pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003462" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Karbohydrater pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003463" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Karbohydrater pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003464" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Karbohydrater pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003465" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Karbohydrater pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.mettede_fettsyrer_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R003466" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003467" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003468" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003469" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003470" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Mettede fettsyrer pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.protein_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R003471" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Protein pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Protein pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003472" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Protein pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003473" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Protein pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003474" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Protein pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003475" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Protein pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.salt_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R003476" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Salt pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Salt pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003477" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Salt pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003478" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Salt pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003479" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Salt pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003480" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Salt pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.sukkerarter_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R003481" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Sukkerarter pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Sukkerarter pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003482" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Sukkerarter pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003483" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Sukkerarter pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003484" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Sukkerarter pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003485" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Sukkerarter pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.bitoin_mikrogr']]">
    <assert id="EHF-QII-G1-R003486" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Biotin (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Biotin (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003487" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Biotin (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003488" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Biotin (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003489" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Biotin (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003490" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Biotin (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.fluorid_mg']]">
    <assert id="EHF-QII-G1-R003491" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Fluorid (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Fluorid (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003492" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Fluorid (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003493" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Fluorid (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003494" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Fluorid (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003495" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Fluorid (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.fosfor_mg']]">
    <assert id="EHF-QII-G1-R003496" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Fosfor (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Fosfor (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003497" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Fosfor (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003498" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Fosfor (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003499" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Fosfor (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003500" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Fosfor (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.jern_mg']]">
    <assert id="EHF-QII-G1-R003501" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Jern (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Jern (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003502" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Jern (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003503" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Jern (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003504" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Jern (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003505" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Jern (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.jod_mikrogr']]">
    <assert id="EHF-QII-G1-R003506" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Jod (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Jod (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003507" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Jod (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003508" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Jod (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003509" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Jod (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003510" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Jod (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.kalium_mg']]">
    <assert id="EHF-QII-G1-R003511" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kalium (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Kalium (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003512" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kalium (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003513" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kalium (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003514" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kalium (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003515" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kalium (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.kalsium_mg']]">
    <assert id="EHF-QII-G1-R003516" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kalsium (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Kalsium (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003517" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kalsium (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003518" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kalsium (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003519" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kalsium (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003520" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kalsium (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.klorid_mg']]">
    <assert id="EHF-QII-G1-R003521" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Klorid (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Klorid (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003522" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Klorid (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003523" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Klorid (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003524" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Klorid (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003525" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Klorid (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.kobber_mg']]">
    <assert id="EHF-QII-G1-R003526" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kobber (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Kobber (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003527" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kobber (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003528" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kobber (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003529" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kobber (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003530" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kobber (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.krom_mikrogr']]">
    <assert id="EHF-QII-G1-R003531" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Krom (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Krom (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003532" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Krom (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003533" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Krom (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003534" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Krom (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003535" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Krom (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.magnesium_mg']]">
    <assert id="EHF-QII-G1-R003536" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Magnesium (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Magnesium (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003537" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Magnesium (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003538" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Magnesium (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003539" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Magnesium (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003540" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Magnesium (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.mangan_mg']]">
    <assert id="EHF-QII-G1-R003541" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Mangan (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Mangan (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003542" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Mangan (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003543" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Mangan (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003544" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Mangan (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003545" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Mangan (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.molybden_mikrogr']]">
    <assert id="EHF-QII-G1-R003546" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Molybden (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Molybden (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003547" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Molybden (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003548" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Molybden (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003549" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Molybden (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003550" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Molybden (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.niacin_mg']]">
    <assert id="EHF-QII-G1-R003551" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Niacin (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Niacin (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003552" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Niacin (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003553" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Niacin (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003554" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Niacin (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003555" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Niacin (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.pantotensyre_mg']]">
    <assert id="EHF-QII-G1-R003556" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Pantotensyre (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Pantotensyre (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003557" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Pantotensyre (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003558" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Pantotensyre (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003559" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Pantotensyre (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003560" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Pantotensyre (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_bitoin']]">
    <assert id="EHF-QII-G1-R003561" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003562" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003563" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003564" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003565" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Biotin (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_fluorid']]">
    <assert id="EHF-QII-G1-R003566" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003567" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003568" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003569" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003570" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Fluorid (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_folinsyre']]">
    <assert id="EHF-QII-G1-R003571" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003572" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003573" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003574" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003575" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Folinsyre (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_fosfor']]">
    <assert id="EHF-QII-G1-R003576" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003577" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003578" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003579" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003580" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Fosfor (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_jern']]">
    <assert id="EHF-QII-G1-R003581" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Jern (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Jern (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003582" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Jern (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003583" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Jern (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003584" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Jern (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003585" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Jern (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_jod']]">
    <assert id="EHF-QII-G1-R003586" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Jod (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Jod (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003587" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Jod (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003588" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Jod (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003589" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Jod (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003590" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Jod (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_kalium']]">
    <assert id="EHF-QII-G1-R003591" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003592" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003593" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003594" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003595" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kalium (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_kalsium']]">
    <assert id="EHF-QII-G1-R003596" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003597" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003598" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003599" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003600" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kalsium (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_klorid']]">
    <assert id="EHF-QII-G1-R003601" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003602" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003603" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003604" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003605" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Klorid (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_kobber']]">
    <assert id="EHF-QII-G1-R003606" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003607" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003608" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003609" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003610" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kobber (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_krom']]">
    <assert id="EHF-QII-G1-R003611" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Krom (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Krom (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003612" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Krom (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003613" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Krom (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003614" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Krom (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003615" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Krom (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_magnesium']]">
    <assert id="EHF-QII-G1-R003616" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003617" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003618" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003619" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003620" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Magnesium (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_mangan']]">
    <assert id="EHF-QII-G1-R003621" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003622" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003623" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003624" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003625" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Mangan (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_molybden']]">
    <assert id="EHF-QII-G1-R003626" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003627" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003628" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003629" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003630" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Molybden (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_niacin']]">
    <assert id="EHF-QII-G1-R003631" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003632" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003633" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003634" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003635" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Niacin (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_pantotensyre']]">
    <assert id="EHF-QII-G1-R003636" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003637" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003638" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003639" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003640" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Pantotensyre (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_riboflavin']]">
    <assert id="EHF-QII-G1-R003641" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003642" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003643" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003644" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003645" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Riboflavin (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_selen']]">
    <assert id="EHF-QII-G1-R003646" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Selen (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Selen (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003647" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Selen (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003648" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Selen (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003649" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Selen (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003650" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Selen (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_sink']]">
    <assert id="EHF-QII-G1-R003651" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Sink (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Sink (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003652" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Sink (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003653" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Sink (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003654" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Sink (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003655" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Sink (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_tiamin']]">
    <assert id="EHF-QII-G1-R003656" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003657" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003658" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003659" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003660" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Tiamin (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_a']]">
    <assert id="EHF-QII-G1-R003661" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003662" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003663" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003664" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003665" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin A (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_b12']]">
    <assert id="EHF-QII-G1-R003666" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003667" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003668" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003669" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003670" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin B12 (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_b6']]">
    <assert id="EHF-QII-G1-R003671" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003672" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003673" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003674" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003675" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin B6 (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_c']]">
    <assert id="EHF-QII-G1-R003676" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003677" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003678" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003679" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003680" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin C (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_d']]">
    <assert id="EHF-QII-G1-R003681" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003682" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003683" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003684" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003685" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin D (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_e']]">
    <assert id="EHF-QII-G1-R003686" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003687" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003688" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003689" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003690" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin E (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.prosentandel_vitamin_k']]">
    <assert id="EHF-QII-G1-R003691" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak) (næringsinnhold)'">Property 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak) (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003692" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak) (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003693" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak) (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003694" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak) (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003695" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin K (prosentandel daglig referanseinntak) (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.riboflavin_mg']]">
    <assert id="EHF-QII-G1-R003696" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Riboflavin (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Riboflavin (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003697" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Riboflavin (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003698" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Riboflavin (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003699" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Riboflavin (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003700" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Riboflavin (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.selen_mikrogr']]">
    <assert id="EHF-QII-G1-R003701" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Selen (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Selen (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003702" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Selen (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003703" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Selen (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003704" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Selen (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003705" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Selen (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.sink_mg']]">
    <assert id="EHF-QII-G1-R003706" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Sink (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Sink (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003707" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Sink (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003708" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Sink (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003709" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Sink (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003710" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Sink (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.tiamin_mg']]">
    <assert id="EHF-QII-G1-R003711" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Tiamin (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Tiamin (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003712" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Tiamin (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003713" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Tiamin (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003714" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Tiamin (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003715" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Tiamin (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_a_mikrogr']]">
    <assert id="EHF-QII-G1-R003716" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin A (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Vitamin A (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003717" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin A (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003718" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin A (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003719" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin A (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003720" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin A (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_b12_mikrogr']]">
    <assert id="EHF-QII-G1-R003721" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003722" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003723" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003724" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003725" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin B12 (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_b6_mg']]">
    <assert id="EHF-QII-G1-R003726" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin B6 (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Vitamin B6 (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003727" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin B6 (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003728" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin B6 (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003729" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin B6 (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003730" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin B6 (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_c_mikrogr']]">
    <assert id="EHF-QII-G1-R003731" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin C  (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Vitamin C  (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003732" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin C  (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003733" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin C  (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003734" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin C  (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003735" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin C  (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_d_mikrogr']]">
    <assert id="EHF-QII-G1-R003736" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin D (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Vitamin D (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003737" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin D (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003738" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin D (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003739" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin D (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003740" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin D (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_e_mg']]">
    <assert id="EHF-QII-G1-R003741" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin E  (mg) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Vitamin E  (mg) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003742" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin E  (mg) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003743" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin E  (mg) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003744" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin E  (mg) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003745" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin E  (mg) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.vitamin_k_mikrogr']]">
    <assert id="EHF-QII-G1-R003746" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Vitamin K (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Vitamin K (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003747" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Vitamin K (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003748" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Vitamin K (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003749" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Vitamin K (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003750" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Vitamin K (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.enummettede_fettsyrer_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R003751" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003752" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003753" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003754" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003755" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Enumettede fettsyrer pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.flerumettede_fettsyrer_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R003756" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003757" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003758" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003759" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003760" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Flerumettede fettsyrer pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.polyoler_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R003761" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Polyoler pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Polyoler pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003762" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Polyoler pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003763" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Polyoler pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003764" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Polyoler pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003765" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Polyoler pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.stivelse_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R003766" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Stivelse pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Stivelse pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003767" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Stivelse pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003768" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Stivelse pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003769" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Stivelse pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003770" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Stivelse pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.kostfibre_pr_100gr_ml']]">
    <assert id="EHF-QII-G1-R003771" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Kostfiber pr 100 g/ml (næringsinnhold)'">Property 'Næringsinnhold, Kostfiber pr 100 g/ml (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003772" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Kostfiber pr 100 g/ml (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003773" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Kostfiber pr 100 g/ml (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003774" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Kostfiber pr 100 g/ml (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003775" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Kostfiber pr 100 g/ml (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:item:dagligvare:vin_brennevin_sterkol']]/cac:AdditionalItemProperty[cbc:NameCode[@listID = 'urn:fdc:anskaffelser.no:2022:ehf:qii:property'][normalize-space() = '#NaeringsinnholdListe.folinsyre_mikrogr']]">
    <assert id="EHF-QII-G1-R003776" flag="fatal" test="normalize-space(cbc:Name) = 'Næringsinnhold, Folinsyre (mikrogram) pr 100g (næringsinnhold)'">Property 'Næringsinnhold, Folinsyre (mikrogram) pr 100g (næringsinnhold)' has wrong name.</assert>
    <assert id="EHF-QII-G1-R003777" flag="fatal" test="cbc:ValueQuantity/@unitCode = ('')">Unit code must be according to allowed unit codes for property 'Næringsinnhold, Folinsyre (mikrogram) pr 100g (næringsinnhold)'.</assert>
    <assert id="EHF-QII-G1-R003778" flag="fatal" test="count(*) = count(cbc:Name[1] | cbc:NameCode[1] | cbc:ValueQuantity[1])">Only allowed elements for property 'Næringsinnhold, Folinsyre (mikrogram) pr 100g (næringsinnhold)' may be used.</assert>
    <assert id="EHF-QII-G1-R003779" flag="fatal" test="normalize-space(cbc:ValueQuantity)">Property 'Næringsinnhold, Folinsyre (mikrogram) pr 100g (næringsinnhold)' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003780" flag="fatal" test="not(normalize-space(cbc:ValueQuantity)) or (normalize-space(cbc:ValueQuantity) castable as xs:decimal)">Property 'Næringsinnhold, Folinsyre (mikrogram) pr 100g (næringsinnhold)' value must be a valid numeric value.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:service']]">
    <assert id="EHF-QII-G1-R003781" flag="fatal" test="cbc:Name">Property 'Name' is mandatory.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:service']]/cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:service']"/>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:service']]/cbc:Name">
    <assert id="EHF-QII-G1-R003782" flag="fatal" test="normalize-space()">Property 'Name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003783" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:service']]/cbc:Description">
    <assert id="EHF-QII-G1-R003784" flag="fatal" test="normalize-space()">Property 'Description' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:service']]/cbc:Keyword">
    <assert id="EHF-QII-G1-R003785" flag="fatal" test="normalize-space()">Property 'Keywords' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:service']]/cbc:BrandName">
    <assert id="EHF-QII-G1-R003786" flag="fatal" test="normalize-space()">Property 'Brand name' can not be empty.</assert>
    <assert id="EHF-QII-G1-R003787" flag="fatal" test="not(normalize-space()) or string-length(normalize-space()) &lt;= 300">Property 'Brand name' value must have a length of maximum 300 characters.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:service']]/cac:BuyersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R003788" flag="fatal" test="normalize-space()">Property 'Buyers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:service']]/cac:SellersItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R003789" flag="fatal" test="normalize-space()">Property 'Sellers item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:service']]/cac:StandardItemIdentification/cbc:ID">
    <assert id="EHF-QII-G1-R003790" flag="fatal" test="normalize-space()">Property 'Standard item identification' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:service']]/cac:CommodityClassification/cbc:ItemClassificationCode">
    <assert id="EHF-QII-G1-R003791" flag="fatal" test="normalize-space()">Property 'Classification code' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][normalize-space() = 'urn:fdc:anskaffelser.no:2022:ehf:qii:service']]/cac:OriginCountry/cbc:IdentificationCode">
    <assert id="EHF-QII-G1-R003792" flag="fatal" test="normalize-space()">Property 'Origin country' can not be empty.</assert>
  </rule>
  <rule context="ubl:Catalogue/cac:CatalogueLine/cac:Item[cac:CommodityClassification/cbc:ItemClassificationCode[@listID = 'ZZZ'][starts-with(normalize-space(), 'urn:fdc:anskaffelser.no:2022:ehf:qii')]]">
    <assert id="EHF-QII-G1-R003793" flag="fatal" test="false()">Invalid classification identifier mimicking EHF Qualified Item Information G1 found.</assert>
  </rule>
</pattern>

</schema>